-- Global Variables

TrinityDockFrames = 15;
TrinityMaxDockShapes = 7;
TrinityKeyBindButton = 0;
TrinityKeyBindSpell = nil;
TrinityButtonStyle = 1;
TrinitySelfCastOption = 1;

TrinityFirstRun = true;
TrinityDockBarsHide = false;
TrinityButtonsHide = false;
TrinityDockingUpdated = false;
TrinityBindingsUpdated = false;
TrinityPlayerEnteredWorld = false;
TrinityVariablesLoaded = false;
TrinityCombatLockdown = false;
TrinityDockLockdown = false;
TrinityButtonLock = false;
TrinityProwlBarActive = false;
TrinityKeyBindingTextHidden = false;
TrinityShowButtonTooltips = true;
TrinityDocksStowed = false;
TrinityCoolDown = false;
TrinityChangeBarTypes = false;

TrinitySavedVersion = "unknown"
TrinityCurrentVersion = "20000.20.2.beta"

TrinitySpellBindings = {};
TrinityButtonsSavedState = {};
TrinityButtonsSavedState2 = {};
TrinityForms = {}
TrinityButtonsButtonLoc = { 12.63545630201, -121.64504791763 };
TrinityMiscBars = {
	["menu"] = 0,
	["bags"] = 0,
	["pet"] = 0,
	["form"] = 0,
	["cast"] = 0,
}
TrinityTargets = {
	[1] = "none",
	[2] = "player",
	[3] = "pet",
	[4] = "target",
	[5] = "targettarget",
	[6] = "focus",
	[7] = "mouseover",	
	[8] = "party1",
	[9] = "partypet1",
	[10] = "party2",
	[11] = "partypet2",
	[12] = "party3",
	[13] = "partypet3",
	[14] = "party4",
	[15] = "partypet4",
	
}

TrinityDebug = {}

TrinityCount = 1;

-- Main on load funtion, creates frames and initializes them
function TrinityButtons_OnLoad()	

	MainMenuBar:Hide();
	
	local stanceFrame = CreateFrame("Frame", "TrinityStanceButtons", UIParent, "SecureStateDriverTemplate");
		stanceFrame:SetAttribute("statemap-stance", "$input");		
		stanceFrame:SetAttribute("statebindings","0:zero;1:one;2:two;3:three;4:four;5:five;6:six;7:seven;8:eight;9:nine");						
		
	local pagedFrame = CreateFrame("Frame", "TrinityPagedButtons", UIParent, "SecureStateDriverTemplate");		
		pagedFrame:SetAttribute("statemap-actionbar", "$input");
		pagedFrame:SetAttribute("statebindings","0:zero;1:one;2:two;3:three;4:four;5:five;6:six;7:seven;8:eight;9:nine");	
		
	local hybridPagedFrame = CreateFrame("Frame", "TrinityHybridPagedButtons", UIParent, "SecureStateDriverTemplate");		
		hybridPagedFrame:SetAttribute("statemap-actionbar", "$input");
		hybridPagedFrame:SetAttribute("statebindings","0:zero;1:one;2:two;3:three;4:four;5:five;6:six;7:seven;8:eight;9:nine");					
		
	local hybridStanceFrame = CreateFrame("Frame", "TrinityHybridStanceButtons", UIParent, "SecureStateDriverTemplate");
		hybridStanceFrame:SetAttribute("statemap-stance", "$input");		
		hybridStanceFrame:SetAttribute("statebindings","0:zero;1:one;2:two;3:three;4:four;5:five;6:six;7:seven;8:eight;9:nine");			
		hybridPagedFrame:SetAttribute("addchild", hybridStanceFrame);
		hybridStanceFrame:SetAttribute("showstates", "1");		
		
	local normalFrame = CreateFrame("Frame", "TrinityNormalButtons", UIParent, "SecureStateDriverTemplate");
		normalFrame:SetAttribute("statemap", "0:=");
		normalFrame:SetAttribute("statebindings","0:zero;1:one;2:two;3:three;4:four;5:five;6:six;7:seven;8:eight;9:nine");	
		
	local stowageFrame = CreateFrame("Frame", "TrinityStowedButtons", UIParent, "SecureStateDriverTemplate");
		stowageFrame:SetPoint("BOTTOM", 0, -100);
		stowageFrame:SetAttribute("state", "99");
		TrinityStowedButtons.buttonIndex = {}
		for i=1,155 do
			TrinityStowedButtons.buttonIndex[i] = 0;
		end
		TrinityStowedButtons.buttonCount = 0;	
		TrinityStowedButtons.buttonList = {};	
		
	TrinityFirstRun = true;
end

function TrinitySpellBinder_OnLoad()

	local posCount = 5
	local negCount = 0;
	for i=1,12 do
		local bindFrame = CreateFrame("Button", "TrinitySpellBinderButton"..i, getglobal("SpellButton"..i), "TrinitySpellBinderTemplate");				
		if (mod(i,2) == 0) then
			bindFrame:SetID(i+posCount);
			posCount = posCount - 1;			
		else
			bindFrame:SetID(i+negCount);
			 negCount = negCount - 1;			
		end		
		bindFrame:SetPoint("TOPLEFT", getglobal("SpellButton"..i), "TOPLEFT", 0 ,0);
		bindFrame:SetPoint("BOTTOMRIGHT", getglobal("SpellButton"..i), "BOTTOMRIGHT", 0 ,0);
		bindFrame:SetFrameLevel(getglobal("SpellButton"..i):GetFrameLevel()+1);		
		
		getglobal("SpellButton"..i):CreateFontString("$parentHotKey", "ARTWORK", "NumberFontNormalSmall");		
		getglobal("SpellButton"..i.."HotKey"):SetPoint("TOPRIGHT", -1, -5);		
	end		
	for i=1,10 do
		local bindFrame = CreateFrame("Button", "TrinitySpellBinderButton"..i+12, getglobal("ShapeshiftButton"..i), "TrinitySpellBinderTemplate");				
		bindFrame:SetID(i+12);
		bindFrame:SetPoint("TOPLEFT", getglobal("ShapeshiftButton"..i), "TOPLEFT", 0 ,0);
		bindFrame:SetPoint("BOTTOMRIGHT", getglobal("ShapeshiftButton"..i), "BOTTOMRIGHT", 0 ,0);
		bindFrame:SetFrameLevel(getglobal("ShapeshiftButton"..i):GetFrameLevel()+1);	
		getglobal("ShapeshiftButton"..i.."HotKey"):SetPoint("TOPRIGHT", 0, -3);		
		getglobal("ShapeshiftButton"..i.."HotKey"):SetTextColor(1,1,1)
		getglobal("ShapeshiftButton"..i):CreateFontString("$parentHotKeyRound", "ARTWORK", "NumberFontNormalSmallRound");		
		getglobal("ShapeshiftButton"..i.."HotKeyRound"):SetPoint("TOPRIGHT", 0, -3);		
		getglobal("ShapeshiftButton"..i.."HotKeyRound"):SetTextColor(1,1,1)		
	end			
end

function TrinitySpellBookFrame_OnEvent()

	if ( event == "SPELLS_CHANGED" or "UPDATE_BINDINGS") then
		if ( SpellBookFrame:IsVisible() ) then					
			SpellBookFrame_Update();
			SpellBook_UpdatePageArrows();
			for i=1,12 do
				getglobal("SpellButton"..i.."HotKey"):SetText();								
				local frameid = getglobal("TrinitySpellBinderButton"..i):GetID()
				local spellid = SpellBook_GetSpellID(frameid);
				local spellName, subSpellName = GetSpellName(spellid, SpellBookFrame.bookType);
				if (spellName) then
					if (subSpellName) then
						spellName = spellName.."("..subSpellName..")".."-HotKey";
					else
						spellName = spellName.."()".."-HotKey";
					end				
					for k,v in pairs(TrinitySpellBindings) do
						if (k == spellName) then
							getglobal("SpellButton"..i.."HotKey"):SetText(v);								
						end
					end
				end
			end
		end
	elseif ( event == "LEARNED_SPELL_IN_TAB" ) then
		local flashFrame = getglobal("SpellBookSkillLineTab"..arg1.."Flash");
		if ( SpellBookFrame.bookType == BOOKTYPE_PET ) then
			return;
		else
			if ( flashFrame ) then
				flashFrame:Show();
				SpellBookFrame.flashTabs = 1;
			end
		end
	end
end

function TrinityCreateDockFrames()

	local dockFrame = CreateFrame("Frame", "TrinityDockFrame0", UIParent);
		dockFrame:SetID(0);
		CreateFrame("CheckButton", "$parentShowGrid", dockFrame);
		dockFrame:SetPoint("BOTTOM", 0, -200);
		TrinityButtonDockDefaults(0, dockFrame);		

	for i=1,TrinityDockFrames do
		local dockFrame = CreateFrame("Button", "TrinityDockFrame"..i, UIParent, "TrinityDockFrameTemplate");
		dockFrame:SetID(i);		
		TrinityButtonDockDefaults(i, dockFrame);		
		getglobal(dockFrame:GetName().."Close"):Hide();
	end
end	

function TrinityCreateButtons()

	local dummyButton = CreateFrame("CheckButton", "TrinityActionButton0", TrinityNormalButtons, "SecureActionButtonTemplate");
		TrinityNormalButtons:SetAttribute("addchild", dummyButton);
		dummyButton:CreateFontString("$parentHotKey", "ARTWORK", "NumberFontNormalSmall");
		dummyButton.hotkey = nil;
		dummyButton.dock = 0;
		dummyButton:SetID(0);
		dummyButton:SetPoint("CENTER", 0 ,0);
		dummyButton:Hide();		

	for i=1,120 do
		local actionButton = CreateFrame("CheckButton", "TrinityActionButton"..i, TrinityNormalButtons, "TrinityActionButtonTemplate");
		actionButton:SetAttribute("useparent-unit", true);				
		actionButton:SetAttribute("type", "action");		
		actionButton:SetID(i);
		getglobal("TrinityActionButton"..i.."BindFrame"):SetID(i);
		actionButton:SetAttribute("action1", i);				
		actionButton:SetAttribute("action2", i);
		actionButton.anchor = 99;
		actionButton.hotkey = nil;
		actionButton.hotkeytext = "";		
		actionButton.laststate = "";				
	end
	
	for i=121,155 do
		local actionButton = CreateFrame("Frame", "TrinityActionButton"..i, TrinityNormalButtons);
		actionButton:SetClampedToScreen(true);
		actionButton:CreateFontString("$parentHotKey", "ARTWORK", "NumberFontNormalSmallGray");
		actionButton:CreateFontString("$parentHotKeyRound", "ARTWORK", "NumberFontNormalSmallGray");
		actionButton:SetID(i);
		actionButton:SetWidth(36);
		actionButton:SetHeight(40);
		actionButton.anchor = 99;
		actionButton.hotkey = nil;
		actionButton.hotkeytext = "";		
		actionButton.laststate = "";				
	end
	
	Trinity_ReassignDefaultUIElements()
end

function TrinityCreateHybridCheck(i, dockFrame)

	local hybridCheck = CreateFrame("CheckButton", "TrinityHybridOption"..i, dockFrame, "TrinityCheckButtonTemplate");
		hybridCheck:SetPoint("BOTTOMRIGHT", dockFrame, "BOTTOMRIGHT",  -18, 18);		
		hybridCheck:SetID(i);
		hybridCheck:SetScript("OnEvent", function() this:SetChecked(dockFrame.config["hybrid"]); TrinitySetHybridMode(dockFrame, this:GetChecked()) end);
		hybridCheck:SetScript("OnClick", function() dockFrame.config["hybrid"] = this:GetChecked() TrinitySetHybridMode(dockFrame, this:GetChecked()) TrinityUpdateBarLabel(dockFrame) end);
		hybridCheck:SetScript("OnEnter", function() TrinityActionButton_SetTooltip() GameTooltip:SetText("Check to enable hybrid paging for this dock", 1.0, 1.0, 1.0); GameTooltip:Show(); end);
		hybridCheck:SetScript("OnLeave", function() GameTooltip:Hide(); end);
		
		if (dockFrame.config["header"] == "TrinityStanceButtons") then
			hybridCheck:SetAttribute("showstates", "0-9");
			TrinityStanceButtons:SetAttribute("addchild", hybridCheck);
		
		elseif (dockFrame.config["header"] == "TrinityPagedButtons") then
			hybridCheck:SetAttribute("showstates", "0-9");
			TrinityPagedButtons:SetAttribute("addchild", hybridCheck);		

		elseif (dockFrame.config["header"] == "TrinityHybridStanceButtons") then
			hybridCheck:SetAttribute("showstates", "0-9");
			TrinityHybridStanceButtons:SetAttribute("addchild", hybridCheck);		
		
		elseif (dockFrame.config["header"] == "TrinityHybridPagedButtons") then
			hybridCheck:SetAttribute("showstates", "0-9");
			TrinityHybridPagedButtons:SetAttribute("addchild", hybridCheck);		
		else
			hybridCheck:SetAttribute("showstates", "NOSHOW");
			TrinityNormalButtons:SetAttribute("addchild", hybridCheck);
		end		

end

function TrinitySetHybridMode(frame, checked)

	if (checked) then
		if (string.find(frame.config["header"],"Stance")) then
			frame.config["header"] = "TrinityHybridStanceButtons";
			for i=0,9 do
				local buttonList = {};
				string.gsub(frame.buttonList[i], "%d+", function (btn) table.insert(buttonList, btn) end);
				for j=1,getn(buttonList) do
					TrinityHybridStanceButtons:SetAttribute("addchild", getglobal("TrinityActionButton"..buttonList[j]));		
				end
			end
			TrinityHybridStanceButtons:SetAttribute("addchild", getglobal("TrinityHybridOption"..frame:GetID()));		
		end
	
		if (string.find(frame.config["header"], "Paged")) then
			frame.config["header"] = "TrinityHybridPagedButtons";
			for i=0,9 do
				local buttonList = {};
				string.gsub(frame.buttonList[i], "%d+", function (btn) table.insert(buttonList, btn) end);
				for j=1,getn(buttonList) do
					TrinityHybridPagedButtons:SetAttribute("addchild", getglobal("TrinityActionButton"..buttonList[j]));		
					if (i==1) then
						getglobal("TrinityActionButton"..buttonList[j]):SetAttribute("showstates", "HPAGED");						
						getglobal("TrinityActionButton"..buttonList[j]).dock = 0;
					end
				end
			end
			TrinityHybridPagedButtons:SetAttribute("addchild", getglobal("TrinityHybridOption"..frame:GetID()));		
		end
	else
	
		if (string.find(frame.config["header"],"Stance")) then
			frame.config["header"] = "TrinityStanceButtons";
			for i=0,9 do
				local buttonList = {};
				string.gsub(frame.buttonList[i], "%d+", function (btn) table.insert(buttonList, btn) end);
				for j=1,getn(buttonList) do
					TrinityStanceButtons:SetAttribute("addchild", getglobal("TrinityActionButton"..buttonList[j]));		
				end
			end
			TrinityStanceButtons:SetAttribute("addchild", getglobal("TrinityHybridOption"..frame:GetID()));		
		end
	
		if (string.find(frame.config["header"], "Paged")) then
			frame.config["header"] = "TrinityPagedButtons";
			for i=0,9 do
				local buttonList = {};
				string.gsub(frame.buttonList[i], "%d+", function (btn) table.insert(buttonList, btn) end);
				for j=1,getn(buttonList) do
					TrinityPagedButtons:SetAttribute("addchild", getglobal("TrinityActionButton"..buttonList[j]));		
					if (i==1) then
						if (getglobal("TrinityActionButton"..buttonList[j]):GetAttribute("showstates") == "HPAGED") then
							getglobal("TrinityActionButton"..buttonList[j]):SetAttribute("showstates", "1");
							getglobal("TrinityActionButton"..buttonList[j]).dock = frame:GetID();
						end
					end					
				end
			end
			TrinityPagedButtons:SetAttribute("addchild", getglobal("TrinityHybridOption"..frame:GetID()));					
		end	
	end
	
	TrinityUpdateDocking(frame:GetID())	
	
	TrinityUpdateBindings();
end

function TrinityCreateProwlCheck(i, dockFrame)

	local prowlCheck = CreateFrame("CheckButton", "TrinityProwlOption"..i, dockFrame, "TrinityCheckButtonTemplate");
		prowlCheck:SetPoint("BOTTOMRIGHT", dockFrame, "BOTTOMRIGHT",  -18, 18);		
		prowlCheck:SetID(i);
		prowlCheck:SetScript("OnEvent", function() this:SetChecked(dockFrame.config["prowl"]); TrinitySetProwl(this); end);
		prowlCheck:SetScript("OnClick", function() TrinitySetProwl(this); end);
		prowlCheck:SetScript("OnEnter", function() TrinityActionButton_SetTooltip() GameTooltip:SetText("Check to enable prowl bar", 1.0, 1.0, 1.0); GameTooltip:Show(); end);
		prowlCheck:SetScript("OnLeave", function() GameTooltip:Hide(); end);
		if (dockFrame.config["header"] == "TrinityStanceButtons") then
			prowlCheck:SetAttribute("showstates", tostring(TrinityForms["Cat Form"]));
		else
			prowlCheck:SetAttribute("showstates", "NOSHOW");
		end
		TrinityStanceButtons:SetAttribute("addchild", prowlCheck);	
end

function TrinitySetProwl(frame)

	for i=1,TrinityDockFrames do		
		if (getglobal("TrinityDockFrame"..i).config["header"] == "TrinityStanceButtons") then
			getglobal("TrinityDockFrame"..i).config["prowl"] = frame:GetChecked();
			if (not getglobal("TrinityProwlOption"..i)) then
				TrinityCreateProwlCheck(i, getglobal("TrinityDockFrame"..i));
				TrinityRefreshHeaders();
			end
			getglobal("TrinityProwlOption"..i):SetChecked(getglobal("TrinityDockFrame"..i).config["prowl"]);
			getglobal("TrinityHybridOption"..i):SetAttribute("showstates", "!3,0-9");
		end
		
		if (getglobal("TrinityDockFrame"..i).config["header"] == "TrinityHybridStanceButtons") then
			getglobal("TrinityDockFrame"..i).config["prowl"] = frame:GetChecked();
			if (not getglobal("TrinityProwlOption"..i)) then
				TrinityCreateProwlCheck(i, getglobal("TrinityDockFrame"..i));
				TrinityRefreshHeaders();
			end
			getglobal("TrinityProwlOption"..i):SetChecked(getglobal("TrinityDockFrame"..i).config["prowl"]);
			getglobal("TrinityHybridOption"..i):SetAttribute("showstates", "!3,0-9");
		end				
	end	

	if (getglobal("TrinityDockFrame"..frame:GetID()).config["header"] == "TrinityStanceButtons") then
	
		if (frame:GetChecked()) then
			TrinityStanceButtons:SetAttribute("statemap-stealth-0", "0:=;"..tostring(TrinityForms["Tree of Life"])..":=;"..tostring(TrinityForms["Moonkin Form"])..":=;"..tostring(TrinityForms["Prowl"])..":"..tostring(TrinityForms["Cat Form"]));		
			TrinityStanceButtons:SetAttribute("statemap-stealth-1", "0:=;"..tostring(TrinityForms["Tree of Life"])..":=;"..tostring(TrinityForms["Moonkin Form"])..":=;"..tostring(TrinityForms["Cat Form"])..":"..tostring(TrinityForms["Prowl"]));				
			TrinityProwlBarActive = true;
		else
			TrinityStanceButtons:SetAttribute("statemap-stealth-0", "0:=;"..tostring(TrinityForms["Tree of Life"])..":=;"..tostring(TrinityForms["Moonkin Form"])..":=;"..tostring(TrinityForms["Cat Form"])..":=");		
			TrinityStanceButtons:SetAttribute("statemap-stealth-1", "0:=;"..tostring(TrinityForms["Tree of Life"])..":=;"..tostring(TrinityForms["Moonkin Form"])..":=;"..tostring(TrinityForms["Cat Form"])..":=");
			TrinityProwlBarActive = false;
		end
	end
	
	if (getglobal("TrinityDockFrame"..frame:GetID()).config["header"] == "TrinityHybridStanceButtons") then
	
		if (frame:GetChecked()) then
			TrinityHybridStanceButtons:SetAttribute("statemap-stealth-0", "0:=;"..tostring(TrinityForms["Tree of Life"])..":=;"..tostring(TrinityForms["Moonkin Form"])..":=;"..tostring(TrinityForms["Prowl"])..":"..tostring(TrinityForms["Cat Form"]));		
			TrinityHybridStanceButtons:SetAttribute("statemap-stealth-1", "0:=;"..tostring(TrinityForms["Tree of Life"])..":=;"..tostring(TrinityForms["Moonkin Form"])..":=;"..tostring(TrinityForms["Cat Form"])..":"..tostring(TrinityForms["Prowl"]));				
			TrinityProwlBarActive = true;
		else
			TrinityHybridStanceButtons:SetAttribute("statemap-stealth-0", "0:=;"..tostring(TrinityForms["Tree of Life"])..":=;"..tostring(TrinityForms["Moonkin Form"])..":=;"..tostring(TrinityForms["Cat Form"])..":=");		
			TrinityHybridStanceButtons:SetAttribute("statemap-stealth-1", "0:=;"..tostring(TrinityForms["Tree of Life"])..":=;"..tostring(TrinityForms["Moonkin Form"])..":=;"..tostring(TrinityForms["Cat Form"])..":=");
			TrinityProwlBarActive = false;
		end	
	end
	
	TrinitySaveButtonState();
end

-- Function to handle default UI elements that we still want to use.
function Trinity_ReassignDefaultUIElements()

	local defaultElement = {}
	
	TrinityBagDoodads:SetFrameStrata("LOW");
	
 	defaultElement[121] = TrinityBagDoodads:GetName(); 	
 	defaultElement[123] = CharacterBag2Slot:GetName();	
 	defaultElement[122] = CharacterBag3Slot:GetName();
 	defaultElement[124] = CharacterBag1Slot:GetName();
 	defaultElement[125] = CharacterBag0Slot:GetName();
 	defaultElement[126] = MainMenuBarBackpackButton:GetName();	
  	
  	defaultElement[127] = CharacterMicroButton:GetName();   	
  	defaultElement[128] = SpellbookMicroButton:GetName();
  	defaultElement[129] = TalentMicroButton:GetName();
  	defaultElement[130] = QuestLogMicroButton:GetName();
  	defaultElement[131] = SocialsMicroButton:GetName();
  	defaultElement[132] = LFGMicroButton:GetName();
  	defaultElement[133] = MainMenuMicroButton:GetName();
  	defaultElement[134] = HelpMicroButton:GetName();  	
  	
	for i=1,10 do
		defaultElement[i+134] = getglobal("PetActionButton"..i):GetName();
		getglobal("PetActionButton"..i):SetScript("OnUpdate", function() TrinityPetButtonOnUpdate(arg1) end);
		getglobal("PetActionButton"..i):CreateTexture("$parentAutoCastSim", "OVERLAY", "TrinityCheckButtonTextureTemplate");		
		getglobal("PetActionButton"..i.."AutoCastSim"):SetPoint("TOPLEFT", 0, 0);
		getglobal("PetActionButton"..i.."AutoCastSim"):SetPoint("BOTTOMRIGHT", 0, 0);
 	end 	 	
	for i=1,10 do
		defaultElement[i+144] = getglobal("ShapeshiftButton"..i):GetName();		
		getglobal("ShapeshiftButton"..i):SetScript("OnEnter", function() if (TrinityShowButtonTooltips) then if ( GetCVar("UberTooltips") == "1" ) then	GameTooltip_SetDefaultAnchor(GameTooltip, this) else GameTooltip:SetOwner(this, "ANCHOR_RIGHT") end GameTooltip:SetShapeshift(this:GetID()) end end);		
	end	
	
	defaultElement[155] = TrinityCastingBar:GetName();

	for i=121,155 do
		getglobal(defaultElement[i]):ClearAllPoints();
		getglobal(defaultElement[i]):SetParent(getglobal("TrinityActionButton"..i));				
		if (i>126 and i<135) then
			getglobal("TrinityActionButton"..i):SetWidth(getglobal(defaultElement[i]):GetWidth()*0.8);			
			getglobal("TrinityActionButton"..i):SetHeight(getglobal(defaultElement[i]):GetHeight()/2);
			getglobal(defaultElement[i]):SetPoint("BOTTOM", getglobal("TrinityActionButton"..i), "BOTTOM");
		else
			getglobal("TrinityActionButton"..i):SetWidth(getglobal(defaultElement[i]):GetWidth());
			getglobal("TrinityActionButton"..i):SetHeight(getglobal(defaultElement[i]):GetHeight());
			getglobal(defaultElement[i]):SetPoint("CENTER", getglobal("TrinityActionButton"..i), "CENTER");
		end		
		getglobal(defaultElement[i]):Show();		
	end
	
	TrinityCastingBar:SetPoint("TOPLEFT");
	TrinityCastingBar:SetPoint("BOTTOMRIGHT");
	
	TrinityLatencyBarFrame:SetParent("TrinityBagDoodads");
	TrinityLatencyBarFrame:SetPoint("CENTER", "TrinityBagDoodads", "CENTER", -9, 0);	
 	
 	KeyRingButton:ClearAllPoints();
 	KeyRingButton:SetParent("TrinityBagDoodads");
 	KeyRingButton:SetPoint("CENTER", "TrinityBagDoodads", "LEFT", 27, 0); 	 	
 	KeyRingButton:SetHeight(34)
 	KeyRingButton:Show();	
end

function TrinityButtonDockDefaults(i, dockFrame)

	dockFrame.anchors = {};
	dockFrame.lastDocked = {};
	dockFrame.buttonCount = {};
	dockFrame.placed = {};
	dockFrame.buttonList = {};
	for i=0,9 do
		dockFrame.anchors[i] = 0;
		dockFrame.lastDocked[i] = 0;
		dockFrame.buttonCount[i] = 0;
		dockFrame.placed[i] = 0;
		dockFrame.buttonList[i] = "";			
	end
	dockFrame.config = {
		["header"] = "TrinityNormalButtons";
		["scale"] = 1;
		["alpha"] = 1;
		["shape"] = 0;
		["hide"] = 0;
		["columns"] = 6;
		["ghost"] = nil;	
		["prowl"] = nil;
		["vis"] = 1;		
		["showgrid"] = nil;
		["buttonSpaceH"] = 3;
		["buttonSpaceV"] = 3;
		["style"] = 1;
		["target"] = "none";
		["paged"] = "1,2,3,4,5,6";
		["hybrid"] = nil;
		["stowed"] = false;
		["stowbuttons"] = false;
	}	
	dockFrame.centerx = UIParent:GetWidth()/2;
	dockFrame.centery = 30*dockFrame:GetID();	
	dockFrame.elapsed = 3;
	dockFrame.update = false;	
end

function TrinityButtonDefaults(i, actionButton, stanceFrame, pagedFrame, normalFrame)

	if (i<13) then		

		if (UnitClass("player") ~= TRINITY_WARRIOR) then
		
			actionButton.dock = 1;			
			actionButton.hotkey = tostring(i);
			actionButton.hotkeytext = tostring(i);	
			if (i==10) then
				actionButton.hotkey = "0"; actionButton.hotkeytext = "0";
			elseif (i==11) then
				actionButton.hotkey = "-"; actionButton.hotkeytext = "-";
			elseif (i==12) then
				actionButton.hotkey = "="; actionButton.hotkeytext = "=";
			end
			if (UnitClass("player") == TRINITY_DRUID  or UnitClass("player") == TRINITY_ROGUE or UnitClass("player") == TRINITY_PRIEST) then
				actionButton:SetAttribute("showstates", "0");				
				actionButton.laststate = actionButton:GetAttribute("showstates");
				stanceFrame:SetAttribute("addchild", actionButton);					
			else
				actionButton:SetAttribute("showstates", "1");
				actionButton.laststate = actionButton:GetAttribute("showstates");
				pagedFrame:SetAttribute("addchild", actionButton);
			end						
		else		
			actionButton.dock = 7;
			actionButton.hotkey = nil;
			actionButton.hotkeytext = "";		
			actionButton:SetAttribute("showstates", "0");				
			actionButton.laststate = actionButton:GetAttribute("showstates");
			normalFrame:SetAttribute("addchild", actionButton);
		end
		
	elseif (i>12 and i<25) then
	
		actionButton.dock = 2;		
		actionButton.hotkey = nil;
		actionButton.hotkeytext = "";		
	
		if (UnitClass("player") == TRINITY_DRUID or UnitClass("player") == TRINITY_WARRIOR or UnitClass("player") == TRINITY_ROGUE or UnitClass("player") == TRINITY_PRIEST) then			
			actionButton:SetAttribute("showstates", "1");		
			actionButton.laststate = actionButton:GetAttribute("showstates");
			pagedFrame:SetAttribute("addchild", actionButton);
		else
			actionButton:SetAttribute("showstates", "0");
			actionButton.laststate = actionButton:GetAttribute("showstates");
			normalFrame:SetAttribute("addchild", actionButton);
		end
		
	elseif (i>24 and i<37) then
		
		actionButton.dock = 3;
		actionButton.hotkey = nil;
		actionButton.hotkeytext = "";		
		actionButton:SetAttribute("showstates", "0");
		actionButton.laststate = actionButton:GetAttribute("showstates");
		normalFrame:SetAttribute("addchild", actionButton);

	elseif (i>36 and i<49) then
		
		actionButton.dock = 4;
		actionButton.hotkey = nil;
		actionButton.hotkeytext = "";		
		actionButton:SetAttribute("showstates", "0");
		actionButton.laststate = actionButton:GetAttribute("showstates");
		normalFrame:SetAttribute("addchild", actionButton);
		
	elseif (i>48 and i<61) then
		
		actionButton.dock = 5;
		actionButton.hotkey = nil;
		actionButton.hotkeytext = "";		
		actionButton:SetAttribute("showstates", "0");
		actionButton.laststate = actionButton:GetAttribute("showstates");
		normalFrame:SetAttribute("addchild", actionButton);
		
	elseif (i>60 and i<73) then
		
		actionButton.dock = 6;
		actionButton.hotkey = nil;
		actionButton.hotkeytext = "";		
		actionButton:SetAttribute("showstates", "0");
		actionButton.laststate = actionButton:GetAttribute("showstates");
		normalFrame:SetAttribute("addchild", actionButton);
		
	elseif (i>72 and i<85) then
	
		if (UnitClass("player") == TRINITY_DRUID) then
		
			actionButton.dock = 1;								
			actionButton.hotkey = tostring(i-72);
			actionButton.hotkeytext = tostring(i-72);	
			if (i==82) then
				actionButton.hotkey = "0"; actionButton.hotkeytext = "0";
			elseif (i==83) then
				actionButton.hotkey = "-"; actionButton.hotkeytext = "-";
			elseif (i==84) then
				actionButton.hotkey = "="; actionButton.hotkeytext = "=";
			end
			actionButton:SetAttribute("showstates", tostring(TrinityForms["Cat Form"]));
			actionButton.laststate = actionButton:GetAttribute("showstates");
			stanceFrame:SetAttribute("addchild", actionButton);
			
		elseif (UnitClass("player") == TRINITY_WARRIOR or UnitClass("player") == TRINITY_ROGUE or UnitClass("player") == TRINITY_PRIEST) then
		
			actionButton.dock = 1;								
			actionButton.hotkey = tostring(i-72);
			actionButton.hotkeytext = tostring(i-72);	
			if (i==82) then
				actionButton.hotkey = "0"; actionButton.hotkeytext = "0";
			elseif (i==83) then
				actionButton.hotkey = "-"; actionButton.hotkeytext = "-";
			elseif (i==84) then
				actionButton.hotkey = "="; actionButton.hotkeytext = "=";
			end
			actionButton:SetAttribute("showstates", "1");
			actionButton.laststate = actionButton:GetAttribute("showstates");
			stanceFrame:SetAttribute("addchild", actionButton);

		else
			actionButton.dock = 7;
			actionButton.hotkey = nil;
			actionButton.hotkeytext = "";		
			actionButton:SetAttribute("showstates", "0");
			actionButton.laststate = actionButton:GetAttribute("showstates");
			normalFrame:SetAttribute("addchild", actionButton);
		end
		
	elseif (i>84 and i<97) then
	
		if (UnitClass("player") == TRINITY_WARRIOR) then
		
			actionButton.dock = 1;				
			actionButton.hotkey = tostring(i-84);
			actionButton.hotkeytext = tostring(i-84);	
			if (i==94) then
				actionButton.hotkey = "0"; actionButton.hotkeytext = "0";
			elseif (i==95) then
				actionButton.hotkey = "-"; actionButton.hotkeytext = "-";
			elseif (i==96) then
				actionButton.hotkey = "="; actionButton.hotkeytext = "=";
			end
			actionButton:SetAttribute("showstates", "2");
			actionButton.laststate = actionButton:GetAttribute("showstates");
			stanceFrame:SetAttribute("addchild", actionButton);
		else
			actionButton.dock = 8;
			actionButton.hotkey = nil;
			actionButton.hotkeytext = "";		
			actionButton:SetAttribute("showstates", "0");
			actionButton.laststate = actionButton:GetAttribute("showstates");
			normalFrame:SetAttribute("addchild", actionButton);
		end
		
	elseif (i>96 and i<109) then
	
		if (UnitClass("player") == TRINITY_DRUID) then
		
			actionButton.dock = 1;							
			actionButton.hotkey = tostring(i-96);
			actionButton.hotkeytext = tostring(i-96);	
			if (i==106) then
				actionButton.hotkey = "0"; actionButton.hotkeytext = "0";
			elseif (i==107) then
				actionButton.hotkey = "-"; actionButton.hotkeytext = "-";
			elseif (i==108) then
				actionButton.hotkey = "="; actionButton.hotkeytext = "=";
			end
			local bear
			if (tonumber(TrinityForms["Bear Form"])) then
				bear = TrinityForms["Bear Form"]
			elseif (tonumber(TrinityForms["Dire Bear Form"])) then
				bear = TrinityForms["Dire Bear Form"]
			end			
			actionButton:SetAttribute("showstates", tostring(bear));
			actionButton.laststate = actionButton:GetAttribute("showstates");
			stanceFrame:SetAttribute("addchild", actionButton);
		
		elseif (UnitClass("player") == TRINITY_WARRIOR) then
		
			actionButton.dock = 1;							
			actionButton.hotkey = tostring(i-96);
			actionButton.hotkeytext = tostring(i-96);	
			if (i==106) then
				actionButton.hotkey = "0"; actionButton.hotkeytext = "0";
			elseif (i==107) then
				actionButton.hotkey = "-"; actionButton.hotkeytext = "-";
			elseif (i==108) then
				actionButton.hotkey = "="; actionButton.hotkeytext = "=";
			end
			actionButton:SetAttribute("showstates", "3");
			actionButton.laststate = actionButton:GetAttribute("showstates");
			stanceFrame:SetAttribute("addchild", actionButton);
		else			
			actionButton.dock = 9;
			actionButton.hotkey = nil;
			actionButton.hotkeytext = "";		
			actionButton:SetAttribute("showstates", "0");			
			actionButton.laststate = actionButton:GetAttribute("showstates");
			normalFrame:SetAttribute("addchild", actionButton);
		end
		
	elseif (i>108 and i<121) then		
		
		actionButton.dock = 10;
		actionButton.hotkey = nil;
		actionButton.hotkeytext = "";				
		actionButton:SetAttribute("showstates", "0");		
		actionButton.laststate = actionButton:GetAttribute("showstates");
		normalFrame:SetAttribute("addchild", actionButton);
		
	elseif (i>120 and i<127) then					
		
		actionButton.dock = 11;
		TrinityMiscBars["bags"] = actionButton.dock; 
		actionButton:SetAttribute("showstates", "0");
		actionButton.laststate = actionButton:GetAttribute("showstates");
		normalFrame:SetAttribute("addchild", actionButton);
	
	elseif (i>126 and i<135) then					
		
		actionButton.dock = 12;	
		TrinityMiscBars["menu"] = actionButton.dock; 
		actionButton:SetAttribute("showstates", "0");
		actionButton.laststate = actionButton:GetAttribute("showstates");
		normalFrame:SetAttribute("addchild", actionButton);

	elseif (i>134 and i<145) then					
		
		actionButton.dock = 13;
		TrinityMiscBars["pet"] = actionButton.dock; 
		actionButton:SetAttribute("showstates", "0");
		actionButton.laststate = actionButton:GetAttribute("showstates");
		normalFrame:SetAttribute("addchild", actionButton);

	elseif (i>144 and i<155) then							
	
		actionButton.dock = 14;
		TrinityMiscBars["form"] = actionButton.dock;
		actionButton:SetAttribute("showstates", "0");
		actionButton.laststate = actionButton:GetAttribute("showstates");		
		normalFrame:SetAttribute("addchild", actionButton);
		
	elseif (i==155) then
	
		actionButton.dock = 15;
		TrinityMiscBars["cast"] = actionButton.dock;
		actionButton:SetAttribute("showstates", "0");
		actionButton.laststate = actionButton:GetAttribute("showstates");		
		normalFrame:SetAttribute("addchild", actionButton);
	end	
end

-- This functions main purpose is to initialize the layout on a first run
function TrinityUpdateDockPostions(reset)

	local dockFrameHeight;
	
	local anchor = "BOTTOM";
	local relTo = "UIParent";
	local relPoint = "BOTTOM";
	local x = 0;
	local y = 6;	
	
	if (reset) then
	
		dockFrameHeight = 45;
		
		for i=1,TrinityDockFrames do		
			local dockFrame = getglobal("TrinityDockFrame"..i);
			
			TrinityButtonDockDefaults(i, dockFrame);
			
			if (UnitClass("player") == TRINITY_DRUID or UnitClass("player") == TRINITY_WARRIOR or UnitClass("player") == TRINITY_ROGUE or UnitClass("player") == TRINITY_PRIEST) then
				if (i==1) then
					dockFrame.config["header"] = "TrinityStanceButtons";					
					getglobal(dockFrame:GetName().."Ghost"):Hide();
				elseif (i==2) then
					dockFrame.config["header"] = "TrinityPagedButtons";					
					getglobal(dockFrame:GetName().."Ghost"):Hide();
				else
					dockFrame.config["header"] = "TrinityNormalButtons";					
				end			
			else
				if (i==1) then
					dockFrame.config["header"] = "TrinityPagedButtons";					
					getglobal(dockFrame:GetName().."Ghost"):Hide();
				else
					dockFrame.config["header"] = "TrinityNormalButtons";					
				end
			end					

			if (UnitClass("player") == TRINITY_DRUID) then
				TrinityStanceButtons:SetAttribute("statemap-stance-"..tostring(TrinityForms["Travel Form"]), tostring(TrinityForms["Travel Form"])..":0");
				TrinityStanceButtons:SetAttribute("statemap-stance-"..tostring(TrinityForms["Aquatic Form"]), tostring(TrinityForms["Aquatic Form"])..":0");
				TrinityStanceButtons:SetAttribute("statemap-stance-"..tostring(TrinityForms["Flight Form"]), tostring(TrinityForms["Flight Form"])..":0");
				TrinityCreateProwlCheck(i, dockFrame);
			end
			
			TrinityCreateHybridCheck(i, dockFrame)
			
			TrinityUpdateTargeting(dockFrame)
		
			dockFrame:SetUserPlaced(false);		
			dockFrame:ClearAllPoints();			
			dockFrame:SetPoint(anchor, relTo, relPoint, x, y);
			dockFrame:SetUserPlaced(true);		
			y = y + dockFrameHeight;								
		end			
		
		for i=1,155 do
			local actionButton = getglobal("TrinityActionButton"..i);
			TrinityButtonDefaults(i, actionButton, TrinityStanceButtons, TrinityPagedButtons, TrinityNormalButtons)
		end		

		for i=1,TrinityDockFrames do		
			local dockFrame = getglobal("TrinityDockFrame"..i);
			TrinityMiscBarSetup(i, dockFrame);			
			for showstate=0,9 do
				TrinityBuildDockButtonList(showstate, dockFrame)
			end			
		end

		TrinityStowedButtons.buttonIndex = {}
		for i=1,155 do
			TrinityStowedButtons.buttonIndex[i] = 0;
		end
		TrinityStowedButtons.buttonCount = 0;
		
		TrinityUpdateShapeshiftButtons();
		
		TrinityFirstRun = false;
	else	
		for i=1,TrinityDockFrames do		
			local dockFrame = getglobal("TrinityDockFrame"..i);					
					
			if (dockFrame.config["header"] == "TrinityStanceButtons") then								
				getglobal(dockFrame:GetName().."Ghost"):Hide();
				if (UnitClass("player") == TRINITY_DRUID) then
					TrinityStanceButtons:SetAttribute("statemap-stance-"..tostring(TrinityForms["Travel Form"]), tostring(TrinityForms["Travel Form"])..":0");					
					TrinityStanceButtons:SetAttribute("statemap-stance-"..tostring(TrinityForms["Aquatic Form"]), tostring(TrinityForms["Aquatic Form"])..":0");					
					TrinityStanceButtons:SetAttribute("statemap-stance-"..tostring(TrinityForms["Flight Form"]), tostring(TrinityForms["Flight Form"])..":0");						
					TrinityCreateProwlCheck(i, dockFrame);
				end
			elseif (dockFrame.config["header"] == "TrinityHybridStanceButtons") then								
				getglobal(dockFrame:GetName().."Ghost"):Hide();
				if (UnitClass("player") == TRINITY_DRUID) then
					TrinityStanceButtons:SetAttribute("statemap-stance-"..tostring(TrinityForms["Travel Form"]), tostring(TrinityForms["Travel Form"])..":0");
					TrinityStanceButtons:SetAttribute("statemap-stance-"..tostring(TrinityForms["Aquatic Form"]), tostring(TrinityForms["Aquatic Form"])..":0");
					TrinityStanceButtons:SetAttribute("statemap-stance-"..tostring(TrinityForms["Flight Form"]), tostring(TrinityForms["Flight Form"])..":0");				
					TrinityCreateProwlCheck(i, dockFrame);
				end				
			elseif (dockFrame.config["header"] == "TrinityPagedButtons") then				
				getglobal(dockFrame:GetName().."Ghost"):Hide();
			elseif (dockFrame.config["header"] == "TrinityHybridPagedButtons") then				
				getglobal(dockFrame:GetName().."Ghost"):Hide();				
			end
			
			TrinityCreateHybridCheck(i, dockFrame)
			
			TrinityUpdateTargeting(dockFrame);
			
			TrinityMiscBarSetup(i, dockFrame);			

			dockFrame:SetUserPlaced(false);
			dockFrame:ClearAllPoints();			
			dockFrame:SetPoint("CENTER", relTo, "BOTTOMLEFT", dockFrame.centerx, dockFrame.centery);
			dockFrame:SetUserPlaced(true);
		end		
	end
end

function TrinityMiscBarSetup(i, dockFrame)

	if (i==TrinityMiscBars["bags"]) then
	
		dockFrame.config["header"] = "TrinityNormalButtons";				
		getglobal(dockFrame:GetName().."Close"):Show();
		getglobal(dockFrame:GetName().."Close"):SetPoint("TOPLEFT", 42, 3);
		getglobal(dockFrame:GetName().."ButtonTypes"):SetPoint("TOPLEFT", 46, -19);
		getglobal(dockFrame:GetName().."Add"):SetScript("OnClick", function() dockFrame.config["hide"] = 1 TrinityToggleHideShow(dockFrame, 1) TrinityUpdateDocking(this:GetParent():GetID()) end);
		getglobal(dockFrame:GetName().."Subtract"):SetScript("OnClick", function() dockFrame.config["hide"] = 0 TrinityToggleHideShow(dockFrame, 1) TrinityUpdateDocking(this:GetParent():GetID()) end);
		getglobal(dockFrame:GetName().."Add"):SetScript("OnUpdate", function() end);
		getglobal(dockFrame:GetName().."Subtract"):SetScript("OnUpdate", function() end);
		if (dockFrame.buttonCount[0] == 1) then
			MainMenuBarBackpackButton:SetScript("OnClick", function() OpenAllBags() end);
		else
			MainMenuBarBackpackButton:SetScript("OnClick", function() if (IsShiftKeyDown()) then OpenAllBags() else ToggleBackpack() end end);
		end
		getglobal(dockFrame:GetName().."ShowGrid"):Hide();
		getglobal(dockFrame:GetName().."BarType"):Hide();		
		
	elseif (i==TrinityMiscBars["menu"]) then
	
		dockFrame.config["header"] = "TrinityNormalButtons";				
		getglobal(dockFrame:GetName().."Close"):Show();
		getglobal(dockFrame:GetName().."Add"):Hide();
		getglobal(dockFrame:GetName().."Subtract"):Hide();
		getglobal(dockFrame:GetName().."ShowGrid"):Hide();
		getglobal(dockFrame:GetName().."BarType"):Hide();		
		getglobal(dockFrame:GetName().."ButtonTypes"):Hide();		
		
	elseif (i==TrinityMiscBars["pet"]) then
	
		dockFrame.config["header"] = "TrinityNormalButtons";
		getglobal(dockFrame:GetName().."ButtonTypes"):SetPoint("TOPLEFT", 23, -19);
		getglobal(dockFrame:GetName().."Close"):Show();
		getglobal(dockFrame:GetName().."Add"):Hide();
		getglobal(dockFrame:GetName().."Subtract"):Hide();				
		getglobal(dockFrame:GetName().."ShowGrid"):Hide();
		getglobal(dockFrame:GetName().."BarType"):Hide();		
		
	elseif (i==TrinityMiscBars["form"]) then
	
		dockFrame.config["header"] = "TrinityNormalButtons";			
		getglobal(dockFrame:GetName().."ButtonTypes"):SetPoint("TOPLEFT", 23, -19);
		getglobal(dockFrame:GetName().."Close"):Show();
		getglobal(dockFrame:GetName().."Add"):Hide();
		getglobal(dockFrame:GetName().."Subtract"):Hide();				
		getglobal(dockFrame:GetName().."ShowGrid"):Hide();
		getglobal(dockFrame:GetName().."BarType"):Hide();		
		
	elseif (i==TrinityMiscBars["cast"]) then
	
		getglobal(dockFrame:GetName().."Close"):Show();
		getglobal(dockFrame:GetName().."Close"):SetPoint("TOPLEFT", 42, 3);						
		getglobal(dockFrame:GetName().."Add"):SetScript("OnUpdate", function() TrinityAddOnUpdate(dockFrame, arg1) end);
		getglobal(dockFrame:GetName().."Subtract"):SetScript("OnUpdate", function() TrinitySubtractOnUpdate(dockFrame, arg1) end);		
		getglobal(dockFrame:GetName().."ShowGrid"):Hide();
		getglobal(dockFrame:GetName().."BarType"):Hide();
		getglobal(dockFrame:GetName().."Ghost"):Hide();
		getglobal(dockFrame:GetName().."ButtonTypes"):Hide();		
		if (not dockFrame.config["orientation"]) then
			dockFrame.config["orientation"] = TrinityCastingBar:GetOrientation();
		else
			TrinityCastingBar:SetOrientation(dockFrame.config["orientation"]);
			TrinityCastingBarDummy:SetOrientation(dockFrame.config["orientation"]);
			TrinityCastingBarSetTextures(dockFrame.config["orientation"]);
		end
		if (not dockFrame.config["anchorwidth"]) then
			dockFrame.config["anchorwidth"] = TrinityCastingBar:GetParent():GetWidth();
		else
			TrinityActionButton155:SetWidth(dockFrame.config["anchorwidth"]);
		end
		if (not dockFrame.config["anchorheight"]) then
			dockFrame.config["anchorheight"] = TrinityCastingBar:GetParent():GetHeight();
		else
			TrinityActionButton155:SetHeight(dockFrame.config["anchorheight"]);			
		end
			
		TrinityCastingBarDummy:SetParent(getglobal("TrinityDockFrame"..TrinityMiscBars["cast"]));		
		if (getglobal("TrinityDockFrame"..TrinityMiscBars["cast"]).config["hide"] == 0) then
			TrinityCastingBarDummy:Show();
		else
			TrinityCastingBarDummy:Hide();
		end
		TrinityCastingBar:Hide();		
	end
end

-- A function to handle events
function TrinityControls_OnEvent(self,event,...)

	if (event == "UPDATE_STEALTH") then
		if (not TrinityDockBarsHide) then
			TrinityUpdateDockingAfterEvent()
		end
	end
	
	if (event == "VARIABLES_LOADED") then	
		TrinityCreateDockFrames();
		TrinityCreateButtons();		
		TrinityLoadSV();
		TrinityVariablesLoaded = true;
	end
	
	if (event == "PLAYER_REGEN_DISABLED") then
		if (not TrinityDockBarsHide) then
			UIErrorsFrame:AddMessage("In Combat Lockdown - Hiding Docks", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
			TrinityDockLockdown = true;
			TrinityDockBarsHide = true;
			TrinityButtonsHide = true;
			TrinityUpdateDocking()
		end
		
		
		for i=1,TrinityDockFrames do							
			if (getglobal("TrinityDockFrame"..i).config["ghost"] == 1) then
				local buttonList = {};	
				string.gsub(getglobal("TrinityDockFrame"..i).buttonList[0], "%d+", function (btn) table.insert(buttonList, btn) end);
				for j=1,getn(buttonList) do					
					getglobal("TrinityActionButton"..buttonList[j]):SetAlpha(getglobal("TrinityDockFrame"..i).config["alpha"]);					
				end
			end
			getglobal("TrinityDockFrame"..i).config["vis"] = 1;
		end
		
		TrinityRefreshHeaders();		
		TrinityCombatLockdown = true;
	end
	
	if (event == "PLAYER_REGEN_ENABLED") then	
		if (TrinityDockLockdown) then
			UIErrorsFrame:AddMessage("Combat Lockdown Ended - Showing Docks", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
			TrinityDockLockdown = false;
			TrinityDockBarsHide = false;
			TrinityButtonsHide = false;
			TrinityUpdateDocking()
		end
		
		TrinityUpdateDockingAfterEvent()
		
		TrinityCombatLockdown = false;
	end

	if (event == "PLAYER_ENTERING_WORLD") then
		if (not TrinityPlayerEnteredWorld) then			
			if (TrinityMiscBars["form"] ~= 0) then
				if (getglobal("TrinityDockFrame"..TrinityMiscBars["form"]).config["hide"] == 0) then
					TrinityUpdateShapeshiftButtons();
				end					
			end
			TrinityUpdateFormNames();
			TrinityUpdateDockPostions(TrinityFirstRun);			
			for i=1, TrinityDockFrames do
				local dockFrame = getglobal("TrinityDockFrame"..i);				
				TrinitySwapTextures(dockFrame);
				if (dockFrame.config["ghost"] == 1) then
					TrinityGhostUpdate(dockFrame);						
				end
			end	
			TrinityUpdateDocking();
			TrinityUpdateBindings();
			TrinityHideKeyBindings();
			TrinitySetSelfCast(TrinitySelfCastOption);
			TrinityPlayerEnteredWorld = true;			
		end
	end
	
	if (event == "PLAYER_AURAS_CHANGED") then		
		if (not TrinityDockBarsHide) then
			TrinityUpdateDockingAfterEvent()
		end
	end

	if (event == "ACTIONBAR_PAGE_CHANGED") then				
		if (not TrinityDockBarsHide) then
			TrinityUpdateDockingAfterEvent()
		end
	end

	if (event == "UPDATE_SHAPESHIFT_FORMS") then
		if (not TrinityDockBarsHide) then
			if (TrinityMiscBars["form"] ~= 0) then
				if (getglobal("TrinityDockFrame"..TrinityMiscBars["form"]).config["hide"]) then
					TrinityUpdateShapeshiftButtons();				
					TrinityUpdateDocking(TrinityMiscBars["form"]);
				end
			end
		end
	end
	
	if (event == "ACTIONBAR_SHOWGRID") then
		if (TrinityDockBarsHide) then
			TrinityButtonsHide = false;
			TrinityHideDocksButtons();
		end
	end
	
	if (event == "ACTIONBAR_HIDEGRID") then
		if (TrinityDockBarsHide) then 
			TrinityButtonsHide = true;			
			TrinityHideDocksButtons();
		end
	end
end

function TrinityUpdateDockingAfterEvent()

	if (not TrinityCombatLockdown and not TrinityDockBarsHide) then
		TrinitySetupDockFrameUpdate()	
	end	
end

function TrinityUpdateFormNames()

	TrinityForms = {}

 	for i=1,GetNumShapeshiftForms() do 		 		
 		local _, formName, _ = GetShapeshiftFormInfo(i); 		
 		TrinityForms[formName] = i; 		
 	end
 	
 	if (UnitClass("player") == TRINITY_DRUID) then
 		TrinityForms["Prowl"] = GetNumShapeshiftForms()+1;
 		
 		if (not TrinityForms["Bear Form"]) then
 			TrinityForms["Bear Form"] = "NOTKNOWN";
 		end 		
 		if (not TrinityForms["Dire Bear Form"]) then
 			TrinityForms["Dire Bear Form"] = "NOTKNOWN";
 		end 		
 		if (not TrinityForms["Cat Form"]) then
 			TrinityForms["Cat Form"] = "NOTKNOWN";
 		end
 		if (not TrinityForms["Aquatic Form"]) then
 			TrinityForms["Aquatic Form"] = "NOTKNOWN";
 		end
 		if (not TrinityForms["Travel Form"]) then
 			TrinityForms["Travel Form"] = "NOTKNOWN";
 		end
 		if (not TrinityForms["Moonkin Form"]) then
 			TrinityForms["Moonkin Form"] = "NOTKNOWN";
 		end
 		if (not TrinityForms["Tree of Life"]) then
 			TrinityForms["Tree of Life"] = "NOTKNOWN";
 		end 		
 		if (not TrinityForms["Flight Form"]) then
 			TrinityForms["Flight Form"] = "NOTKNOWN";
 		end
 	end 
end

function TrinityUpdateShapeshiftButtons()	

	TrinityUpdateFormNames();	

	getglobal("TrinityDockFrame"..TrinityMiscBars["form"]).buttonCount[0] = 0;		

	for i=145,154 do
		getglobal("TrinityActionButton"..i):SetAttribute("showstates", "FORMS");		
		getglobal("TrinityActionButton"..i).dock = 0;		
		TrinityStowedButtons.buttonIndex[getglobal("TrinityActionButton"..i):GetID()] = 1;		
	end
	
	if (GetNumShapeshiftForms() > 0) then		
		for i=145,144+GetNumShapeshiftForms() do			
			if (getglobal("TrinityActionButton"..i):GetAttribute("showstates") == "FORMS") then
				getglobal("TrinityActionButton"..i):SetAttribute("showstates", "0");			
				getglobal("TrinityActionButton"..i).dock = TrinityMiscBars["form"];			
				getglobal("TrinityDockFrame"..TrinityMiscBars["form"]).buttonCount[0] = getglobal("TrinityDockFrame"..TrinityMiscBars["form"]).buttonCount[0] + 1;
				TrinityStowedButtons.buttonIndex[getglobal("TrinityActionButton"..i):GetID()] = 0;
			end
		end 
	end

	SecureStateHeader_Refresh(TrinityNormalButtons, "0");
end

function TrinityChangeBarType(frame)

--TrinityBuildDockButtonList(showstate, dockFrame)

	UIErrorsFrame:AddMessage("Changing bar types disabled in this beta until some issues are resolved", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);		
	return;
end

function TrinityTempInTheWorks(frame)

	if (string.find(frame.config["header"], "Hybrid")) then
		UIErrorsFrame:AddMessage("Disable hybrid mode for this bar before changing bar types", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);		
		return;
	end
	
	local page = 0;
	local anchors = {};
	local lastDocked = {};
	local buttonCount = {};
	local buttonList = {};	
	
	frame.config["ghost"] = nil;	
	frame.config["prowl"] = nil;

	if (frame.config["header"] == "TrinityStanceButtons") then
		frame.config["header"] = "TrinityPagedButtons"	
		getglobal(frame:GetName().."Ghost"):Hide();
		if (getglobal("TrinityProwlOption"..frame:GetID()) and UnitClass("player") == TRINITY_DRUID) then
			getglobal("TrinityProwlOption"..frame:GetID()):SetAttribute("showstates", "NOSHOW");		
		end		
		
		for i=0,9 do			
			if (frame.buttonCount[i] > 0) then
				page = page + 1;
				anchors[page] = frame.anchors[i];
				lastDocked[page] = frame.lastDocked[i];
				buttonCount[page] = frame.buttonCount[i];
				buttonList[page] = frame.buttonList[i];			
			end
			frame.anchors[i] = 0
			frame.lastDocked[i] = 0
			frame.buttonCount[i] = 0
			frame.buttonList[i] = ""
		end
		
		for key,value in pairs(buttonList) do
			local buttonList = {}
			frame.anchors[key] = anchors[key]
			frame.lastDocked[key] = lastDocked[key]
			frame.buttonCount[key] = buttonCount[key]
			frame.buttonList[key] = buttonList[key]
			if (frame.buttonList[key]) then			
				string.gsub(frame.buttonList[key], "%d+", function (btn) table.insert(buttonList, btn) end);
				for k,v in pairs(buttonList) do
					TrinityPagedButtons:SetAttribute("addchild", getglobal("TrinityActionButton"..v));
					getglobal("TrinityActionButton"..v):SetAttribute("showstates", tostring(key));
				end
			end
		end
		
	elseif (frame.config["header"] == "TrinityPagedButtons") then	
		frame.config["header"] = "TrinityNormalButtons"
		getglobal(frame:GetName().."Ghost"):Show();
		if (getglobal("TrinityProwlOption"..frame:GetID()) and UnitClass("player") == TRINITY_DRUID) then
			getglobal("TrinityProwlOption"..frame:GetID()):SetAttribute("showstates", "NOSHOW");		
		end
		
		for i=0,9 do			
			if (frame.buttonCount[i] > 0) then				
				if (page == 0) then
					page = i
				end			
				anchors[page] = frame.anchors[i];
				lastDocked[page] = frame.lastDocked[i];
				buttonCount[page] = frame.buttonCount[i];
				buttonList[page] = frame.buttonList[i];
			end
			frame.anchors[i] = 0
			frame.lastDocked[i] = 0
			frame.buttonCount[i] = 0
			frame.buttonList[i] = ""
		end
		
		for key,value in pairs(buttonList) do
			local buttonList = {}
			if (key == page) then				
				frame.anchors[0] = anchors[key]
				frame.lastDocked[0] = lastDocked[key]
				frame.buttonCount[0] = buttonCount[key]
				frame.buttonList[0] = buttonList[key]
				if (frame.buttonList[0]) then				
					string.gsub(frame.buttonList[0], "%d+", function (btn) table.insert(buttonList, btn) end);
					for k,v in pairs(buttonList) do
						TrinityNormalButtons:SetAttribute("addchild", getglobal("TrinityActionButton"..v));
						getglobal("TrinityActionButton"..v):SetAttribute("showstates", "0");
					end
				end
			else
				if (frame.buttonList[key]) then
					string.gsub(frame.buttonList[key], "%d+", function (btn) table.insert(buttonList, btn) end);
					for k,v in pairs(buttonList) do
						getglobal("TrinityActionButton"..v):SetAttribute("showstates", "TEMP");		
						getglobal("TrinityActionButton"..v).dock = 0;
						TrinityStowedButtons:SetAttribute("addchild", getglobal("TrinityActionButton"..v));
						TrinityStowedButtons.buttonIndex[tonumber(v)] = 1;
						TrinityStowedButtons.buttonCount = TrinityStowedButtons.buttonCount + 1;		
					end
				end
			end
		end	
		
	elseif (frame.config["header"] == "TrinityNormalButtons") then	
		frame.config["header"] = "TrinityStanceButtons"
		getglobal(frame:GetName().."Ghost"):Hide();
		if (getglobal("TrinityProwlOption"..frame:GetID()) and UnitClass("player") == TRINITY_DRUID) then
			getglobal("TrinityProwlOption"..frame:GetID()):SetAttribute("showstates", tostring(TrinityForms["Cat Form"]));		
		end

		for i=0,9 do			
			if (frame.buttonCount[i] > 0) then				
				anchors[page] = frame.anchors[i];
				lastDocked[page] = frame.lastDocked[i];
				buttonCount[page] = frame.buttonCount[i];
				buttonList[page] = frame.buttonList[i];				
				page = page + 1;
			end
			frame.anchors[i] = 0
			frame.lastDocked[i] = 0
			frame.buttonCount[i] = 0
			frame.buttonList[i] = ""
		end
		
		for key,value in pairs(buttonList) do
			local buttonList = {}
			if (UnitClass("player") == TRINITY_WARRIOR and key == 0) then
				frame.anchors[1] = anchors[key]
				frame.lastDocked[1] = lastDocked[key]
				frame.buttonCount[1] = buttonCount[key]
				frame.buttonList[1] = buttonList[key]
				if (frame.buttonList[1]) then
					string.gsub(frame.buttonList[1], "%d+", function (btn) table.insert(buttonList, btn) end);
					for k,v in pairs(buttonList) do
						TrinityStanceButtons:SetAttribute("addchild", getglobal("TrinityActionButton"..v));
						getglobal("TrinityActionButton"..buttonList[v]):SetAttribute("showstates", "1");
					end
				end
			else
				frame.anchors[key] = anchors[key]
				frame.lastDocked[key] = lastDocked[key]
				frame.buttonCount[key] = buttonCount[key]
				frame.buttonList[key] = buttonList[key]				
				if (frame.buttonList[key]) then
					string.gsub(frame.buttonList[key], "%d+", function (btn) table.insert(buttonList, btn) end);
					for k,v in pairs(buttonList) do
						TrinityStanceButtons:SetAttribute("addchild", getglobal("TrinityActionButton"..v));
						getglobal("TrinityActionButton"..v):SetAttribute("showstates", tostring(key));
					end
				end
			end
		end
	end
	
	TrinityRefreshHeaders();
end

function TrinityGetStance(frame)

	local stance;

	if (frame.config["header"] == "TrinityStanceButtons" or frame.config["header"] == "TrinityHybridStanceButtons") then
		if (IsStealthed() and UnitClass("player") == TRINITY_DRUID and GetShapeshiftForm() == TrinityForms["Cat Form"] and TrinityProwlBarActive) then
			stance = TrinityForms["Prowl"];		
		elseif (UnitClass("player") == TRINITY_DRUID and 
			(GetShapeshiftForm() == TrinityForms["Travel Form"] or 
			 GetShapeshiftForm() == TrinityForms["Aquatic Form"] or 
			 GetShapeshiftForm() == TrinityForms["Flight Form"])) then
			stance = 0;	
		else
			stance = GetShapeshiftForm(true);
		end		
	end
	
	if (frame.config["header"] == "TrinityPagedButtons" or frame.config["header"] == "TrinityHybridPagedButtons") then
		stance = GetActionBarPage();
	end
	
	if (frame.config["header"] == "TrinityNormalButtons") then
		stance = 0;
	end	
	
	return stance;
end

-- Function to change the arrangment of buttons
function TrinityChangeShape(frame, dir)

	frame.elapsed = 0;
	
	if (dir == "left") then
		frame.config["shape"] = frame.config["shape"] - 1;
		if (frame.config["shape"] < 0) then
			frame.config["shape"] = TrinityMaxDockShapes
		end
	elseif (dir == "right") then
		frame.config["shape"] = frame.config["shape"] + 1;
		if (frame.config["shape"] > TrinityMaxDockShapes) then
			frame.config["shape"] = 0;
		end
	end
end

function TrinityChangeTarget(frame, dir)

	local index;

	for i=1, getn(TrinityTargets) do
		if (frame.config["target"] == TrinityTargets[i]) then
			index = i;
			break;
		end
	end

	if (dir == "right") then
		if (index == 1) then
			index = getn(TrinityTargets)
		else
			index = index - 1;
		end
		
		frame.config["target"] = TrinityTargets[index];
		
	elseif (dir == "left") then
		if (index == getn(TrinityTargets)) then
			index = 1;
		else
			index = index + 1;
		end
		
		frame.config["target"] = TrinityTargets[index];
	end	
	
	TrinityUpdateTargeting(frame);
end

function TrinityUpdateTargeting(frame)
	for i=0,9 do		
		local buttonList = {}				
		if (frame.buttonList[i] and frame.buttonList[i] ~= "") then
			string.gsub(frame.buttonList[i], "%d+", function (btn) table.insert(buttonList, btn) end);		
			for i=1,getn(buttonList) do					
				actionButton = getglobal("TrinityActionButton"..buttonList[i]);
				if (frame.config["target"] == "none") then
					actionButton:SetAttribute("useparent-unit", true);
					actionButton:SetAttribute("unit", nil);
				else
					actionButton:SetAttribute("useparent-unit", false);
					actionButton:SetAttribute("unit", frame.config["target"]);
				end
			end
		end
	end
end

-- Function to change the size of buttons
function TrinityUpdateScale(frame, action)

	frame.elapsed = 0;
	
	if (action == "up") then
		frame.config["scale"] = frame.config["scale"] + 0.01;
		if (frame.config["scale"] > 2) then
			frame.config["scale"] = 2;
		end
	else
		frame.config["scale"] = frame.config["scale"] - 0.01;
		if (frame.config["scale"] < 0.2) then
			frame.config["scale"] = 0.2;
		end
	end	
end

-- Function to change the opacity of buttons.
function TrinityUpdateAlpha(frame, action)

	if (action == "up") then
		frame.config["alpha"] = frame.config["alpha"] + 0.05;
		if (frame.config["alpha"] > 1) then
			frame.config["alpha"] = 1;
		end
	else
		frame.config["alpha"] = frame.config["alpha"] - 0.05;
		if (frame.config["alpha"] < 0.1) then
			frame.config["alpha"] = 0.1;
		end
	end	
end

function TrinityAddOnUpdate(frame, elapsed)	

	this.elapsed = this.elapsed + elapsed;
	frame.count = frame.count + elapsed

	if (MouseIsOver(this)) then
		TrinityActionButton_SetTooltip()			
		GameTooltip:SetText("Click to increase casting bar width", 1.0, 1.0, 1.0);
		GameTooltip:Show();
	end
	if ( this:GetButtonState() == "PUSHED" and this.elapsed > 0.15) then
		TrinityCastingBarWidth(frame, "add")
		TrinityUpdateDocking(this:GetParent():GetID());
		this.elapsed = 0;
		PlaySound("UChatScrollButton");
	end
end

function TrinitySubtractOnUpdate(frame, elapsed)

	this.elapsed = this.elapsed + elapsed;
	frame.count = frame.count + elapsed

	if (MouseIsOver(this)) then
		TrinityActionButton_SetTooltip()			
		GameTooltip:SetText("Click to decrease casting bar width", 1.0, 1.0, 1.0);
		GameTooltip:Show();
	end
	if ( this:GetButtonState() == "PUSHED" and this.elapsed > 0.15) then			
		TrinityCastingBarWidth(frame, "subtract")
		TrinityUpdateDocking(this:GetParent():GetID());
		this.elapsed = 0;
		PlaySound("UChatScrollButton");
	end
end

function TrinityAdjustSpacing(frame, dir)

	frame.elapsed = 0;

	if (dir == "add") then
	
		if (this.click == "LeftButton") then
			frame.config["buttonSpaceH"] = frame.config["buttonSpaceH"] + 1;
		else
			frame.config["buttonSpaceV"] = frame.config["buttonSpaceV"] + 1;
		end
		
	else
	
		if (this.click == "LeftButton") then
			frame.config["buttonSpaceH"] = frame.config["buttonSpaceH"] - 1;
		else
			frame.config["buttonSpaceV"] = frame.config["buttonSpaceV"] - 1;
		end
		
	end

end

function TrinityCastingBarWidth(frame, dir)

	frame.elapsed = 0;
	
	local increase = math.ceil(frame.count);
		
	local castBar = TrinityCastingBar:GetName()		
	
	if (frame.config["shape"] == 0) then
		
		if (dir == "add") then
		
			TrinityCastingBar:GetParent():SetWidth(TrinityCastingBar:GetParent():GetWidth()+increase)
		
		else
			if (TrinityCastingBar:GetParent():GetWidth()-increase > 10) then
				TrinityCastingBar:GetParent():SetWidth(TrinityCastingBar:GetParent():GetWidth()-increase)		
			else
				TrinityCastingBar:GetParent():SetWidth(10)		
			end	
		end
		
		frame.config["anchorwidth"] = TrinityCastingBar:GetParent():GetWidth();
		frame.config["anchorheight"] = TrinityCastingBar:GetParent():GetHeight();
		
	elseif (frame.config["shape"] == 1) then
		
		if (dir == "add") then
		
			TrinityCastingBar:GetParent():SetHeight(TrinityCastingBar:GetParent():GetHeight()+increase)

		else
			if (TrinityCastingBar:GetParent():GetHeight()-increase > 10) then
				TrinityCastingBar:GetParent():SetHeight(TrinityCastingBar:GetParent():GetHeight()-increase)
			else
				TrinityCastingBar:GetParent():SetHeight(10)
			end
		end
		
		frame.config["anchorwidth"] = TrinityCastingBar:GetParent():GetWidth();
		frame.config["anchorheight"] = TrinityCastingBar:GetParent():GetHeight();
	end
end

function TrinityCastingBarSetTextures(orient)

	local castBar = TrinityCastingBar:GetName()				

	if (orient == "HORIZONTAL") then

		getglobal(castBar):SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
		TrinityCastingBarDummy:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")				
		getglobal(castBar .. "Spark"):SetHeight(32);
		getglobal(castBar .. "Border"):SetTexture("Interface\\Tooltips\\UI-StatusBar-Border");
		TrinityCastingBarDummyBorder:SetTexture("Interface\\Tooltips\\UI-StatusBar-Border");
		getglobal(castBar .. "Flash"):SetTexture("Interface\\AddOns\\TrinityButtons\\Images\\FlashH");						
		getglobal(castBar .. "Text"):SetFont("Fonts\\FRIZQT__.TTF", 12);
		
		getglobal(castBar .. "Border"):SetPoint("TOPLEFT", -8, 2);
		getglobal(castBar .. "Border"):SetPoint("BOTTOMRIGHT", 8, -2);
		TrinityCastingBarDummyBorder:SetPoint("TOPLEFT", -8, 2);
		TrinityCastingBarDummyBorder:SetPoint("BOTTOMRIGHT", 8, -2);
		getglobal(castBar .. "Flash"):SetPoint("TOPLEFT", -8, 2);
		getglobal(castBar .. "Flash"):SetPoint("BOTTOMRIGHT", 8, -2);
		getglobal(castBar .. "Text"):SetPoint("TOPLEFT", -8, 2);
		getglobal(castBar .. "Text"):SetPoint("BOTTOMRIGHT", 8, -2);		
	end
	
	if (orient == "VERTICAL") then
		
		getglobal(castBar):SetStatusBarTexture("Interface\\AddOns\\TrinityButtons\\Images\\BarFill2V")
		TrinityCastingBarDummy:SetStatusBarTexture("Interface\\AddOns\\TrinityButtons\\Images\\BarFill2V")
		getglobal(castBar .. "Spark"):SetHeight(10);
		getglobal(castBar .. "Border"):SetTexture("Interface\\AddOns\\TrinityButtons\\Images\\UI-StatusBar-BorderV.tga");		
		TrinityCastingBarDummyBorder:SetTexture("Interface\\AddOns\\TrinityButtons\\Images\\UI-StatusBar-BorderV.tga");
		getglobal(castBar .. "Flash"):SetTexture("Interface\\AddOns\\TrinityButtons\\Images\\FlashV.tga");	
		getglobal(castBar .. "Text"):SetFont("Fonts\\ARIALN.TTF", 12);
		
		getglobal(castBar .. "Border"):SetPoint("TOPLEFT", -2, 8);
		getglobal(castBar .. "Border"):SetPoint("BOTTOMRIGHT", 2, -8);
		TrinityCastingBarDummyBorder:SetPoint("TOPLEFT", -2, 8);
		TrinityCastingBarDummyBorder:SetPoint("BOTTOMRIGHT", 2, -8);
		getglobal(castBar .. "Flash"):SetPoint("TOPLEFT", -2, 8);
		getglobal(castBar .. "Flash"):SetPoint("BOTTOMRIGHT", 2, -8);
		getglobal(castBar .. "Text"):SetPoint("TOPLEFT", -2, 8);
		getglobal(castBar .. "Text"):SetPoint("BOTTOMRIGHT", 2, -8);				
	end
end


function TrinityCastingBarOrientation(dockFrame)

	local castBar = TrinityCastingBar:GetName()				
	local width, height;		

	if (dockFrame.config["anchorwidth"] == 0 or not dockFrame.config["anchorwidth"]) then
		width = TrinityCastingBar:GetParent():GetWidth()
	else
		width = dockFrame.config["anchorwidth"];
	end
	
	if (dockFrame.config["anchorheight"] == 0 or not dockFrame.config["anchorheight"]) then
		height = TrinityCastingBar:GetParent():GetHeight()	 
	else
		height = dockFrame.config["anchorheight"];
	end
	 
	if ( (mod(dockFrame.config["shape"],2) == 0 and dockFrame.config["orientation"] == "VERTICAL")) then 				
	
		getglobal(castBar):SetOrientation("HORIZONTAL");
		TrinityCastingBarDummy:SetOrientation("HORIZONTAL");
		TrinityCastingBarSetTextures("HORIZONTAL");
		
		TrinityCastingBar:GetParent():SetWidth(height)	
		TrinityCastingBar:GetParent():SetHeight(width/0.8)
		
		dockFrame.config["anchorwidth"] = TrinityCastingBar:GetParent():GetWidth();
		dockFrame.config["anchorheight"] = TrinityCastingBar:GetParent():GetHeight();
		dockFrame.config["orientation"] = TrinityCastingBar:GetOrientation() 
		dockFrame.config["shape"] = 0;
	end
		
	if ((mod(dockFrame.config["shape"],2) ~= 0 and dockFrame.config["orientation"] == "HORIZONTAL")) then
		
		getglobal(castBar):SetOrientation("VERTICAL");
		TrinityCastingBarDummy:SetOrientation("VERTICAL");
		TrinityCastingBarSetTextures("VERTICAL");
		
		TrinityCastingBar:GetParent():SetWidth(height*0.8)
		TrinityCastingBar:GetParent():SetHeight(width)

		dockFrame.config["anchorwidth"] = TrinityCastingBar:GetParent():GetWidth();
		dockFrame.config["anchorheight"] = TrinityCastingBar:GetParent():GetHeight();	
		dockFrame.config["orientation"] = TrinityCastingBar:GetOrientation() 
		dockFrame.config["shape"] = 1;
	end	
end

function TrinityUpdateRows(frame, action)

	frame.elapsed = 0;
	
	if (action == "up") then
	
		stance = TrinityGetStance(frame);

		frame.config["columns"] = frame.config["columns"] + 1;
		if (frame.config["columns"] > frame.buttonCount[stance]) then
			frame.config["columns"] = frame.buttonCount[stance];
		end
	else
		frame.config["columns"] = frame.config["columns"] - 1;
		if (frame.config["columns"] < 2) then
			frame.config["columns"] = 2;
		end
	end	
end

function TrinityToggleHideShow(dockFrame, offset)

	if (dockFrame.config["hide"] == 0) then		
		if (dockFrame:GetID() == TrinityMiscBars["cast"]) then
			TrinityCastingBarDummy:Hide();	
		end
		local buttonList = {};	
		string.gsub(dockFrame.buttonList[0], "%d+", function (btn) table.insert(buttonList, btn) end);
		for i=1,getn(buttonList) do
			if (offset == 1) then
				if (buttonList[i] ~= "126") then
					getglobal("TrinityActionButton"..buttonList[i]):SetAttribute("showstates","MISCBAR");					
					getglobal("TrinityActionButton"..buttonList[i]).dock = 0;
					MainMenuBarBackpackButton:SetScript("OnClick", function() OpenAllBags() end);
				end
			else
				getglobal("TrinityActionButton"..buttonList[i]):SetAttribute("showstates","MISCBAR");				
				getglobal("TrinityActionButton"..buttonList[i]).dock = 0;
			end
		end
		if (offset == 1) then
			dockFrame.buttonCount[0] = 1;
			dockFrame.anchors[0] = 126;
			dockFrame.lastDocked[0] = 126;
			dockFrame.buttonList[0] = "126,"
		else					
			dockFrame.buttonCount[0] = 0;
			dockFrame.config["hide"] = 1;		
		end		
	else		
		local buttonList = {};	
		local dockNum;
		
		if (dockFrame:GetID() == TrinityMiscBars["bags"]) then
			dockFrame.buttonList[0] = "121";			
			dockNum = TrinityMiscBars["bags"];
			for i=122,126 do
				dockFrame.buttonList[0] = dockFrame.buttonList[0]..","..tostring(i);
			end
		elseif (dockFrame:GetID() == TrinityMiscBars["menu"]) then
			dockFrame.buttonList[0] = "127";
			dockNum = TrinityMiscBars["menu"];
			for i=128,134 do
				dockFrame.buttonList[0] = dockFrame.buttonList[0]..","..tostring(i);
			end		
		elseif (dockFrame:GetID() == TrinityMiscBars["pet"]) then
			dockFrame.buttonList[0] = "135";			
			dockNum = TrinityMiscBars["pet"];
			for i=136,144 do
				dockFrame.buttonList[0] = dockFrame.buttonList[0]..","..tostring(i);
			end		
		elseif (dockFrame:GetID() == TrinityMiscBars["form"]) then
			dockFrame.buttonList[0] = "145";			
			dockNum = TrinityMiscBars["form"];
			if (GetNumShapeshiftForms() > 1) then
				for i=146,144+GetNumShapeshiftForms() do
					dockFrame.buttonList[0] = dockFrame.buttonList[0]..","..tostring(i);
				end			
			end
		elseif (dockFrame:GetID() == TrinityMiscBars["cast"]) then
			dockFrame.buttonList[0] = "155";
			dockNum = TrinityMiscBars["cast"];
			TrinityCastingBarDummy:Show();
		else
			return;
		end
		
		string.gsub(dockFrame.buttonList[0], "%d+", function (btn) table.insert(buttonList, btn) end);			
		for i=1,getn(buttonList) do
			if (offset == 1) then
				MainMenuBarBackpackButton:SetScript("OnClick", function() if (IsShiftKeyDown()) then OpenAllBags() else ToggleBackpack() end end);
			end			
			getglobal("TrinityActionButton"..buttonList[i]):SetAttribute("showstates","0");						
			getglobal("TrinityActionButton"..buttonList[i]).dock = dockNum;
			dockFrame.lastDocked[0] = tonumber(buttonList[i]);
		end
		dockFrame.buttonCount[0] = getn(buttonList);
		dockFrame.anchors[0] = tonumber(buttonList[1]);
		if (offset ~= 1) then
			dockFrame.config["hide"] = 0;		
		end
	end
end

-- Function to add a button to a docking frame.
function TrinityAddButton(frame)

	local stance;
	
	frame.elapsed = 0;
	
	stance = TrinityGetStance(frame);

	for i=1,120 do
	
		actionButton = getglobal("TrinityActionButton"..i);
	
		if (TrinityStowedButtons.buttonIndex[i] == 1) then
			
			actionButton.dock = frame:GetID();
			actionButton:SetAttribute("showstates", tostring(stance));			
			
			if (frame.buttonCount[stance] <= 0) then
				frame.anchors[stance] = i;
			end
			frame.buttonCount[stance] = frame.buttonCount[stance] + 1;
			if (not frame.buttonList[stance] or frame.buttonList[stance] == "") then
				frame.buttonList[stance] = actionButton:GetID()..",";
			else
				frame.buttonList[stance] = frame.buttonList[stance]..actionButton:GetID()..","
			end			
			frame.lastDocked[stance] = i;	
			
			TrinityStowedButtons.buttonIndex[i] = 0;			
			TrinityStowedButtons.buttonCount = TrinityStowedButtons.buttonCount - 1;
			
			getglobal(frame.config["header"]):SetAttribute("addchild", actionButton);				
			
			return;
		end		
	end
	
	UIErrorsFrame:AddMessage("All buttons are being used, no available buttons found.\nRemove buttons from one bar to add to another.", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
end

-- Function to remove a button from a docking frame.
function TrinitySubtractButtons(frame, all)

	local stance;
	
	frame.elapsed = 0;

	stance = TrinityGetStance(frame);
	
	if (frame.buttonCount[stance] < 1) then
		frame.anchors[stance] = 0;
		return;
	end
	
	if (frame.lastDocked[stance] > 120) then
		return;
	end
	
	local count = 1;
	
	if (all) then
		count = frame.buttonCount[stance];
	end
	
	for i=1,count do	
	
		local buttonList = {};	
		string.gsub(frame.buttonList[stance], "%d+", function (btn) table.insert(buttonList, btn) end);		
	
		getglobal("TrinityActionButton"..frame.lastDocked[stance]):SetAttribute("showstates", "TEMP");		
		getglobal("TrinityActionButton"..frame.lastDocked[stance]).dock = 0;
		getglobal("TrinityActionButton"..frame.lastDocked[stance]):ClearAllPoints();
		getglobal("TrinityActionButton"..frame.lastDocked[stance]):SetPoint("CENTER", "TrinityStowedButtons", "CENTER");
		
		TrinityStowedButtons:SetAttribute("addchild", getglobal("TrinityActionButton"..frame.lastDocked[stance]));
		TrinityStowedButtons.buttonIndex[tonumber(frame.lastDocked[stance])] = 1;
		TrinityStowedButtons.buttonCount = TrinityStowedButtons.buttonCount + 1;		
		
		frame.buttonCount[stance] = frame.buttonCount[stance] - 1;		
		frame.lastDocked[stance] = tonumber(buttonList[getn(buttonList)-1]);		
		frame.buttonList[stance] = string.gsub(frame.buttonList[stance], buttonList[getn(buttonList)]..",", "")		
				
		if (frame.buttonCount[stance] == 0) then
			frame.anchors[stance] = 0;
			frame.lastDocked[stance] = 0;			
		end
	end	
end

function TrinityGetShowstate(button)

	dockFrame = getglobal("TrinityDockFrame"..button.dock);

	for showstate=0,9 do
		local buttonList = {};	
		if (not dockFrame.buttonList[showstate] or dockFrame.buttonList[showstate] == "") then
			if (button.laststate and button.laststate ~= "") then
				return button.laststate;
			end
		end		
		string.gsub(dockFrame.buttonList[showstate], "%d+", function (btn) table.insert(buttonList, btn) end);
		for i=1,getn(buttonList) do						
			if (buttonList[i] == tostring(button:GetID())) then
				return tostring(showstate);
			end
		end
	end
	
	return "UNKNOWN";
end

function TrinityHideDocksButtons(startDock, endDock)

	for i=1,120 do		
		if (TrinityPlayerEnteredWorld) then
			local actionButton = getglobal("TrinityActionButton"..i);		
			if (TrinityButtonsHide) then					
				if (not HasAction(i) and TrinityStowedButtons.buttonIndex[i] ~= 1 and not MouseIsOver(actionButton)
				    and not getglobal("TrinityDockFrame"..actionButton.dock.."ShowGrid"):GetChecked()) then			    
				    	if (tonumber(actionButton:GetAttribute("showstates"))) then
				    		if (actionButton:GetAttribute("showstates") ~= "NOACTION") then
				    			actionButton.laststate = actionButton:GetAttribute("showstates")				    		
				    		end
						actionButton:SetAttribute("showstates", "NOACTION");
						--actionButton:Hide();
					end
				end		
			else
				if (tonumber(actionButton.laststate) and actionButton:GetAttribute("showstates") == "NOACTION") then
					actionButton:SetAttribute("showstates", actionButton.laststate);
				end
				
				if (actionButton:GetAttribute("showstates") == tostring(TrinityGetStance(getglobal("TrinityDockFrame"..actionButton.dock)))) then
					actionButton:Show();
				end				
			end			
		end
	end	

	if (startDock and endDock) then
		for i=startDock,endDock do
			local dockFrame = getglobal("TrinityDockFrame"..i);	
		
			if (TrinityDockBarsHide) then				
				dockFrame:Hide();	
				if (getglobal("TrinityProwlOption"..i) and dockFrame.config["header"] == "TrinityStanceButtons" and UnitClass("player") == TRINITY_DRUID) then			
					getglobal("TrinityProwlOption"..i):SetAttribute("showstates", "NOSHOW");
					getglobal("TrinityProwlOption"..i):Hide();
				elseif (getglobal("TrinityProwlOption"..i) and dockFrame.config["header"] == "TrinityHybridStanceButtons" and UnitClass("player") == TRINITY_DRUID) then			
					getglobal("TrinityProwlOption"..i):SetAttribute("showstates", "NOSHOW");					
					getglobal("TrinityProwlOption"..i):Hide();
				end
				getglobal("TrinityHybridOption"..i):SetAttribute("showstates", "NOSHOW");				
				getglobal("TrinityHybridOption"..i):Hide()
				
				if (dockFrame.config["header"] == "TrinityPagedButtons" or dockFrame.config["header"] == "TrinityHybridPagedButtons") then
					local paged = {};
					local pagestates1 = nil;
					local pagestates2 = nil;
					local begin;
					local limit = 0;
					
					if (dockFrame.config["header"] == "TrinityPagedButtons") then
						begin = 1;					
					elseif (dockFrame.config["header"] == "TrinityHybridPagedButtons") then
						begin = 2;
						limit = 1;
						paged[limit] = 1;
					end					
					
					for j=begin,6 do										
						if (dockFrame.buttonCount[j] > 0) then
							if (limit == 0) then
								if (dockFrame.config["header"] == "TrinityHybridPagedButtons") then
									ChangeActionBarPage(1);	
								else
									ChangeActionBarPage(j);								
								end
							end	
							limit = limit + 1;
							paged[limit] = j;							
						end
					end
					
					for j=1,limit do
						if (not pagestates1) then
							pagestates1 = tostring(paged[j])..","
						else
							pagestates1 = pagestates1..tostring(paged[j])..","
						end
					end
					if (pagestates1) then
						pagestates1 = string.gsub(pagestates1, ",$", "");				
					end
					for j=limit,1,-1 do
						if (not pagestates2) then
							pagestates2 = tostring(paged[j])..","
						else
							pagestates2 = pagestates2..tostring(paged[j])..","
						end
					end
					if (pagestates2) then
						pagestates2 = string.gsub(pagestates2, ",$", "");					
					end
					getglobal(dockFrame.config["header"]):SetAttribute("statemap-actionbar", pagestates1..":"..pagestates2);				
				end
			else
			
				for i=0,9 do
					dockFrame.placed[i] = 0;
				end				
				
				if (dockFrame.config["stowed"] == false) then
					dockFrame:Show();				
				
					if (dockFrame.config["header"] == "TrinityStanceButtons") then
						getglobal("TrinityHybridOption"..i):SetAttribute("showstates", "0-9");
						if (getglobal("TrinityProwlOption"..i) and UnitClass("player") == TRINITY_DRUID) then			
							getglobal("TrinityProwlOption"..i):SetAttribute("showstates", tostring(TrinityForms["Cat Form"]));			
							getglobal("TrinityHybridOption"..i):SetAttribute("showstates", "!3,0-9");							
						end							
						getglobal("TrinityHybridOption"..i):Show();
					elseif (dockFrame.config["header"] == "TrinityHybridStanceButtons") then
						getglobal("TrinityHybridOption"..i):SetAttribute("showstates", "0-9");				
						if (getglobal("TrinityProwlOption"..i) and UnitClass("player") == TRINITY_DRUID) then			
							getglobal("TrinityProwlOption"..i):SetAttribute("showstates", tostring(TrinityForms["Cat Form"]));			
							getglobal("TrinityHybridOption"..i):SetAttribute("showstates", "!3,0-9");							
						end						
						getglobal("TrinityHybridOption"..i):Show();
					elseif (dockFrame.config["header"] == "TrinityPagedButtons") then
						getglobal("TrinityHybridOption"..i):SetAttribute("showstates", "0-9");				
						getglobal("TrinityHybridOption"..i):Show();
					elseif (dockFrame.config["header"] == "TrinityHybridPagedButtons") then
						getglobal("TrinityHybridOption"..i):SetAttribute("showstates", "0-9");												
						getglobal("TrinityHybridOption"..i):Show();
					end
				else
					if (not dockFrame.adjusting) then
						dockFrame:Hide();				
					end
				end
				
				if (dockFrame.config["header"] == "TrinityPagedButtons" or dockFrame.config["header"] == "TrinityHybridPagedButtons") then
					getglobal(dockFrame.config["header"]):SetAttribute("statemap-actionbar", "$input");								
				end
			end
		end
	end
	
	TrinitySaveButtonState();		
	TrinityRefreshHeaders();	
end

function TrinityBuildDockButtonList(showstate, dockFrame)

	dockFrame.buttonList[showstate] = ""

	for i=1,155 do	
		local actionButton = getglobal("TrinityActionButton"..i);		
		if (actionButton.dock == dockFrame:GetID()) then
			if (actionButton:GetAttribute("showstates") == tostring(showstate)) then
				if (dockFrame.buttonList[showstate] == "") then
					dockFrame.buttonList[showstate] = tostring(actionButton:GetID())..",";
					dockFrame.anchors[showstate] = actionButton:GetID();
					dockFrame.buttonCount[showstate] = 1;
				else
					dockFrame.buttonList[showstate] = dockFrame.buttonList[showstate]..tostring(actionButton:GetID())..",";
					dockFrame.lastDocked[showstate] = actionButton:GetID();
					dockFrame.buttonCount[showstate] = dockFrame.buttonCount[showstate] + 1;
				end				
			end
		end	
	end
end

-- This is the main function that arranges the buttons based of dock frame settings.
function TrinityUpdateDocking(dockNumber)

	startDock = 1; endDock = TrinityDockFrames;
	
	if (dockNumber) then		
		startDock = dockNumber;
		endDock = dockNumber;
	end
	
	TrinityHideDocksButtons(startDock, endDock)
		
	for i=startDock,endDock do		
		
		local dockFrame = getglobal("TrinityDockFrame"..i);
		local dockFrameName = getglobal("TrinityDockFrame"..i):GetName();
		local dockFrameScale = getglobal("TrinityDockFrame"..i.."Scale");			
		local anchorplaced = {};
		
		for showstate=0,9 do		
			
			local buttonList = {};
			
			anchorplaced[showstate] = false;			
			
			string.gsub(dockFrame.buttonList[showstate], "%d+", function (btn) table.insert(buttonList, btn) end);
			
			for k,v in pairs(buttonList) do						
				local actionButton = getglobal("TrinityActionButton"..v);				
				local width = actionButton:GetWidth();
				local height = 40;
				local pad = 0;
				getglobal(actionButton:GetName().."HotKey"):SetText(actionButton.hotkeytext);		
				getglobal(actionButton:GetName().."HotKeyRound"):SetText(actionButton.hotkeytext);		

				if (TrinityCastingBar:GetOrientation() == "VERTICAL") then					
					height = actionButton:GetHeight();				
				end
		
				if (dockFrame:GetID() == TrinityMiscBars["menu"]) then
					if (dockFrame.buttonCount[showstate] ~= 0) then
						width = 30;
						height = actionButton:GetHeight();
					else
						width = 36;
						height = 40;
					end
				end						
		
				actionButton:SetScale(dockFrame.config["scale"]);
				actionButton:SetAlpha(dockFrame.config["alpha"]);						
			
				actionButton:ClearAllPoints();							
			
				if (not anchorplaced[showstate]) then							
			
					if (dockFrame.config["shape"] == 0) then
						if (dockFrame:GetID() == TrinityMiscBars["menu"]) then
							actionButton:SetPoint("LEFT", dockFrame:GetName(), "CENTER", -((width*(dockFrame.buttonCount[showstate]-1))/2), -4);					
						else
							actionButton:SetPoint("LEFT", dockFrame:GetName(), "CENTER", -(((width*dockFrame.buttonCount[showstate])+(dockFrame.config["buttonSpaceH"]*(dockFrame.buttonCount[showstate]-1)))/2), 0);					
						end
						dockFrame.lastDocked[showstate] = actionButton:GetID();
					elseif (dockFrame.config["shape"] == 1) then
						if (dockFrame:GetID() == TrinityMiscBars["cast"]) then
							actionButton:SetPoint("TOP", dockFrame:GetName(), "CENTER", 0, ((height+dockFrame.config["buttonSpaceV"])*(dockFrame.buttonCount[showstate]))/2) ;
						else
							actionButton:SetPoint("TOP", dockFrame:GetName(), "CENTER", 0, ((height+dockFrame.config["buttonSpaceV"])*(dockFrame.buttonCount[showstate]-1))/2) ;
						end
						dockFrame.lastDocked[showstate] = actionButton:GetID();
					elseif (dockFrame.config["shape"] == 2) then
						if (dockFrame:GetID() == TrinityMiscBars["menu"]) then
							actionButton:SetPoint("TOPLEFT", dockFrame:GetName(), "CENTER", -((width)*((dockFrame.config["columns"]-0.5)/2)), (26)*(math.ceil(dockFrame.buttonCount[showstate]/dockFrame.config["columns"])/2));
						else
							actionButton:SetPoint("TOPLEFT", dockFrame:GetName(), "CENTER", -((width+dockFrame.config["buttonSpaceH"])*(dockFrame.config["columns"]/2)), (height+dockFrame.config["buttonSpaceV"])*((dockFrame.buttonCount[showstate]/dockFrame.config["columns"])/2));
						end
						dockFrame.lastDocked[showstate] = actionButton:GetID();							
						dockFrame.placed[showstate] = 1;
						getglobal(dockFrame:GetName().."IncreaseRows"):Show();
						getglobal(dockFrame:GetName().."DecreaseRows"):Show();
						getglobal(dockFrame:GetName().."Columns"):Show();
						getglobal(dockFrame:GetName().."Rows"):Show();
						dockFrame.multiplier = 1;
					elseif (dockFrame.config["shape"] == 3) then
						dockFrame.placed[showstate] = 90;
						local x = math.floor(((width+dockFrame.config["buttonSpaceH"])*(dockFrame.buttonCount[showstate]/math.pi))*(cos(dockFrame.placed[showstate])));
						local y = math.floor(((width+dockFrame.config["buttonSpaceV"])*(dockFrame.buttonCount[showstate]/math.pi))*(sin(dockFrame.placed[showstate])));
						actionButton:SetPoint("CENTER", dockFrame:GetName(), "CENTER", x, y);
						dockFrame.lastDocked[showstate] = actionButton:GetID();						
					elseif (dockFrame.config["shape"] == 4) then
						dockFrame.placed[showstate] = 180;
						local x = math.floor(((width+dockFrame.config["buttonSpaceH"])*(dockFrame.buttonCount[showstate]/math.pi))*(cos(dockFrame.placed[showstate])));
						local y = math.floor(((width+dockFrame.config["buttonSpaceV"])*(dockFrame.buttonCount[showstate]/math.pi))*(sin(dockFrame.placed[showstate])));
						actionButton:SetPoint("BOTTOM", dockFrame:GetName(), "BOTTOM", x, y+(width/2));
						dockFrame.lastDocked[showstate] = actionButton:GetID();						
					elseif (dockFrame.config["shape"] == 5) then
						dockFrame.placed[showstate] = 180;
						local x = math.floor(((width+dockFrame.config["buttonSpaceH"])*(dockFrame.buttonCount[showstate]/math.pi))*(cos(dockFrame.placed[showstate])));
						local y = math.floor(((width+dockFrame.config["buttonSpaceV"])*(dockFrame.buttonCount[showstate]/math.pi))*(sin(dockFrame.placed[showstate])));
						actionButton:SetPoint("TOP", dockFrame:GetName(), "TOP", x, y-(width/2));
						dockFrame.lastDocked[showstate] = actionButton:GetID();						
					elseif (dockFrame.config["shape"] == 6) then
						dockFrame.placed[showstate] = 90;
						local x = math.floor(((width+dockFrame.config["buttonSpaceH"])*(dockFrame.buttonCount[showstate]/math.pi))*(cos(dockFrame.placed[showstate])));
						local y = math.floor(((width+dockFrame.config["buttonSpaceV"])*(dockFrame.buttonCount[showstate]/math.pi))*(sin(dockFrame.placed[showstate])));
						actionButton:SetPoint("LEFT", dockFrame:GetName(), "LEFT", x+(width/2), y);
						dockFrame.lastDocked[showstate] = actionButton:GetID();						
					elseif (dockFrame.config["shape"] == 7) then
						dockFrame.placed[showstate] = 90;
						local x = math.floor(((width+dockFrame.config["buttonSpaceH"])*(dockFrame.buttonCount[showstate]/math.pi))*(cos(dockFrame.placed[showstate])));
						local y = math.floor(((width+dockFrame.config["buttonSpaceV"])*(dockFrame.buttonCount[showstate]/math.pi))*(sin(dockFrame.placed[showstate])));
						actionButton:SetPoint("RIGHT", dockFrame:GetName(), "RIGHT", x-(width/2), y);
						dockFrame.lastDocked[showstate] = actionButton:GetID();						
					end
					
					anchorplaced[showstate] = true;
					
				else
				
					if (dockFrame.config["shape"] == 0) then
						actionButton:SetPoint("LEFT", getglobal("TrinityActionButton"..dockFrame.lastDocked[showstate]), "RIGHT", dockFrame.config["buttonSpaceH"], 0);							
						dockFrame.lastDocked[showstate] = actionButton:GetID();
					elseif (dockFrame.config["shape"] == 1) then
						actionButton:SetPoint("TOPLEFT", getglobal("TrinityActionButton"..dockFrame.lastDocked[showstate]), "BOTTOMLEFT", 0, -(dockFrame.config["buttonSpaceV"]));
						dockFrame.lastDocked[showstate] = actionButton:GetID();
					elseif (dockFrame.config["shape"] == 2) then						
						if ((dockFrame.config["columns"]*dockFrame.multiplier) == dockFrame.placed[showstate]) then																					
							if (dockFrame:GetID() == TrinityMiscBars["menu"]) then
								actionButton:SetPoint("TOPLEFT", dockFrame:GetName(), "CENTER", -((width)*((dockFrame.config["columns"]-0.5)/2)), (26)*(math.ceil(dockFrame.buttonCount[showstate]/dockFrame.config["columns"])/2)-(((height+dockFrame.config["buttonSpaceV"])*dockFrame.multiplier)));
							else
								actionButton:SetPoint("TOPLEFT", dockFrame:GetName(), "CENTER", -((width+dockFrame.config["buttonSpaceH"])*(dockFrame.config["columns"]/2)), (height+dockFrame.config["buttonSpaceV"])*((dockFrame.buttonCount[showstate]/dockFrame.config["columns"])/2)-(((height+dockFrame.config["buttonSpaceV"])*dockFrame.multiplier)));
							end
							dockFrame.lastDocked[showstate] = actionButton:GetID();							
							dockFrame.placed[showstate] = dockFrame.placed[showstate] + 1;
							dockFrame.multiplier = dockFrame.multiplier + 1;
						else
							actionButton:SetPoint("LEFT", getglobal("TrinityActionButton"..dockFrame.lastDocked[showstate]), "RIGHT", dockFrame.config["buttonSpaceH"], 0);
							dockFrame.lastDocked[showstate] = actionButton:GetID();
							dockFrame.placed[showstate] = dockFrame.placed[showstate] + 1;								
						end
					elseif (dockFrame.config["shape"] == 3) then
						dockFrame.placed[showstate] = dockFrame.placed[showstate] - (360/dockFrame.buttonCount[showstate]);							
						local x = math.floor(((width+dockFrame.config["buttonSpaceH"])*(dockFrame.buttonCount[showstate]/math.pi))*(cos(dockFrame.placed[showstate])));
						local y = math.floor(((width+dockFrame.config["buttonSpaceV"])*(dockFrame.buttonCount[showstate]/math.pi))*(sin(dockFrame.placed[showstate])));
						actionButton:SetPoint("CENTER", dockFrame:GetName(), "CENTER", x, y);
						dockFrame.lastDocked[showstate] = actionButton:GetID();						
					elseif (dockFrame.config["shape"] == 4) then
						dockFrame.placed[showstate] = dockFrame.placed[showstate] - (180/(dockFrame.buttonCount[showstate]-1));							
						local x = math.floor(((width+dockFrame.config["buttonSpaceH"])*(dockFrame.buttonCount[showstate]/math.pi))*(cos(dockFrame.placed[showstate])));
						local y = math.floor(((width+dockFrame.config["buttonSpaceV"])*(dockFrame.buttonCount[showstate]/math.pi))*(sin(dockFrame.placed[showstate])));
						actionButton:SetPoint("BOTTOM", dockFrame:GetName(), "BOTTOM", x, y+(width/2));
						dockFrame.lastDocked[showstate] = actionButton:GetID();						
					elseif (dockFrame.config["shape"] == 5) then
						dockFrame.placed[showstate] = dockFrame.placed[showstate] + (180/(dockFrame.buttonCount[showstate]-1));							
						local x = math.floor(((width+dockFrame.config["buttonSpaceH"])*(dockFrame.buttonCount[showstate]/math.pi))*(cos(dockFrame.placed[showstate])));
						local y = math.floor(((width+dockFrame.config["buttonSpaceV"])*(dockFrame.buttonCount[showstate]/math.pi))*(sin(dockFrame.placed[showstate])));
						actionButton:SetPoint("TOP", dockFrame:GetName(), "TOP", x, y-(width/2));
						dockFrame.lastDocked[showstate] = actionButton:GetID();						
					elseif (dockFrame.config["shape"] == 6) then
						dockFrame.placed[showstate] = dockFrame.placed[showstate] - (180/(dockFrame.buttonCount[showstate]-1));							
						local x = math.floor(((width+dockFrame.config["buttonSpaceH"])*(dockFrame.buttonCount[showstate]/math.pi))*(cos(dockFrame.placed[showstate])));
						local y = math.floor(((width+dockFrame.config["buttonSpaceV"])*(dockFrame.buttonCount[showstate]/math.pi))*(sin(dockFrame.placed[showstate])));
						actionButton:SetPoint("LEFT", dockFrame:GetName(), "LEFT", x+(width/2), y);
						dockFrame.lastDocked[showstate] = actionButton:GetID();						
					elseif (dockFrame.config["shape"] == 7) then
						dockFrame.placed[showstate] = dockFrame.placed[showstate] + (180/(dockFrame.buttonCount[showstate]-1));							
						local x = math.floor(((width+dockFrame.config["buttonSpaceH"])*(dockFrame.buttonCount[showstate]/math.pi))*(cos(dockFrame.placed[showstate])));
						local y = math.floor(((width+dockFrame.config["buttonSpaceV"])*(dockFrame.buttonCount[showstate]/math.pi))*(sin(dockFrame.placed[showstate])));
						actionButton:SetPoint("RIGHT", dockFrame:GetName(), "RIGHT", x-(width/2), y);
						dockFrame.lastDocked[showstate] = actionButton:GetID();						
					end						
				end
			end
		end		
	end	
	
	TrinitySetupDockFrameUpdate()
	
	TrinitySaveButtonState();	
	
	TrinityRefreshHeaders();
end

function TrinitySetupDockFrameUpdate()

	for i=1,TrinityDockFrames do
	
		local dockFrame = getglobal("TrinityDockFrame"..i);				
		local stance = TrinityGetStance(dockFrame);
		local width, height, pad;	
		
		if (dockFrame.buttonCount[stance] > 0) then
			
			if (TrinityDockBarsHide) then
				pad = 0;
			else
				if (dockFrame:GetID() == TrinityMiscBars["cast"]) then	
					pad = 36;
				else
					pad = getglobal("TrinityActionButton"..dockFrame.anchors[stance]):GetWidth()
				end			
			end
			
			if (dockFrame:GetID() == TrinityMiscBars["cast"]) then	
				TrinityCastingBarOrientation(dockFrame)
				if (TrinityCastingBar:GetOrientation() == "VERTICAL") then					
					width = 30;
					height = getglobal("TrinityActionButton"..dockFrame.anchors[stance]):GetHeight()					
				else
					width = getglobal("TrinityActionButton"..dockFrame.anchors[stance]):GetWidth()
					height = 40;
				end
			elseif (dockFrame:GetID() == TrinityMiscBars["menu"]) then			
				width = 30;			
				height = 40;
			else
				width = getglobal("TrinityActionButton"..dockFrame.anchors[stance]):GetWidth()	
				height = 40;
			end
		else
			pad = 36; width = 36; height = 40;			
		end
		
		TrinityUpdateDockFrames(dockFrame, stance, width, height, pad, 6);			
	end
end

function TrinityUpdateBarLabel(dockFrame)

	local targetText;
	local targets = {
		["none"] = "None",
		["player"] = "Self",
		["pet"] = "Pet",
		["target"] = "CurTgt",
		["targettarget"] = "TgtTgt",
		["focus"] = "Focus",
		["party1"] = "Party1",
		["partypet1"] = "P-Pet1",
		["party2"] = "Party2",
		["partypet2"] = "P-Pet2",
		["party3"] = "Party3",
		["partypet3"] = "P-Pet3",
		["party4"] = "Party4",
		["partypet4"] = "P-Pet4",
		["mouseover"] = "Mouse",
	}
	
	targetText = targets[dockFrame.config["target"]];

	if (dockFrame.config["shape"] == 1) then
	
		if (dockFrame.config["header"] == "TrinityStanceButtons") then
			if (dockFrame.mode == 1) then
				getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText("S-"..GetShapeshiftForm());	
			else
				getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText(targetText);	
			end
			getglobal(dockFrame:GetName().."BarType"):SetWidth(28);
		elseif (dockFrame.config["header"] == "TrinityPagedButtons") then
			if (dockFrame.mode == 1) then
				getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText("P-"..GetActionBarPage());		
			else
				getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText(targetText);	
			end
			getglobal(dockFrame:GetName().."BarType"):SetWidth(28);
		elseif (dockFrame.config["header"] == "TrinityHybridStanceButtons") then
			if (dockFrame.mode == 1) then
				getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText("HS-"..GetShapeshiftForm());	
			else
				getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText(targetText);	
			end
			getglobal(dockFrame:GetName().."BarType"):SetWidth(28);
		elseif (dockFrame.config["header"] == "TrinityHybridPagedButtons") then
			if (dockFrame.mode == 1) then
				getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText("HP-"..GetActionBarPage());		
			else
				getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText(targetText);	
			end
			getglobal(dockFrame:GetName().."BarType"):SetWidth(28);			
		elseif (dockFrame:GetID() == TrinityMiscBars["bags"]) then
			getglobal(dockFrame:GetName().."BarNumber"):SetText("Bags");
			getglobal(dockFrame:GetName().."Close"):SetPoint("TOPLEFT", 19, -34);
		elseif (dockFrame:GetID() == TrinityMiscBars["menu"]) then
			getglobal(dockFrame:GetName().."BarNumber"):SetText("Menu");
			getglobal(dockFrame:GetName().."BarNumber"):SetTextHeight(9);
		elseif (dockFrame:GetID() == TrinityMiscBars["pet"]) then
			getglobal(dockFrame:GetName().."BarNumber"):SetText("Pet");	
		elseif (dockFrame:GetID() == TrinityMiscBars["form"]) then
			getglobal(dockFrame:GetName().."BarNumber"):SetText("Form");		
		elseif (dockFrame:GetID() == TrinityMiscBars["cast"]) then
			getglobal(dockFrame:GetName().."BarNumber"):SetText("Cast");		
			getglobal(dockFrame:GetName().."Close"):SetPoint("TOPLEFT", 19, -34);
		else	
			if (dockFrame.mode == 1) then
				getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText("Bar"..dockFrame:GetID());						
			else
				getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText(targetText);	
			end
			getglobal(dockFrame:GetName().."BarType"):SetWidth(28);
		end
		
	elseif (dockFrame.config["shape"] == 2) then
	
		if (dockFrame.config["header"] == "TrinityStanceButtons") then
			if (dockFrame.mode == 1) then
				getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText("S-"..GetShapeshiftForm());
			else
				getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText(targetText);	
			end
			getglobal(dockFrame:GetName().."BarType"):SetWidth(36);
		elseif (dockFrame.config["header"] == "TrinityPagedButtons") then
			if (dockFrame.mode == 1) then
				getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText("P-"..GetActionBarPage());
			else
				getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText(targetText);	
			end
			getglobal(dockFrame:GetName().."BarType"):SetWidth(36);
		elseif (dockFrame.config["header"] == "TrinityHybridStanceButtons") then
			if (dockFrame.mode == 1) then
				getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText("HS-"..GetShapeshiftForm());
			else
				getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText(targetText);	
			end
			getglobal(dockFrame:GetName().."BarType"):SetWidth(36);
		elseif (dockFrame.config["header"] == "TrinityHybridPagedButtons") then
			if (dockFrame.mode == 1) then
				getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText("HP-"..GetActionBarPage());
			else
				getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText(targetText);	
			end
			getglobal(dockFrame:GetName().."BarType"):SetWidth(36);			
		elseif (dockFrame:GetID() == TrinityMiscBars["bags"]) then

		elseif (dockFrame:GetID() == TrinityMiscBars["menu"]) then

		elseif (dockFrame:GetID() == TrinityMiscBars["pet"]) then

		elseif (dockFrame:GetID() == TrinityMiscBars["form"]) then

		elseif (dockFrame:GetID() == TrinityMiscBars["cast"]) then
			
		else	
			if (dockFrame.mode == 1) then
				getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText("Bar"..dockFrame:GetID());						
			else
				getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText(targetText);	
			end
			getglobal(dockFrame:GetName().."BarType"):SetWidth(36);
		end				
	else

		if (dockFrame.config["header"] == "TrinityStanceButtons") then
			if (dockFrame.mode == 1) then
				getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText("Stance-"..GetShapeshiftForm());			
			else
				getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText(targetText);	
			end
			getglobal(dockFrame:GetName().."BarType"):SetWidth(50);
		elseif (dockFrame.config["header"] == "TrinityPagedButtons") then
			if (dockFrame.mode == 1) then
				getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText("Paged-"..GetActionBarPage());
			else
				getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText(targetText);	
			end
			getglobal(dockFrame:GetName().."BarType"):SetWidth(50);
		elseif (dockFrame.config["header"] == "TrinityHybridStanceButtons") then
			if (dockFrame.mode == 1) then
				getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText("HStnce-"..GetShapeshiftForm());			
			else
				getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText(targetText);	
			end
			getglobal(dockFrame:GetName().."BarType"):SetWidth(50);
		elseif (dockFrame.config["header"] == "TrinityHybridPagedButtons") then
			if (dockFrame.mode == 1) then
				getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText("HPgd-"..GetActionBarPage());
			else
				getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText(targetText);	
			end
			getglobal(dockFrame:GetName().."BarType"):SetWidth(50);			
		elseif (dockFrame:GetID() == TrinityMiscBars["bags"]) then		
			getglobal(dockFrame:GetName().."BarNumber"):SetText("Bags");
			getglobal(dockFrame:GetName().."Close"):SetPoint("TOPLEFT", 42, 3);
		elseif (dockFrame:GetID() == TrinityMiscBars["menu"]) then
			getglobal(dockFrame:GetName().."BarNumber"):SetText("Menu");
			getglobal(dockFrame:GetName().."BarNumber"):SetTextHeight(10);
		elseif (dockFrame:GetID() == TrinityMiscBars["pet"]) then
			getglobal(dockFrame:GetName().."BarNumber"):SetText("PetBar");	
		elseif (dockFrame:GetID() == TrinityMiscBars["form"]) then
			getglobal(dockFrame:GetName().."BarNumber"):SetText("FormBar");
		elseif (dockFrame:GetID() == TrinityMiscBars["cast"]) then
			getglobal(dockFrame:GetName().."BarNumber"):SetText("CastBar");	
			getglobal(dockFrame:GetName().."Close"):SetPoint("TOPLEFT", 42, 3);
		else	
			if (dockFrame.mode == 1) then
				getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText("Bar"..dockFrame:GetID());		
			else
				getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText(targetText);	
			end
			getglobal(dockFrame:GetName().."BarType"):SetWidth(50);
		end
	end
end

-- This function sizes the dockframe
function TrinityUpdateDockFrames(dockFrame, stance, width, height, pad, num)

	getglobal(dockFrame:GetName().."Rows"):SetText(dockFrame.config["columns"]);	
	
	if (dockFrame.elapsed < 0.75) then
		dockFrame.update = true;
		return;
	end
	
	if (dockFrame.config["shape"] ~= 2) then
		getglobal(dockFrame:GetName().."IncreaseRows"):Hide();
		getglobal(dockFrame:GetName().."DecreaseRows"):Hide();
		getglobal(dockFrame:GetName().."Columns"):Hide();
		getglobal(dockFrame:GetName().."Rows"):Hide();
	end
	
	if (dockFrame.config["shape"] == 0) then
		getglobal(dockFrame:GetName().."ShowGrid"):SetPoint("TOPLEFT", 43, -1);
	else
		getglobal(dockFrame:GetName().."ShowGrid"):SetPoint("TOPLEFT", 23, -39);
	end

	dockFrame:SetUserPlaced(false);
	local x,y = dockFrame:GetCenter();		
	
	if (dockFrame:GetID() == TrinityMiscBars["menu"]) then
		pad = 18;
		height = 40;
	end
	
	TrinityUpdateBarLabel(dockFrame);
	
	if (dockFrame.config["shape"] == 0) then				
		dockFrame:SetWidth((((width+dockFrame.config["buttonSpaceH"])*dockFrame.buttonCount[stance])*dockFrame.config["scale"])+(pad*4));		
		dockFrame:SetHeight(height);				
	elseif (dockFrame.config["shape"] == 1) then
		if (dockFrame:GetID() == TrinityMiscBars["menu"]) then
			width = 40;
		elseif (dockFrame:GetID() == TrinityMiscBars["pet"]) then
			getglobal(dockFrame:GetName().."BarNumber"):SetText("Pet");	
			width = 36;
		elseif (dockFrame:GetID() == TrinityMiscBars["form"]) then
			width = 36;
		elseif (dockFrame:GetID() == TrinityMiscBars["cast"]) then
			width = 36; pad = 45;
		end
		dockFrame:SetWidth(width*1.4);
		dockFrame:SetHeight((((height+dockFrame.config["buttonSpaceV"])*(dockFrame.buttonCount[stance]))*dockFrame.config["scale"])+(pad*3));			
	elseif (dockFrame.config["shape"] == 2) then
		if (dockFrame:GetID() == TrinityMiscBars["menu"]) then
			dockFrame:SetWidth((((width)*dockFrame.config["columns"])*dockFrame.config["scale"])+(pad*5));
		else
			dockFrame:SetWidth((((width+dockFrame.config["buttonSpaceH"])*dockFrame.config["columns"])*dockFrame.config["scale"])+(pad*3.25));
		end
		if (math.ceil(dockFrame.buttonCount[stance]/dockFrame.config["columns"]) <= 1) then
			dockFrame:SetHeight((height+dockFrame.config["buttonSpaceV"])*2);			
		elseif (dockFrame:GetID() == TrinityMiscBars["menu"]) then
			dockFrame:SetHeight(36*(math.ceil(dockFrame.buttonCount[stance]/dockFrame.config["columns"]))*dockFrame.config["scale"]);
		else
			dockFrame:SetHeight((height+dockFrame.config["buttonSpaceV"])*(math.ceil(dockFrame.buttonCount[stance]/dockFrame.config["columns"]))*dockFrame.config["scale"]+pad);
		end
	elseif (dockFrame.config["shape"] == 3) then
		dockFrame:SetWidth(((((width+dockFrame.config["buttonSpaceH"])*2)*((dockFrame.buttonCount[stance]/math.pi)))*dockFrame.config["scale"])+(pad*3));
		dockFrame:SetHeight(((((height+dockFrame.config["buttonSpaceV"])*2)*((dockFrame.buttonCount[stance]/math.pi)))*dockFrame.config["scale"])+(pad));
	elseif (dockFrame.config["shape"] == 4) then
		dockFrame:SetWidth(((width+dockFrame.config["buttonSpaceH"])*(dockFrame.buttonCount[stance]/math.pi)*dockFrame.config["scale"]*2)+width+(pad*3));
		dockFrame:SetHeight(((height+dockFrame.config["buttonSpaceV"])*(dockFrame.buttonCount[stance]/math.pi)*dockFrame.config["scale"])+(height));
	elseif (dockFrame.config["shape"] == 5) then
		dockFrame:SetWidth(((width+dockFrame.config["buttonSpaceH"])*(dockFrame.buttonCount[stance]/math.pi)*dockFrame.config["scale"]*2)+width+(pad*3));
		dockFrame:SetHeight(((height+dockFrame.config["buttonSpaceV"])*(dockFrame.buttonCount[stance]/math.pi)*dockFrame.config["scale"])+(height));	
	elseif (dockFrame.config["shape"] == 6) then
		dockFrame:SetWidth(((width+dockFrame.config["buttonSpaceH"])*(dockFrame.buttonCount[stance]/math.pi)*dockFrame.config["scale"])+(width*2));
		dockFrame:SetHeight(((height+dockFrame.config["buttonSpaceV"])*(dockFrame.buttonCount[stance]/math.pi)*dockFrame.config["scale"]*2)+height+(pad*3));    
	elseif (dockFrame.config["shape"] == 7) then
		dockFrame:SetWidth(((width+dockFrame.config["buttonSpaceH"])*(dockFrame.buttonCount[stance]/math.pi)*dockFrame.config["scale"])+(width*2));
		dockFrame:SetHeight(((height+dockFrame.config["buttonSpaceV"])*(dockFrame.buttonCount[stance]/math.pi)*dockFrame.config["scale"]*2)+height+(pad*3));    
	end
	
	if (TrinityPlayerEnteredWorld) then		
		dockFrame:ClearAllPoints();
		dockFrame:SetPoint("CENTER","UIParent", "BOTTOMLEFT", x, y);
		dockFrame:SetUserPlaced(true);
	end	
	
	return;

end

function TrinityRefreshHeaders()

	if (UnitClass("player") == TRINITY_DRUID) then
		if (IsStealthed() and GetShapeshiftForm() == TrinityForms["Cat Form"] and TrinityProwlBarActive) then
			SecureStateHeader_Refresh(TrinityStanceButtons, TrinityForms["Prowl"]);			
			SecureStateHeader_Refresh(TrinityHybridStanceButtons, TrinityForms["Prowl"]);			
		elseif (GetShapeshiftForm() == TrinityForms["Aquatic Form"] or  GetShapeshiftForm() == TrinityForms["Flight Form"] or GetShapeshiftForm() == TrinityForms["Travel Form"]) then		
			SecureStateHeader_Refresh(TrinityStanceButtons, "0");			
			SecureStateHeader_Refresh(TrinityHybridStanceButtons, "0");			
		end	
	else		
		SecureStateHeader_Refresh(TrinityStanceButtons, tostring(GetShapeshiftForm()));			
		SecureStateHeader_Refresh(TrinityHybridStanceButtons, tostring(GetShapeshiftForm()));			
	end	

	SecureStateHeader_Refresh(TrinityPagedButtons, tostring(GetActionBarPage()));	
	SecureStateHeader_Refresh(TrinityHybridPagedButtons, tostring(GetActionBarPage()));	

	SecureStateHeader_Refresh(TrinityNormalButtons, "0");
	
	SecureStateHeader_Refresh(TrinityStowedButtons, "100");	
end

-- A function to hide/show buttons on mouseover
function TrinityGhostUpdate(dockFrame)

	if (MouseIsOver(dockFrame) and dockFrame.config["vis"] == 0 and dockFrame.config["hide"] == 0) then				
		local buttonList = {};	
		string.gsub(dockFrame.buttonList[0], "%d+", function (btn) table.insert(buttonList, btn) end);
		for i=1,getn(buttonList) do
			if (getglobal("TrinityActionButton"..buttonList[i]):GetAttribute("showstates") == "GHOST") then										
				getglobal("TrinityActionButton"..buttonList[i]):SetAttribute("showstates", getglobal("TrinityActionButton"..buttonList[i]).laststate);			
				getglobal("TrinityActionButton"..buttonList[i]).laststate = "GHOST";							
				getglobal("TrinityActionButton"..buttonList[i]):SetAlpha(dockFrame.config["alpha"]);				
			end			
		end
		TrinityRefreshHeaders()
		dockFrame.config["vis"] = 1;		
	end
	
	if (not MouseIsOver(dockFrame) and dockFrame.config["vis"] == 1) then		
		local buttonList = {};	
		string.gsub(dockFrame.buttonList[0], "%d+", function (btn) table.insert(buttonList, btn) end);			
		for i=1,getn(buttonList) do
			if (getglobal("TrinityActionButton"..buttonList[i]):GetAttribute("showstates") ~= "GHOST") then
				getglobal("TrinityActionButton"..buttonList[i]).laststate = getglobal("TrinityActionButton"..buttonList[i]):GetAttribute("showstates");			
				getglobal("TrinityActionButton"..buttonList[i]):SetAttribute("showstates","GHOST");
				getglobal("TrinityActionButton"..buttonList[i]):SetAlpha(0);
			end			
		end
		TrinityRefreshHeaders()
		dockFrame.config["vis"] = 0;		
	end
end

-- This function updates each button with visual elements
function Trinity_UpdateButton()

	if (not TrinityPlayerEnteredWorld) then
		return;
	end

	local icon = getglobal(this:GetName().."IconFrame".."Icon");
	local normalTexture = getglobal(this:GetName().."NormalTexture");
	local border = getglobal(this:GetName().."Border");
	local flashTexture = getglobal(this:GetName().."Flash");
	local count = getglobal(this:GetName().."Count");
	local macroName = getglobal(this:GetName().."Name");
	local id = this:GetID();	
	
	local isUsable, notEnoughMana = IsUsableAction(id);
	
	if ( isUsable ) then
		if ( IsActionInRange(id) == 0) then
			icon:SetVertexColor(0.8, 0.1, 0.1);			
		else
			icon:SetVertexColor(1.0, 1.0, 1.0);			
		end
	elseif ( notEnoughMana ) then
		icon:SetVertexColor(0.2, 0.2, 0.9);		
	else
		icon:SetVertexColor(0.3, 0.3, 0.3);		
	end
     		
	if ( HasAction(id) ) then
		local texture = GetActionTexture(id);
		icon:SetTexture(texture);
		icon:SetTexCoord(0,1,0,1);
		if (getglobal("TrinityDockFrame"..this.dock).config["style"] == 1) then
			this:SetNormalTexture("Interface\\Buttons\\UI-Quickslot2");
		elseif (getglobal("TrinityDockFrame"..this.dock).config["style"] == 3) then
			this:SetNormalTexture("");
			icon:SetTexCoord(0.08,0.92,0.08,0.92);
		end
		normalTexture:SetVertexColor(1,1,1,1);
		icon:Show();		
	else	
		if (getglobal("TrinityDockFrame"..this.dock).config["style"] == 1 or  getglobal("TrinityDockFrame"..this.dock).config["style"] == 3) then					
			this:SetNormalTexture("Interface\\Buttons\\UI-Quickslot");					
		end
		normalTexture:SetVertexColor(1,1,1,0.35);
		icon:Hide();
	end
	
	if ( IsEquippedAction(id) ) then
		border:SetVertexColor(0, 1.0, 0, 0.5);
		border:Show();
	else
		border:Hide();
	end
	
	
	if ( IsConsumableAction(id) ) then
		count:SetText(GetActionCount(id));
	else
		count:SetText("");
	end
	
	if ( IsCurrentAction(id) or IsAutoRepeatAction(id) ) then
		this:SetChecked(1);
	else
		this:SetChecked(0);
	end	
	
	macroName:SetText(GetActionText(id));	
	

end

function Trinity_UpdateButton_OnEvent()

	local id = this:GetID();
	local cooldown = getglobal(this:GetName().."IconFrame".."Cooldown");
	local cooldowntext=getglobal(this:GetName().."CooldownText");
	local cooldowntexthuge=getglobal(this:GetName().."CooldownTextHuge");	
	local start, duration, enable = GetActionCooldown(id);	

	--cooldown code courtesy of hacocuk from Curse Gaming
	if (TrinityCoolDown) then
		if ( start > 0 and duration > 4 and enable > 0) then			
			local cd=math.ceil(duration-(GetTime()-start));		
			if (cd<6) then
				cooldowntext:Hide()
				cooldowntexthuge:Show()				
			else
				cooldowntext:Show()
				cooldowntexthuge:Hide()						
			end				
			if(cd>60) then
				cd=ceil(cd/60);
				cd=cd.."m";
			end		
			cooldowntexthuge:SetText(cd);
			cooldowntext:SetText(cd);
		else
			cooldowntext:SetText("");
			cooldowntexthuge:SetText("");		
		end		
	end
		
	CooldownFrame_SetTimer(cooldown, start, duration, enable);	
end


function TrinityChooseButtonStyle(dockFrame)

	if (dockFrame.config["style"] == 1) then
	
		dockFrame.config["style"] = 2;		
		TrinitySwapTextures(dockFrame)
		
	elseif (dockFrame.config["style"] == 2) then
	
		dockFrame.config["style"] = 3;
		TrinitySwapTextures(dockFrame)
		
	elseif (dockFrame.config["style"] == 3) then
	
		dockFrame.config["style"] = 1;
		TrinitySwapTextures(dockFrame)
	end	
	
end

function TrinitySwapTextures(dockFrame)

	for i=0,9 do	

		local defaultElement = {} 		
		local buttonList = {}		

		if (dockFrame.buttonList[i] ~= "") then

			string.gsub(dockFrame.buttonList[i], "%d+", function (btn) table.insert(buttonList, btn) end);		

			if (dockFrame.config["style"] == 1) then

				if (dockFrame:GetID() == TrinityMiscBars["bags"]) then

					defaultElement[1] = CharacterBag2Slot:GetName();	
					defaultElement[2] = CharacterBag3Slot:GetName();
					defaultElement[3] = CharacterBag1Slot:GetName();
					defaultElement[4] = CharacterBag0Slot:GetName();
					defaultElement[5] = MainMenuBarBackpackButton:GetName();	
					defaultElement[6] = TrinityBagDoodads:GetName();

					for i=1,6 do
						getglobal(defaultElement[i]):SetNormalTexture("Interface\\Buttons\\UI-Quickslot2")
						getglobal(defaultElement[i].."NormalTexture"):SetWidth(60);
						getglobal(defaultElement[i].."NormalTexture"):SetHeight(60);
						getglobal(defaultElement[i].."NormalTexture"):ClearAllPoints();
						getglobal(defaultElement[i].."NormalTexture"):SetPoint("CENTER",0,0);												
						getglobal(defaultElement[i]):SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");			
						getglobal(defaultElement[i]):SetCheckedTexture("Interface\\Buttons\\CheckButtonHilight");			
						getglobal(defaultElement[i]):SetPushedTexture("Interface\\Buttons\\UI-Quickslot-Depress");									
						getglobal(defaultElement[i]):CreateTexture("$parentSheen", "OVERLAY", "TrinityCheckButtonSheenTemplate");						
						getglobal(defaultElement[i].."Sheen"):SetTexture("");
						if (i~=6) then
							getglobal(defaultElement[i].."IconTexture"):ClearAllPoints();
							getglobal(defaultElement[i].."IconTexture"):SetPoint("TOPLEFT",0,0);		
							getglobal(defaultElement[i].."IconTexture"):SetPoint("BOTTOMLEFT",0,0);		
							getglobal(defaultElement[i].."IconTexture"):SetPoint("TOPRIGHT",0,0);		
							getglobal(defaultElement[i].."IconTexture"):SetPoint("BOTTOMRIGHT",0,0);		
						else
							KeyRingButton:SetScale(1);
							KeyRingButton:SetFrameStrata("LOW");
							KeyRingButton:SetPoint("CENTER", "TrinityBagDoodads", "LEFT", 27, 0); 	 				
							TrinityLatencyBarFrame:SetScale(1);
							TrinityLatencyBarFrame:SetFrameStrata("LOW");
							TrinityLatencyBarFrame:SetPoint("CENTER", "TrinityBagDoodads", "CENTER", -9, 0);	
						end			
					end		

				elseif (dockFrame:GetID() == TrinityMiscBars["pet"]) then

					for i=1,10 do

						local _, _, _, _, _, autoCastAllowed, autoCastEnabled = GetPetActionInfo(i);

						defaultElement[i] = getglobal("PetActionButton"..i):GetName();			

						getglobal(defaultElement[i]):SetNormalTexture("Interface\\Buttons\\UI-Quickslot2")
						getglobal(defaultElement[i].."NormalTexture2"):SetWidth(60);
						getglobal(defaultElement[i].."NormalTexture2"):SetHeight(60);			
						getglobal(defaultElement[i].."NormalTexture2"):ClearAllPoints();
						getglobal(defaultElement[i].."NormalTexture2"):SetPoint("CENTER",0,0);									
						getglobal(defaultElement[i].."Border"):SetTexture("Interface\\Buttons\\UI-ActionButton-Border");
						getglobal(defaultElement[i].."Border"):SetWidth(60);
						getglobal(defaultElement[i].."Border"):SetHeight(60);			
						getglobal(defaultElement[i]):SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");			
						getglobal(defaultElement[i]):SetCheckedTexture("Interface\\Buttons\\CheckButtonHilight");			
						getglobal(defaultElement[i]):SetPushedTexture("Interface\\Buttons\\UI-Quickslot-Depress");						
						getglobal(defaultElement[i]):CreateTexture("$parentSheen", "OVERLAY", "TrinityCheckButtonSheenTemplate");			
						getglobal(defaultElement[i].."Sheen"):SetTexture("");
						getglobal(defaultElement[i].."Cooldown"):ClearAllPoints();
						getglobal(defaultElement[i].."Cooldown"):SetPoint("BOTTOMLEFT",0, 0);		
						getglobal(defaultElement[i].."Cooldown"):SetScale(0.83);
						getglobal(defaultElement[i].."Cooldown"):SetFrameStrata("LOW");						
						if ( autoCastAllowed ) then
							getglobal(defaultElement[i].."AutoCastable"):Show();
						else
							getglobal(defaultElement[i].."AutoCastable"):Hide();
						end
						if ( autoCastEnabled ) then
							getglobal(defaultElement[i].."AutoCast"):Show();
						else
							getglobal(defaultElement[i].."AutoCast"):Hide();
						end				
						getglobal(defaultElement[i].."AutoCastSim"):SetTexture("");						
						getglobal(defaultElement[i].."AutoCastable"):SetTexture("Interface\Buttons\UI-AutoCastableOverlay");
						getglobal(defaultElement[i].."Icon"):ClearAllPoints();
						getglobal(defaultElement[i].."Icon"):SetPoint("TOPLEFT",0,0);		
						getglobal(defaultElement[i].."Icon"):SetPoint("BOTTOMLEFT",0,0);		
						getglobal(defaultElement[i].."Icon"):SetPoint("TOPRIGHT",0,0);		
						getglobal(defaultElement[i].."Icon"):SetPoint("BOTTOMRIGHT",0,0);			
						getglobal(defaultElement[i].."HotKey"):Show();
						getglobal(defaultElement[i].."HotKey"):SetPoint("TOPLEFT", -1, -5);
						getglobal(defaultElement[i].."Count"):SetTextHeight(14);
						getglobal(defaultElement[i].."Count"):SetPoint("BOTTOMRIGHT", -2, 2);				
					end		

				elseif (dockFrame:GetID() == TrinityMiscBars["form"]) then

					for i=1,10 do

						defaultElement[i] = getglobal("ShapeshiftButton"..i):GetName();			

						getglobal(defaultElement[i]):SetNormalTexture("")
						getglobal(defaultElement[i].."NormalTexture"):SetWidth(60);
						getglobal(defaultElement[i].."NormalTexture"):SetHeight(60);			
						getglobal(defaultElement[i].."NormalTexture"):ClearAllPoints();
						getglobal(defaultElement[i].."NormalTexture"):SetPoint("CENTER",0,0);									
						getglobal(defaultElement[i].."Border"):SetTexture("Interface\\Buttons\\UI-ActionButton-Border");
						getglobal(defaultElement[i].."Border"):SetWidth(60);
						getglobal(defaultElement[i].."Border"):SetHeight(60);			
						getglobal(defaultElement[i]):SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");			
						getglobal("TrinitySpellBinderButton"..i+12):SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");			
						getglobal(defaultElement[i]):SetCheckedTexture("Interface\\Buttons\\CheckButtonHilight");			
						getglobal(defaultElement[i]):SetPushedTexture("Interface\\Buttons\\UI-Quickslot-Depress");						
						getglobal(defaultElement[i]):CreateTexture("$parentSheen", "OVERLAY", "TrinityCheckButtonSheenTemplate");			
						getglobal(defaultElement[i].."Sheen"):SetTexture("");
						getglobal(defaultElement[i].."Cooldown"):ClearAllPoints();
						getglobal(defaultElement[i].."Cooldown"):SetPoint("BOTTOMLEFT",0, 0);		
						getglobal(defaultElement[i].."Cooldown"):SetScale(0.83);
						getglobal(defaultElement[i].."Cooldown"):SetFrameStrata("LOW");			
						getglobal(defaultElement[i].."Icon"):ClearAllPoints();
						getglobal(defaultElement[i].."Icon"):SetPoint("TOPLEFT",0,0);		
						getglobal(defaultElement[i].."Icon"):SetPoint("BOTTOMLEFT",0,0);		
						getglobal(defaultElement[i].."Icon"):SetPoint("TOPRIGHT",0,0);		
						getglobal(defaultElement[i].."Icon"):SetPoint("BOTTOMRIGHT",0,0);			
						getglobal(defaultElement[i].."HotKey"):Show()
						getglobal(defaultElement[i].."HotKeyRound"):Hide()
						getglobal(defaultElement[i].."Count"):SetTextHeight(14);
						getglobal(defaultElement[i].."Count"):SetPoint("BOTTOMRIGHT", -2, 2);		
					end	

				elseif (dockFrame:GetID() == TrinityMiscBars["menu"]) then

				elseif (dockFrame:GetID() == TrinityMiscBars["cast"]) then			

				else
					for i=1,getn(buttonList) do					
						actionButton = getglobal("TrinityActionButton"..buttonList[i]);

						actionButton:SetNormalTexture("Interface\\Buttons\\UI-Quickslot2")
						getglobal(actionButton:GetName().."NormalTexture"):SetWidth(60);
						getglobal(actionButton:GetName().."NormalTexture"):SetHeight(60);			
						getglobal(actionButton:GetName().."Border"):SetTexture("Interface\\Buttons\\UI-ActionButton-Border");
						getglobal(actionButton:GetName().."Border"):SetWidth(60);
						getglobal(actionButton:GetName().."Border"):SetHeight(60);			
						actionButton:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");			
						getglobal("TrinityActionButton"..i.."BindFrame"):SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");			
						actionButton:SetCheckedTexture("Interface\\Buttons\\CheckButtonHilight");			
						actionButton:SetPushedTexture("Interface\\Buttons\\UI-Quickslot-Depress");			
						getglobal(actionButton:GetName().."Sheen"):SetTexture("");			
						getglobal(actionButton:GetName().."IconFrame"):SetWidth(36);
						getglobal(actionButton:GetName().."IconFrame"):SetHeight(36);			
						getglobal(actionButton:GetName().."IconFrame".."Cooldown"):SetPoint("TOPLEFT",0,0)
						getglobal(actionButton:GetName().."IconFrame".."Cooldown"):SetPoint("BOTTOMRIGHT",0,0)
						getglobal(actionButton:GetName().."HotKey"):Show()
						getglobal(actionButton:GetName().."HotKeyRound"):Hide()
						getglobal(actionButton:GetName().."Count"):SetTextHeight(14);
						getglobal(actionButton:GetName().."Count"):SetPoint("BOTTOMRIGHT", -2, 2);
						
					end	
				end

			elseif (dockFrame.config["style"] == 2) then

				if (OmniCC) then
					if (OmniCC.size > 16) then
						OmniCC.size = 16;
					end
				end	

				if (dockFrame:GetID() == TrinityMiscBars["bags"]) then	

					defaultElement[1] = CharacterBag2Slot:GetName();	
					defaultElement[2] = CharacterBag3Slot:GetName();
					defaultElement[3] = CharacterBag1Slot:GetName();
					defaultElement[4] = CharacterBag0Slot:GetName();
					defaultElement[5] = MainMenuBarBackpackButton:GetName();
					defaultElement[6] = TrinityBagDoodads:GetName();

					for i=1,6 do
						getglobal(defaultElement[i]):SetNormalTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButton.tga")
						getglobal(defaultElement[i].."NormalTexture"):SetWidth(36);
						getglobal(defaultElement[i].."NormalTexture"):SetHeight(36);
						getglobal(defaultElement[i].."NormalTexture"):ClearAllPoints();
						getglobal(defaultElement[i].."NormalTexture"):SetPoint("TOP",0,-0.5);												
						getglobal(defaultElement[i]):SetHighlightTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonHiLight.tga");			
						getglobal(defaultElement[i]):SetCheckedTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonChecked.tga");			
						getglobal(defaultElement[i]):SetPushedTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonPushed.tga");						
						getglobal(defaultElement[i]):CreateTexture("$parentSheen", "OVERLAY", "TrinityCheckButtonSheenTemplate");
						getglobal(defaultElement[i].."Sheen"):SetTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonSheen.tga");
						if (i~=6) then
							getglobal(defaultElement[i].."IconTexture"):ClearAllPoints();
							getglobal(defaultElement[i].."IconTexture"):SetPoint("TOPLEFT",7,-7);		
							getglobal(defaultElement[i].."IconTexture"):SetPoint("BOTTOMLEFT",7,6);		
							getglobal(defaultElement[i].."IconTexture"):SetPoint("TOPRIGHT",-7,-7);		
							getglobal(defaultElement[i].."IconTexture"):SetPoint("BOTTOMRIGHT",7,6);
						else
							KeyRingButton:SetScale(0.7);
							KeyRingButton:SetFrameStrata("LOW");
							KeyRingButton:SetPoint("CENTER", "TrinityBagDoodads", "LEFT", 34, 0); 	 				
							TrinityLatencyBarFrame:SetScale(0.7);
							TrinityLatencyBarFrame:SetFrameStrata("LOW");
							TrinityLatencyBarFrame:SetPoint("CENTER", "TrinityBagDoodads", "CENTER", -7, 0);	
						end
					end

				elseif (dockFrame:GetID() == TrinityMiscBars["pet"]) then

					for i=1,10 do

						defaultElement[i] = getglobal("PetActionButton"..i):GetName();			

						getglobal(defaultElement[i]):SetNormalTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButton.tga")
						getglobal(defaultElement[i].."NormalTexture2"):SetWidth(32);
						getglobal(defaultElement[i].."NormalTexture2"):SetHeight(32);			
						getglobal(defaultElement[i].."NormalTexture2"):ClearAllPoints();
						getglobal(defaultElement[i].."NormalTexture2"):SetPoint("TOP",0,1);									
						getglobal(defaultElement[i].."Border"):SetTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonBorder.tga");
						getglobal(defaultElement[i].."Border"):SetWidth(36);
						getglobal(defaultElement[i].."Border"):SetHeight(36);			
						getglobal(defaultElement[i]):SetHighlightTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonHiLight.tga");			
						getglobal(defaultElement[i]):SetCheckedTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonChecked.tga");			
						getglobal(defaultElement[i]):SetPushedTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonPushed.tga");			
						getglobal(defaultElement[i]):CreateTexture("$parentSheen", "OVERLAY", "TrinityCheckButtonSheenTemplate");
						getglobal(defaultElement[i].."Sheen"):SetTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonSheen.tga");
						getglobal(defaultElement[i].."Cooldown"):ClearAllPoints();
						getglobal(defaultElement[i].."Cooldown"):SetPoint("BOTTOMLEFT",12, 12);		
						getglobal(defaultElement[i].."Cooldown"):SetScale(0.5);
						getglobal(defaultElement[i].."Cooldown"):SetFrameStrata("LOW");
						getglobal(defaultElement[i].."Cooldown"):SetFrameLevel(1);			
						getglobal(defaultElement[i].."AutoCast"):Hide()
						getglobal(defaultElement[i].."AutoCastable"):SetTexture("");						
						getglobal(defaultElement[i].."AutoCastSim"):SetTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonChecked.tga");						
						getglobal(defaultElement[i].."Icon"):ClearAllPoints();
						getglobal(defaultElement[i].."Icon"):SetPoint("TOPLEFT",5,-5);		
						getglobal(defaultElement[i].."Icon"):SetPoint("BOTTOMLEFT",5, 5);		
						getglobal(defaultElement[i].."Icon"):SetPoint("TOPRIGHT",-5,-5);		
						getglobal(defaultElement[i].."Icon"):SetPoint("BOTTOMRIGHT",5,5);			
						getglobal(defaultElement[i].."HotKey"):SetTextHeight(10);
						getglobal(defaultElement[i].."HotKey"):SetPoint("TOPLEFT", -6, -6);
						getglobal(defaultElement[i].."Count"):SetTextHeight(10);
						getglobal(defaultElement[i].."Count"):SetPoint("BOTTOMRIGHT", -6, 5);				
					end		

				elseif (dockFrame:GetID() == TrinityMiscBars["form"]) then

					for i=1,10 do

						defaultElement[i] = getglobal("ShapeshiftButton"..i):GetName();			

						getglobal(defaultElement[i]):SetNormalTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButton.tga")
						getglobal(defaultElement[i].."NormalTexture"):SetWidth(32);
						getglobal(defaultElement[i].."NormalTexture"):SetHeight(32);			
						getglobal(defaultElement[i].."NormalTexture"):ClearAllPoints();
						getglobal(defaultElement[i].."NormalTexture"):SetPoint("TOP",0,1);												
						getglobal(defaultElement[i].."Border"):SetTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonBorder.tga");
						getglobal(defaultElement[i].."Border"):SetWidth(36);
						getglobal(defaultElement[i].."Border"):SetHeight(36);			
						getglobal(defaultElement[i]):SetHighlightTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonHiLight.tga");			
						getglobal("TrinitySpellBinderButton"..i+12):SetHighlightTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonHiLight.tga");			
						getglobal(defaultElement[i]):SetCheckedTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonChecked.tga");			
						getglobal(defaultElement[i]):SetPushedTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonPushed.tga");			
						getglobal(defaultElement[i]):CreateTexture("$parentSheen", "OVERLAY", "TrinityCheckButtonSheenTemplate");
						getglobal(defaultElement[i].."Sheen"):SetTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonSheen.tga");
						getglobal(defaultElement[i].."Cooldown"):ClearAllPoints();
						getglobal(defaultElement[i].."Cooldown"):SetPoint("BOTTOMLEFT",12, 12);		
						getglobal(defaultElement[i].."Cooldown"):SetScale(0.5);
						getglobal(defaultElement[i].."Cooldown"):SetFrameStrata("LOW");
						getglobal(defaultElement[i].."Cooldown"):SetFrameLevel(1);
						getglobal(defaultElement[i].."Icon"):ClearAllPoints();
						getglobal(defaultElement[i].."Icon"):SetPoint("TOPLEFT",5,-5);		
						getglobal(defaultElement[i].."Icon"):SetPoint("BOTTOMLEFT",5, 5);		
						getglobal(defaultElement[i].."Icon"):SetPoint("TOPRIGHT",-5,-5);		
						getglobal(defaultElement[i].."Icon"):SetPoint("BOTTOMRIGHT",5,5);			
						getglobal(defaultElement[i].."HotKey"):Hide()
						getglobal(defaultElement[i].."HotKeyRound"):Show()
						getglobal(defaultElement[i].."Count"):SetTextHeight(10);
						getglobal(defaultElement[i].."Count"):SetPoint("BOTTOMRIGHT", -6, 5);				
					end		

				elseif (dockFrame:GetID() == TrinityMiscBars["menu"]) then

				elseif (dockFrame:GetID() == TrinityMiscBars["cast"]) then			

				else

					for i=1,getn(buttonList) do					
						actionButton = getglobal("TrinityActionButton"..buttonList[i]);

						actionButton:SetNormalTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButton.tga")
						getglobal(actionButton:GetName().."NormalTexture"):SetWidth(36);
						getglobal(actionButton:GetName().."NormalTexture"):SetHeight(36);			
						getglobal(actionButton:GetName().."Border"):SetTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonBorder.tga");
						getglobal(actionButton:GetName().."Border"):SetWidth(36);
						getglobal(actionButton:GetName().."Border"):SetHeight(36);			
						actionButton:SetHighlightTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonHiLight.tga");			
						getglobal("TrinityActionButton"..i.."BindFrame"):SetHighlightTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonHiLight.tga");			
						actionButton:SetCheckedTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonChecked.tga");			
						actionButton:SetPushedTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonPushed.tga");			
						getglobal(actionButton:GetName().."Sheen"):SetTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonSheen.tga");			
						getglobal(actionButton:GetName().."IconFrame"):SetWidth(25);
						getglobal(actionButton:GetName().."IconFrame"):SetHeight(25);
						getglobal(actionButton:GetName().."IconFrame".."Cooldown"):SetPoint("TOPLEFT",3,-3)
						getglobal(actionButton:GetName().."IconFrame".."Cooldown"):SetPoint("BOTTOMRIGHT",-3,3)
						getglobal(actionButton:GetName().."HotKey"):Hide()
						getglobal(actionButton:GetName().."HotKeyRound"):Show()
						getglobal(actionButton:GetName().."Count"):SetTextHeight(10);
						getglobal(actionButton:GetName().."Count"):SetPoint("BOTTOM", 0, 0);											
					end						
				end

			elseif (dockFrame.config["style"] == 3) then

				if (dockFrame:GetID() == TrinityMiscBars["bags"]) then

					defaultElement[1] = CharacterBag2Slot:GetName();	
					defaultElement[2] = CharacterBag3Slot:GetName();
					defaultElement[3] = CharacterBag1Slot:GetName();
					defaultElement[4] = CharacterBag0Slot:GetName();
					defaultElement[5] = MainMenuBarBackpackButton:GetName();	
					defaultElement[6] = TrinityBagDoodads:GetName();

					for i=1,6 do
						getglobal(defaultElement[i]):SetNormalTexture("")
						getglobal(defaultElement[i].."NormalTexture"):SetWidth(60);
						getglobal(defaultElement[i].."NormalTexture"):SetHeight(60);
						getglobal(defaultElement[i].."NormalTexture"):ClearAllPoints();
						getglobal(defaultElement[i].."NormalTexture"):SetPoint("CENTER",0,0);												
						getglobal(defaultElement[i]):SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");			
						getglobal(defaultElement[i]):SetCheckedTexture("Interface\\Buttons\\CheckButtonHilight");			
						getglobal(defaultElement[i]):SetPushedTexture("Interface\\Buttons\\UI-Quickslot-Depress");									
						getglobal(defaultElement[i]):CreateTexture("$parentSheen", "OVERLAY", "TrinityCheckButtonSheenTemplate");						
						getglobal(defaultElement[i].."Sheen"):SetTexture("");
						if (i~=6) then
							getglobal(defaultElement[i].."IconTexture"):ClearAllPoints();
							getglobal(defaultElement[i].."IconTexture"):SetPoint("TOPLEFT",0,0);		
							getglobal(defaultElement[i].."IconTexture"):SetPoint("BOTTOMLEFT",0,0);		
							getglobal(defaultElement[i].."IconTexture"):SetPoint("TOPRIGHT",0,0);		
							getglobal(defaultElement[i].."IconTexture"):SetPoint("BOTTOMRIGHT",0,0);		
						else
							KeyRingButton:SetScale(1);
							KeyRingButton:SetFrameStrata("LOW");
							KeyRingButton:SetPoint("CENTER", "TrinityBagDoodads", "LEFT", 27, 0); 	 				
							TrinityLatencyBarFrame:SetScale(1);
							TrinityLatencyBarFrame:SetFrameStrata("LOW");
							TrinityLatencyBarFrame:SetPoint("CENTER", "TrinityBagDoodads", "CENTER", -9, 0);	
						end			
					end

				elseif (dockFrame:GetID() == TrinityMiscBars["pet"]) then

					for i=1,10 do

						local _, _, _, _, _, autoCastAllowed, autoCastEnabled = GetPetActionInfo(i);

						defaultElement[i] = getglobal("PetActionButton"..i):GetName();			

						getglobal(defaultElement[i]):SetNormalTexture("")
						getglobal(defaultElement[i].."NormalTexture2"):SetWidth(60);
						getglobal(defaultElement[i].."NormalTexture2"):SetHeight(60);			
						getglobal(defaultElement[i].."NormalTexture2"):ClearAllPoints();
						getglobal(defaultElement[i].."NormalTexture2"):SetPoint("CENTER",0,0);									
						getglobal(defaultElement[i].."Border"):SetTexture("Interface\\Buttons\\UI-ActionButton-Border");
						getglobal(defaultElement[i].."Border"):SetWidth(60);
						getglobal(defaultElement[i].."Border"):SetHeight(60);			
						getglobal(defaultElement[i]):SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");			
						getglobal(defaultElement[i]):SetCheckedTexture("Interface\\Buttons\\CheckButtonHilight");			
						getglobal(defaultElement[i]):SetPushedTexture("Interface\\Buttons\\UI-Quickslot-Depress");						
						getglobal(defaultElement[i]):CreateTexture("$parentSheen", "OVERLAY", "TrinityCheckButtonSheenTemplate");			
						getglobal(defaultElement[i].."Sheen"):SetTexture("");
						getglobal(defaultElement[i].."Cooldown"):ClearAllPoints();
						getglobal(defaultElement[i].."Cooldown"):SetPoint("BOTTOMLEFT",0, 0);		
						getglobal(defaultElement[i].."Cooldown"):SetScale(0.83);
						getglobal(defaultElement[i].."Cooldown"):SetFrameStrata("MEDIUM");						
						if ( autoCastAllowed ) then
							getglobal(defaultElement[i].."AutoCastable"):Show();
						else
							getglobal(defaultElement[i].."AutoCastable"):Hide();
						end
						if ( autoCastEnabled ) then
							getglobal(defaultElement[i].."AutoCast"):Show();
						else
							getglobal(defaultElement[i].."AutoCast"):Hide();
						end											
						getglobal(defaultElement[i].."AutoCastSim"):SetTexture("");						
						getglobal(defaultElement[i].."AutoCastable"):SetTexture("Interface\Buttons\UI-AutoCastableOverlay");
						getglobal(defaultElement[i].."Icon"):ClearAllPoints();
						getglobal(defaultElement[i].."Icon"):SetPoint("TOPLEFT",0,0);		
						getglobal(defaultElement[i].."Icon"):SetPoint("BOTTOMLEFT",0,0);		
						getglobal(defaultElement[i].."Icon"):SetPoint("TOPRIGHT",0,0);		
						getglobal(defaultElement[i].."Icon"):SetPoint("BOTTOMRIGHT",0,0);			
						getglobal(defaultElement[i].."HotKey"):SetTextHeight(12);
						getglobal(defaultElement[i].."HotKey"):SetPoint("TOPLEFT", -1, -5);
						getglobal(defaultElement[i].."Count"):SetTextHeight(14);
						getglobal(defaultElement[i].."Count"):SetPoint("BOTTOMRIGHT", -2, 2);				
					end				

				elseif (dockFrame:GetID() == TrinityMiscBars["form"]) then

					for i=1,10 do

						defaultElement[i] = getglobal("ShapeshiftButton"..i):GetName();			

						getglobal(defaultElement[i]):SetNormalTexture("")
						getglobal(defaultElement[i].."NormalTexture"):SetWidth(60);
						getglobal(defaultElement[i].."NormalTexture"):SetHeight(60);			
						getglobal(defaultElement[i].."NormalTexture"):ClearAllPoints();
						getglobal(defaultElement[i].."NormalTexture"):SetPoint("CENTER",0,0);									
						getglobal(defaultElement[i].."Border"):SetTexture("Interface\\Buttons\\UI-ActionButton-Border");
						getglobal(defaultElement[i].."Border"):SetWidth(60);
						getglobal(defaultElement[i].."Border"):SetHeight(60);			
						getglobal(defaultElement[i]):SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");			
						getglobal("TrinitySpellBinderButton"..i+12):SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");			
						getglobal(defaultElement[i]):SetCheckedTexture("Interface\\Buttons\\CheckButtonHilight");			
						getglobal(defaultElement[i]):SetPushedTexture("Interface\\Buttons\\UI-Quickslot-Depress");						
						getglobal(defaultElement[i]):CreateTexture("$parentSheen", "OVERLAY", "TrinityCheckButtonSheenTemplate");			
						getglobal(defaultElement[i].."Sheen"):SetTexture("");
						getglobal(defaultElement[i].."Cooldown"):ClearAllPoints();
						getglobal(defaultElement[i].."Cooldown"):SetPoint("BOTTOMLEFT",0, 0);		
						getglobal(defaultElement[i].."Cooldown"):SetScale(0.83);
						getglobal(defaultElement[i].."Cooldown"):SetFrameStrata("MEDIUM");			
						getglobal(defaultElement[i].."Icon"):ClearAllPoints();
						getglobal(defaultElement[i].."Icon"):SetPoint("TOPLEFT",0,0);		
						getglobal(defaultElement[i].."Icon"):SetPoint("BOTTOMLEFT",0,0);		
						getglobal(defaultElement[i].."Icon"):SetPoint("TOPRIGHT",0,0);		
						getglobal(defaultElement[i].."Icon"):SetPoint("BOTTOMRIGHT",0,0);			
						getglobal(defaultElement[i].."HotKey"):Show()
						getglobal(defaultElement[i].."HotKeyRound"):Hide()
						getglobal(defaultElement[i].."Count"):SetTextHeight(14);
						getglobal(defaultElement[i].."Count"):SetPoint("BOTTOMRIGHT", -2, 2);		
					end	

				elseif (dockFrame:GetID() == TrinityMiscBars["menu"]) then

				elseif (dockFrame:GetID() == TrinityMiscBars["cast"]) then			

				else

					for i=1,getn(buttonList) do					
						actionButton = getglobal("TrinityActionButton"..buttonList[i]);

						actionButton:SetNormalTexture("")
						getglobal(actionButton:GetName().."NormalTexture"):SetWidth(60);
						getglobal(actionButton:GetName().."NormalTexture"):SetHeight(60);			
						getglobal(actionButton:GetName().."Border"):SetTexture("Interface\\Buttons\\UI-ActionButton-Border");
						getglobal(actionButton:GetName().."Border"):SetWidth(60);
						getglobal(actionButton:GetName().."Border"):SetHeight(60);			
						actionButton:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");			
						getglobal("TrinityActionButton"..i.."BindFrame"):SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");			
						actionButton:SetCheckedTexture("Interface\\Buttons\\CheckButtonHilight");			
						actionButton:SetPushedTexture("Interface\\Buttons\\UI-Quickslot-Depress");			
						getglobal(actionButton:GetName().."Sheen"):SetTexture("");			
						getglobal(actionButton:GetName().."IconFrame"):SetWidth(36);
						getglobal(actionButton:GetName().."IconFrame"):SetHeight(36);		
						getglobal(actionButton:GetName().."IconFrame".."Cooldown"):SetPoint("TOPLEFT",0,0)
						getglobal(actionButton:GetName().."IconFrame".."Cooldown"):SetPoint("BOTTOMRIGHT",0,0)
						getglobal(actionButton:GetName().."HotKey"):Show()
						getglobal(actionButton:GetName().."HotKeyRound"):Hide()
						getglobal(actionButton:GetName().."Count"):SetTextHeight(14);
						getglobal(actionButton:GetName().."Count"):SetPoint("BOTTOMRIGHT", -2, 2);															
					end	
				end
			end
		end
	end

	TrinityShapeshiftBar_UpdateState()

	TrinityPetActionBar_Update()

	TrinityUpdateDocking();		

	
end	

-- A function to determine where the mouse is located for the binding tool.
function TrinitySetBindingOnUpdate(elapsed)

	if (this.elapsedTime) then
		this.elapsedTime = this.elapsedTime + elapsed;
	else
		this.elapsedTime = elapsed;
	end
	
	if (this.reminder) then
		this.reminder = this.reminder + elapsed;
	else
		this.reminder = elapsed;
	end
	
	if (this.elapsedTime < 0.1) then
		return;
	end	
	
	if (this.reminder > 20) then
		UIErrorsFrame:AddMessage("Key Binding is Active.", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);												
		this.reminder = nil;
	end	
	
	this.elapsedTime = nil;	
	
	if (TrinityKeyBindButton == 0) then
	
		local obj = GetMouseFocus();
		local frame, id;
	
		if (obj and obj:GetName()) then
			frame = obj:GetName();
			id = obj:GetID();		
			if (string.find(frame, "TrinityActionButton")) then
				this:EnableKeyboard(true);				
				GameTooltip:AddLine("\nHit a key to bind it to |cff00ff00Action Button "..id.."|r", 1.0, 1.0, 1.0);
				GameTooltip:AddLine("Hit |cfff00000ESC|r to clear this button's current binding", 1.0, 1.0, 1.0);
				TrinityKeyBindButton = id;				
			end
		end			
	end
	
	if (not TrinityKeyBindSpell) then
	
		local obj = GetMouseFocus();
		local frame, id;
	
		if (obj and obj:GetName()) then
			frame = obj:GetName();
			id = obj:GetID();		
			if (string.find(frame, "TrinitySpellBinderButton")) then
				if (string.find(obj:GetParent():GetName(), "SpellButton") and getglobal(obj:GetParent():GetName().."IconTexture"):IsVisible()) then
					local spellid = SpellBook_GetSpellID(id);
					local spellName, subSpellName = GetSpellName(spellid, SpellBookFrame.bookType);
					local texture = GetSpellTexture(spellid, SpellBookFrame.bookType);					
					if (spellName) then
						this:EnableKeyboard(true);				
						if (subSpellName) then					
							GameTooltip:AddLine("\n Hit a key to bind it to |cff00ff00"..spellName.."("..subSpellName..")|r", 1.0, 1.0, 1.0);	
							GameTooltip:AddLine(" Hit |cfff00000ESC|r to clear this spell's binding", 1.0, 1.0, 1.0);																				
							TrinityKeyBindSpell = spellid..spellName.."("..subSpellName..")";
						else
							GameTooltip:AddLine("\n Hit a key to bind it to |cff00ff00"..spellName.."()|r", 1.0, 1.0, 1.0);	
							GameTooltip:AddLine(" Hit |cfff00000ESC|r to clear this spell's binding", 1.0, 1.0, 1.0);																				
							TrinityKeyBindSpell = spellid..spellName.."()";
						end
					end
				elseif (string.find(obj:GetParent():GetName(), "ShapeshiftButton")) then
			 		local _, formName, _ = GetShapeshiftFormInfo(obj:GetID()-12); 														
					this:EnableKeyboard(true);				
					GameTooltip:AddLine("\n Hit a key to bind it to |cff00ff00"..formName.."()|r", 1.0, 1.0, 1.0);	
					GameTooltip:AddLine(" Hit |cfff00000ESC|r to clear this form's binding", 1.0, 1.0, 1.0);																				
					TrinityKeyBindSpell = formName.."()";				
				end
			end
		end
	end
	
	GameTooltip:Show();
end

-- The main function to bind keys to buttons.
function TrinitySetBinding(bindkey, modifier, spell)	

	local key;
	local keytext;
	local stance = 0;	
	
	if (modifier) then
		key = modifier..bindkey;
		
		if (string.find(bindkey, "BUTTON")) then
			keytext = string.lower(string.gsub(modifier, "(%a)(%a+)", "%1"))..string.gsub(bindkey,"(%a+)(%A)","m%2");			
		elseif (string.find(bindkey, "NUMPAD")) then
			keytext = string.lower(string.gsub(modifier, "(%a)(%a+)", "%1"))..string.gsub(bindkey,"NUMPAD","n");			
			keytext = string.gsub(keytext,"DIVIDE","/");
			keytext = string.gsub(keytext,"MULTIPLY","*");
			keytext = string.gsub(keytext,"MINUS","-");
			keytext = string.gsub(keytext,"PLUS","+");
			keytext = string.gsub(keytext,"DECIMAL",".");			
		elseif (string.find(bindkey, "MOUSEWHEEL")) then			
			keytext = string.lower(string.gsub(modifier, "(%a)(%a+)", "%1"))..string.gsub(bindkey,"MOUSEWHEEL","mw");			
			keytext = string.gsub(keytext,"UP","U"); 
			keytext = string.gsub(keytext,"DOWN","D");
		else
			keytext = string.lower(string.gsub(modifier, "(%a)(%a+)", "%1"))..bindkey;  
		end
	else
		key = bindkey;
		
		if (string.find(bindkey, "BUTTON")) then
			keytext = string.gsub(bindkey,"(%a+)(%A)","m%2");			
		elseif (string.find(bindkey, "NUMPAD")) then			
			keytext = string.gsub(bindkey,"NUMPAD","n");			
			keytext = string.gsub(keytext,"DIVIDE","/");
			keytext = string.gsub(keytext,"MULTIPLY","*");
			keytext = string.gsub(keytext,"MINUS","-");
			keytext = string.gsub(keytext,"PLUS","+");
			keytext = string.gsub(keytext,"DECIMAL",".");			
		elseif (string.find(bindkey, "MOUSEWHEEL")) then			
			keytext = string.gsub(bindkey,"MOUSEWHEEL","mw");			
			keytext = string.gsub(keytext,"UP","U"); 
			keytext = string.gsub(keytext,"DOWN","D");
		else
			keytext = bindkey;
		end
	end
	
	if (bindkey == "ESCAPE") then
		key = "";
		keytext = "";						
	end	
	
	for k,v in pairs(TrinitySpellBindings) do
		if (v == key) then
			TrinitySpellBindings[k] = "";			
		end
		if (v == keytext) then
			TrinitySpellBindings[k] = "";
		end
	end				
	
	if (spell) then
		actionButton = TrinityActionButton0;		
		actionButtonHotkey = getglobal(actionButton:GetName().."HotKey");
		if (TrinitySpellBindings[spell]) then
			SetOverrideBindingSpell(TrinityStowedButtons, false, TrinitySpellBindings[spell], "");		
			ClearOverrideBindings(TrinityStowedButtons);
		end
		TrinitySpellBindings[spell] = key; 
		TrinitySpellBindings[spell.."-HotKey"] = keytext; 				
	else
		actionButton = getglobal("TrinityActionButton"..TrinityKeyBindButton);
		actionButtonHotkey = getglobal(actionButton:GetName().."HotKey");
		if (actionButton.hotkey) then
			SetOverrideBinding(TrinityStowedButtons, false, actionButton.hotkey, nil);									
			SetBinding(actionButton.hotkey, nil);
			ClearOverrideBindings(TrinityStowedButtons);		
		end				
	end
	
	if (actionButton ~= TrinityActionButton0) then	
		stance = TrinityGetStance(getglobal("TrinityDockFrame"..actionButton.dock));
	end
	
	actionButtonHotkey:SetText(keytext);
	actionButton.hotkey = key;
	actionButton.hotkeytext = keytext;	

	for i=1,120 do
		if (i ~= actionButton:GetID()) then
			if (getglobal("TrinityActionButton"..i).dock == actionButton.dock) then
				if (getglobal("TrinityActionButton"..i):GetAttribute("showstates") == actionButton:GetAttribute("showstates")) then			
					if (getglobal("TrinityActionButton"..i).hotkey == key) then					
						local header = getglobal("TrinityDockFrame"..getglobal("TrinityActionButton"..i).dock).config["header"];
						if (header) then
							SetOverrideBinding(getglobal(header), false, getglobal("TrinityActionButton"..i).hotkey, nil)						
						end
						SetBinding(getglobal("TrinityActionButton"..i).hotkey, nil)					
						getglobal("TrinityActionButton"..i).hotkey = "";
						getglobal("TrinityActionButton"..i).hotkeytext = "";
						getglobal("TrinityActionButton"..i.."HotKey"):SetText("");
						getglobal("TrinityActionButton"..i.."HotKeyRound"):SetText("");
					end
				else			
					local buttonList = {};				
					for i=0,9 do
						buttonList[i] = {};
						string.gsub(getglobal("TrinityDockFrame"..actionButton.dock).buttonList[i], "%d+", function (btn) table.insert(buttonList[i], btn) end);
					end				
					for k,v in pairs(buttonList[stance]) do					
						if (v == tostring(actionButton:GetID())) then					
							for i=0,9 do
								if (i~=stance) then							
									local found = nil;
									for key,value in pairs(buttonList[i]) do
										if (getglobal("TrinityActionButton"..v).hotkey == getglobal("TrinityActionButton"..value).hotkey) then
											found = true;										
										end
									end	
									if (not found) then
										if (buttonList[i][k]) then																		
											if (not getglobal("TrinityActionButton"..buttonList[i][k]).hotkey or getglobal("TrinityActionButton"..buttonList[i][k]).hotkey == "") then
												TrinitySetStateBindings(getglobal("TrinityActionButton"..buttonList[i][k]), key)
												getglobal("TrinityActionButton"..buttonList[i][k]).hotkey = key;
												getglobal("TrinityActionButton"..buttonList[i][k]).hotkeytext = keytext;
												getglobal("TrinityActionButton"..buttonList[i][k].."HotKey"):SetText(keytext);						
												getglobal("TrinityActionButton"..buttonList[i][k].."HotKeyRound"):SetText(keytext);						
											end
										end
									end
								end
							end
						end					
					end
				end		
			
			elseif (getglobal("TrinityActionButton"..i).hotkey == key) then
			
				local dockFrame = getglobal("TrinityDockFrame"..getglobal("TrinityActionButton"..i).dock);
				local header1 = getglobal("TrinityDockFrame"..actionButton.dock).config["header"]
				local header2 = getglobal("TrinityDockFrame"..getglobal("TrinityActionButton"..i).dock).config["header"];
				
				if (header1 and header2) then
					if (header1 == "TrinityHybridStanceButtons" and header2 == "TrinityHybridPagedButtons") then
						TrinitySetStateBindings(getglobal("TrinityActionButton"..i), key);
					elseif (header1 == "TrinityHybridPagedButtons" and header2 == "TrinityHybridStanceButtons") then
						TrinitySetStateBindings(getglobal("TrinityActionButton"..i), key);
					else	
						if (header2) then
							SetOverrideBinding(getglobal(header2), false, getglobal("TrinityActionButton"..i).hotkey, nil)										
						end
						SetBinding(getglobal("TrinityActionButton"..i).hotkey, nil)
						getglobal("TrinityActionButton"..i).hotkey = "";
						getglobal("TrinityActionButton"..i).hotkeytext = "";
						getglobal("TrinityActionButton"..i.."HotKey"):SetText("");				
						getglobal("TrinityActionButton"..i.."HotKeyRound"):SetText("");				
					end				
				else
					SetBinding(getglobal("TrinityActionButton"..i).hotkey, nil)
					getglobal("TrinityActionButton"..i).hotkey = "";
					getglobal("TrinityActionButton"..i).hotkeytext = "";
					getglobal("TrinityActionButton"..i.."HotKey"):SetText("");				
					getglobal("TrinityActionButton"..i.."HotKeyRound"):SetText("");				
				end
			end				
		end		
	end	
	
	SetBinding(key, nil);		
	
	if (key and not spell) then				
		SetBindingClick(key, actionButton:GetName());								
	end
	
	if (spell) then	
		SetBindingSpell(key, spell);						
	end		
	
	TrinityUpdateBindings();	
end

-- A function to initialize bindings at login and also to update all bindings after a new binding is made.
function TrinityClearBindingKeys()

	for i=1,120 do	
		local actionButton = getglobal("TrinityActionButton"..i);
		if (actionButton.hotkey and actionButton.hotkey ~= "") then
			SetBinding(actionButton.hotkey, nil);
		end
	end
	
	for key, value in pairs(TrinitySpellBindings) do
		if (not string.find(key, "-HotKey")) then
			SetBinding(key, nil);			
		end
	end	
end


function TrinityUpdateBindings()

	if (not TrinityPlayerEnteredWorld) then	
		TrinityClearBindingKeys()
	end
	
	for i=1,120 do
	
		local actionButton = getglobal("TrinityActionButton"..i);
		
		if (actionButton.dock) then
		
			if (actionButton.hotkey) then					
		
				TrinitySetStateBindings(actionButton, actionButton.hotkey);	
				
				if (getglobal("TrinityDockFrame"..actionButton.dock).config["header"] == "TrinityStanceButtons") then
					if (string.find(actionButton:GetAttribute("showstates"), "^"..tostring(GetShapeshiftForm()).."$")) then
						SetBindingClick(actionButton.hotkey, actionButton:GetName());							
					end										
				elseif (getglobal("TrinityDockFrame"..actionButton.dock).config["header"] == "TrinityPagedButtons") then
					if (string.find(actionButton:GetAttribute("showstates"), "^"..tostring(GetActionBarPage()).."$")) then
						SetBindingClick(actionButton.hotkey, actionButton:GetName());													
					end										
				elseif (getglobal("TrinityDockFrame"..actionButton.dock).config["header"] == "TrinityHybridStanceButtons") then
					if (string.find(actionButton:GetAttribute("showstates"), "^"..tostring(GetShapeshiftForm()).."$")) then
						SetBindingClick(actionButton.hotkey, actionButton:GetName());							
					end										
				elseif (getglobal("TrinityDockFrame"..actionButton.dock).config["header"] == "TrinityHybridPagedButtons") then
					if (string.find(actionButton:GetAttribute("showstates"), "^"..tostring(GetActionBarPage()).."$")) then
						SetBindingClick(actionButton.hotkey, actionButton:GetName());													
					end																
				elseif (getglobal("TrinityDockFrame"..actionButton.dock).config["header"] == "TrinityNormalButtons") then
					if (string.find(actionButton:GetAttribute("showstates"), "^0$")) then
						SetBindingClick(actionButton.hotkey, actionButton:GetName());													
					end					
				end
			end
		end

	end
	
	for key, value in pairs(TrinitySpellBindings) do
		if (not string.find(key, "-HotKey")) then
			SetBindingSpell(value, key);			
		end
	end
	
 	for i=1,GetNumShapeshiftForms() do 		 		
 		local _, formName, _ = GetShapeshiftFormInfo(i); 		 		
 		getglobal("ShapeshiftButton"..i.."HotKey"):SetText();								
 		getglobal("ShapeshiftButton"..i.."HotKeyRound"):SetText();								
		formName = formName.."()-HotKey";
		for k,v in pairs(TrinitySpellBindings) do
			if (k == formName) then
				getglobal("ShapeshiftButton"..i.."HotKey"):SetText(v);								
				getglobal("ShapeshiftButton"..i.."HotKeyRound"):SetText(v);								
			end
		end 		
 	end		
 	
 	SaveBindings(GetCurrentBindingSet());  
 	
 	TrinityRefreshHeaders();
 	
 	TrinitySaveButtonState();
end

-- A function to set which state a button will show based on the button header's state.
function TrinitySetStateBindings(actionButton, key)

	if (string.find(actionButton:GetAttribute("showstates"), "^0$")) then
		actionButton:SetAttribute("bindings-zero", key);
	end
	if (string.find(actionButton:GetAttribute("showstates"), "^1$")) then
		actionButton:SetAttribute("bindings-one", key);
	end
	if (string.find(actionButton:GetAttribute("showstates"), "^2$")) then
		actionButton:SetAttribute("bindings-two", key);
	end
	if (string.find(actionButton:GetAttribute("showstates"), "^3$")) then
		actionButton:SetAttribute("bindings-three", key);
	end
	if (string.find(actionButton:GetAttribute("showstates"), "^4$")) then
		actionButton:SetAttribute("bindings-four", key);
	end
	if (string.find(actionButton:GetAttribute("showstates"), "^5$")) then
		actionButton:SetAttribute("bindings-five", key);
	end
	if (string.find(actionButton:GetAttribute("showstates"), "^6$")) then
		actionButton:SetAttribute("bindings-six", key);
	end
	if (string.find(actionButton:GetAttribute("showstates"), "^7$")) then
		actionButton:SetAttribute("bindings-seven", key);
	end
	if (string.find(actionButton:GetAttribute("showstates"), "^8$")) then
		actionButton:SetAttribute("bindings-eight", key);
	end
	if (string.find(actionButton:GetAttribute("showstates"), "^9$")) then
		actionButton:SetAttribute("bindings-nine", key);
	end
	
	return;
end

-- Function to move the minimap icon
function TrinityButtons_IconDraggingFrame_OnUpdate(arg1)

	local pos;
	local xpos,ypos = GetCursorPosition();
	local xmin,ymin = Minimap:GetLeft(), Minimap:GetBottom();

	xpos = xmin-xpos/Minimap:GetEffectiveScale()+70;
	ypos = ypos/Minimap:GetEffectiveScale()-ymin-70;

	pos = math.deg(math.atan2(ypos,xpos));	
	
	xpos = 80*cos(pos);
	ypos = 80*sin(pos);	

	TrinityBarsMinimapButton:SetPoint("TOPLEFT","Minimap","TOPLEFT",52-xpos,ypos-55);
	TrinityBarsMinimapButton:SetUserPlaced(true);
	TrinityButtonsButtonLoc = { 50-xpos, ypos-54 };
end



function TrinitySaveButtonState()

	if (TrinityButtonsSavedState["Docks"]) then		
		for i=1,TrinityDockFrames do
			dockFrame = getglobal("TrinityDockFrame"..i);		
			TrinityButtonsSavedState["Docks"][i] = { dockFrame.anchors, dockFrame.lastDocked, dockFrame.buttonCount, dockFrame.buttonList, dockFrame.config, dockFrame:GetCenter() };
		end
	end

	if (TrinityButtonsSavedState["Buttons"]) then			
		for i=1,155 do
			actionButton = getglobal("TrinityActionButton"..i);		
			TrinityButtonsSavedState["Buttons"][i] = { actionButton.dock, actionButton.anchor, actionButton:GetAttribute("showstates"), actionButton.hotkey, actionButton.hotkeytext, actionButton.laststate };		
		end
	end	
	
	if (TrinityButtonsSavedState["StowageDock"]) then
		TrinityButtonsSavedState["StowageDock"] = { TrinityStowedButtons.buttonIndex, TrinityStowedButtons.buttonCount, TrinityStowedButtons.buttonList, };		
	end
	
	TrinitySavedVersion = TrinityCurrentVersion;
end

-- Function to save the settings of docks and buttons to the variables that will be saved.
function TrinityLoadSV()

	if (not TrinityButtonsSavedState["Docks"]) then		
		TrinityButtonsSavedState["Docks"] = {};
	else
		for i=1,TrinityDockFrames do
		
			local dockFrame = getglobal("TrinityDockFrame"..i);
			
			if (TrinityButtonsSavedState["Docks"][i]) then
			
				if (TrinityButtonsSavedState["Docks"][i][1]) then
					dockFrame.anchors = TrinityButtonsSavedState["Docks"][i][1];
				end
				if (TrinityButtonsSavedState["Docks"][i][2]) then
					dockFrame.lastDocked = TrinityButtonsSavedState["Docks"][i][2];
				end
				if (TrinityButtonsSavedState["Docks"][i][3]) then
					dockFrame.buttonCount = TrinityButtonsSavedState["Docks"][i][3];			
				end
				if (TrinityButtonsSavedState["Docks"][i][4]) then
					dockFrame.buttonList = TrinityButtonsSavedState["Docks"][i][4];			
				end
				if (TrinityButtonsSavedState["Docks"][i][5]) then
					dockFrame.config = TrinityButtonsSavedState["Docks"][i][5];
				end
				if (TrinityButtonsSavedState["Docks"][i][6]) then
					dockFrame.centerx = TrinityButtonsSavedState["Docks"][i][6];			
				end
				if (TrinityButtonsSavedState["Docks"][i][7]) then
					dockFrame.centery = TrinityButtonsSavedState["Docks"][i][7];			
				end
			end
			
			-- added for changed variables
			if (not dockFrame.config["buttonSpaceH"]) then
				dockFrame.config["buttonSpaceH"] = 3;
			end
			
			if (not dockFrame.config["buttonSpaceV"]) then
				dockFrame.config["buttonSpaceV"] = 3;
			end
			
			if (not dockFrame.config["style"]) then
				dockFrame.config["style"] = 1;
			end		
			
			if (not dockFrame.config["target"]) then
				dockFrame.config["target"] = "none";
			end						
			
			if (not dockFrame.config["paged"]) then
				dockFrame.config["paged"] = "1,2,3,4,5,6";
			end					
			
			if (not dockFrame.config["hybrid"]) then
				dockFrame.config["hybrid"] = nil;
			end	
			
			if (not dockFrame.config["stowed"]) then
				dockFrame.config["stowed"] = false;
			end							
			-- added for changed variables
		end
	end
	
	if (not	TrinityButtonsSavedState["Buttons"]) then
		TrinityButtonsSavedState["Buttons"] = {};
	else
		for i=1,155 do			
		
			local actionButton = getglobal("TrinityActionButton"..i);
			
			if (TrinityButtonsSavedState["Buttons"][i]) then			
				if (TrinityButtonsSavedState["Buttons"][i][1]) then
				
					-- added for changed variables
					if (TrinityButtonsSavedState["Buttons"][i][1] == 99) then
						actionButton.dock = 0;
					else
						actionButton.dock = TrinityButtonsSavedState["Buttons"][i][1];
					end
					-- added for changed variables
					
					dockFrame = getglobal("TrinityDockFrame"..actionButton.dock);					
					if (type(dockFrame.config) == "table") then
						if (dockFrame.config["header"] == "TrinityStanceButtons" or
						    dockFrame.config["header"] == "TrinityHybridStanceButtons" or	
						    dockFrame.config["header"] == "TrinityPagedButtons" or
						    dockFrame.config["header"] == "TrinityHybridPagedButtons" or
				    		    dockFrame.config["header"] == "TrinityNormalButtons") then
							getglobal(dockFrame.config["header"]):SetAttribute("addchild", actionButton);
						end
					end
				end
				if (TrinityButtonsSavedState["Buttons"][i][2]) then
					actionButton.anchor = TrinityButtonsSavedState["Buttons"][i][2];
				end
				if (TrinityButtonsSavedState["Buttons"][i][3]) then
				
					-- added for changed variables
					if (string.find(TrinityButtonsSavedState["Buttons"][i][3], "0,")) then
						actionButton:SetAttribute("showstates", TrinityGetShowstate(actionButton));
					elseif (string.find(TrinityButtonsSavedState["Buttons"][i][3], "10-9")) then
						actionButton:SetAttribute("showstates", "UNKNOWN");						
					-- added for changed variables
					
					else
						actionButton:SetAttribute("showstates", TrinityButtonsSavedState["Buttons"][i][3]);
					end
				end
				if (TrinityButtonsSavedState["Buttons"][i][4]) then
					actionButton.hotkey = TrinityButtonsSavedState["Buttons"][i][4];
				end
				if (TrinityButtonsSavedState["Buttons"][i][5]) then
					actionButton.hotkeytext = TrinityButtonsSavedState["Buttons"][i][5];				
				end
				if (TrinityButtonsSavedState["Buttons"][i][6]) then
				
					-- added for changed variables				
					if (string.find(TrinityButtonsSavedState["Buttons"][i][6], "0,")) then
						actionButton.laststate = TrinityGetShowstate(actionButton);
					elseif (string.find(TrinityButtonsSavedState["Buttons"][i][6], "10-9")) then
						actionButton.laststate = "UNKNOWN";
					-- added for changed variables	
						
					else
						actionButton.laststate = TrinityButtonsSavedState["Buttons"][i][6];				
					end
				end							
			end
			
			actionButton:Show();
		end
	end
	
	
	-- added for changed variables
	if (TrinityButtonsSavedState["TempDock"]) then
		if (TrinityButtonsSavedState["TempDock"][1]) then
			TrinityStowedButtons.buttonIndex = TrinityButtonsSavedState["TempDock"][1];
		end
		if (TrinityButtonsSavedState["TempDock"][2]) then
			TrinityStowedButtons.buttonCount = TrinityButtonsSavedState["TempDock"][2];			
		end
		
		TrinityButtonsSavedState["TempDock"] = {}
	end
	-- added for changed variables
	
	
	if (not	TrinityButtonsSavedState["StowageDock"]) then
		TrinityButtonsSavedState["StowageDock"] = {};	
	else
		if (TrinityButtonsSavedState["StowageDock"][1]) then
			TrinityStowedButtons.buttonIndex = TrinityButtonsSavedState["StowageDock"][1];
		end
		if (TrinityButtonsSavedState["StowageDock"][2]) then
			TrinityStowedButtons.buttonCount = TrinityButtonsSavedState["StowageDock"][2];			
		end
	end	
	
	if (TrinitySavedVersion ~= TrinityCurrentVersion and not TrinityFirstRun) then
		TrinityUpgradeVersion()
	end
end

function TrinityMinimapOptionsOnLoad()

	local angle = 90;
	
	for i=1,7 do
	
		local buttonOption = getglobal("TrinityBarsMinimapButtonOption"..i);	
		local x = ((buttonOption:GetWidth()/.8)*.85)*(cos(angle));
		local y = ((buttonOption:GetWidth()/.8)*.85)*(sin(angle));
		buttonOption:SetScale(0.8)
		buttonOption:SetPoint("CENTER", TrinityBarsGlobalMenuAnchor, "CENTER", x, y);						
		angle = angle - (360/7);
		
		if (i==1) then
			buttonOption:SetParent("TrinityBarsMinimapButton");
			buttonOption:SetScript("OnClick", function() TrinityMinimapOptions1() end);			
			buttonOption:SetScript("OnUpdate", function() TrinityMinimapOptionsOnUpdate("Click to toggle configuration mode\nShift-Click to show/hide button tooltips") end);
			getglobal(buttonOption:GetName().."Icon"):SetTexture("Interface\\Addons\\TrinityButtons\\Images\\docks.tga");
			if (TrinityDockBarsHide == true) then
				getglobal(buttonOption:GetName().."Icon"):SetVertexColor(0.2,0.2,0.2);
			else
				getglobal(buttonOption:GetName().."Icon"):SetVertexColor(1,1,1);
			end
		end								
		
		if (i==2) then
			buttonOption:SetParent("TrinityBarsMinimapButton");
			buttonOption:SetScript("OnClick", function() TrinityMinimapOptions2() end);
			buttonOption:SetScript("OnUpdate", function() TrinityMinimapOptionsOnUpdate("Click to lock/unlock action buttons") end);			
			if (TrinityButtonLock == true) then
				getglobal(buttonOption:GetName().."Icon"):SetTexture("Interface\\Addons\\TrinityButtons\\Images\\locked.tga");			
			else
				getglobal(buttonOption:GetName().."Icon"):SetTexture("Interface\\Addons\\TrinityButtons\\Images\\unlocked.tga");
			end
		end
		
		if (i==3) then
			buttonOption:SetParent("TrinityBarsMinimapButton");
			buttonOption:SetScript("OnClick", function() TrinityMinimapOptions3() end);
			buttonOption:SetScript("OnUpdate", function() TrinityMinimapOptionsOnUpdate("Click to choose button style\nShift-Click to enable/disbale cooldown counter") end);
		end
		
		if (i==4) then
			buttonOption:SetParent("TrinityBarsMinimapButton");
			buttonOption:SetScript("OnClick", function() TrinityMinimapOptions4() end);
			buttonOption:SetScript("OnUpdate", function() TrinityMinimapOptionsOnUpdate("Future option for loading/saving templates") end);
			getglobal(buttonOption:GetName().."Icon"):SetTexture("Interface\\Addons\\TrinityButtons\\Images\\unavailable.tga");
		end

		if (i==5) then
			buttonOption:SetParent("TrinityBarsMinimapButton");
			buttonOption:SetScript("OnClick", function() this.click = arg1 TrinityMinimapOptions5(this) end);			
			buttonOption:SetScript("OnUpdate", function() TrinityMinimapOptionsOnUpdate("Left/Right-Click to cycle forward/back through dock frames\nShift-LeftClick to stow/restore the indicated dock frame\nShift-RightClick to stow/restore the buttons of this dock frame\nCtrl-Alt-Click to stow/restore all dock frames") end);
			getglobal(buttonOption:GetName().."Icon"):SetTexture("Interface\\Addons\\TrinityButtons\\Images\\docks.tga");
			getglobal(buttonOption:GetName().."Icon"):SetVertexColor(0,0,0);
			buttonOption.dockID = 1;
			buttonOption:CreateFontString("$parentDockID", "ARTWORK", "GameFontNormal");
			getglobal(buttonOption:GetName().."DockID"):SetText(buttonOption.dockID);
			getglobal(buttonOption:GetName().."DockID"):SetPoint("CENTER",-1,2);
		end
		
		if (i==6) then
			buttonOption:SetParent("TrinityBarsMinimapButton");
			buttonOption:SetScript("OnClick", function() if (IsShiftKeyDown()) then if (TrinityKeyBindingTextHidden == false) then TrinityKeyBindingTextHidden = true else TrinityKeyBindingTextHidden = false end TrinityHideKeyBindings() else TrinityMinimapOptions6() end end);
			buttonOption:SetScript("OnUpdate", function() TrinityMinimapOptionsOnUpdate("Click to enable/disable key binding mode\nShift-Click to hide key bindings") end);
			getglobal(buttonOption:GetName().."Icon"):SetTexture("Interface\\Addons\\TrinityButtons\\Images\\keybindoff.tga");						
		end
		
		if (i==7) then
			buttonOption.option = "None";
			buttonOption:SetParent("TrinityBarsMinimapButton");
			buttonOption:SetScript("OnClick", function() TrinityMinimapOptions7() end);
			buttonOption:SetScript("OnUpdate", function() TrinityMinimapOptionsOnUpdate("Click to cycle through self-cast options") end);
			getglobal(buttonOption:GetName().."Icon"):SetTexture("Interface\\Icons\\Spell_Arcane_ArcanePotency.blp");
			
		end		
	end
end

function TrinityMinimapOptionsOnClick()

	if (this:GetName() == "TrinityBarsMinimapButton") then
		if (TrinityBarsGlobalMenuAnchor:IsVisible()) then
			TrinityBarsGlobalMenuAnchor:Hide();
		else
			TrinityBarsGlobalMenuAnchor:Show();
		end
	end	

	if (IsAltKeyDown() and IsControlKeyDown() and IsShiftKeyDown()) then
		if (InCombatLockdown()) then
			UIErrorsFrame:AddMessage("In Combat Lockdown", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
			return;
		end
		TrinityButtonStyle = 1;
		TrinitySetSelfCast(1);

		TrinityDockBarsHide = false;
		TrinityButtonsHide = false;
		TrinityButtonLock = false;
		TrinityKeyBindingTextHidden = false;
		TrinityShowButtonTooltips = true;
		TrinityDocksStowed = false;
		
		TrinityBarsGlobalMenuAnchor:ClearAllPoints();
		TrinityBarsGlobalMenuAnchor:SetPoint("CENTER", "TrinityBarsMinimapButton", "CENTER")
		TrinityBarsGlobalMenuAnchor:SetUserPlaced(false);
		TrinityBarsGlobalMenuAnchor.drag = false;		
		TrinityUpdateDockPostions(true);							
		TrinityUpdateDocking();
		TrinityUpdateDockingAfterEvent()
		TrinityUpdateDockPostions(true);
		TrinityUpdateBindings();
		TrinityRefreshHeaders();
		return;
	end
	
	if (IsShiftKeyDown()) then
	
		local x1,y1 = TrinityBarsMinimapButton:GetCenter()
		local x2,y2 = TrinityBarsGlobalMenuAnchor:GetCenter()
		local width = TrinityBarsGlobalMenuAnchor:GetWidth()
	
		if ((x2 < x1-width or x2 > x1+width) and (y2 < y1-width or y2 > y1+width)) then				
			TrinityBarsGlobalMenuAnchor:Show();			
			TrinityBarsGlobalMenuAnchor:ClearAllPoints();
			TrinityBarsGlobalMenuAnchor:SetPoint("CENTER", "TrinityBarsMinimapButton", "CENTER")
			TrinityBarsGlobalMenuAnchor:SetUserPlaced(false);
			TrinityBarsGlobalMenuAnchor.drag = false;		
		
			for i=1,7 do	
				local buttonOption = getglobal("TrinityBarsMinimapButtonOption"..i);	
				buttonOption:Show()
			end
		end
		
		return;
	end
	
	for i=1,7 do	
		local buttonOption = getglobal("TrinityBarsMinimapButtonOption"..i);	
		if (buttonOption:IsVisible()) then
			buttonOption:Hide();
		else
			if (TrinityBarsGlobalMenuAnchor:IsVisible()) then
				buttonOption:Show()
			end
		end
	end	

end

function TrinityMinimapOptionsOnEnter(text)

	TrinityActionButton_SetTooltip()			
	GameTooltip:SetText(text, 1.0, 1.0, 1.0);
	GameTooltip:Show();
end

function TrinityMinimapOptionsOnUpdate(text)

	if (MouseIsOver(this)) then
		TrinityActionButton_SetTooltip()			
		GameTooltip:SetText(text, 1.0, 1.0, 1.0);
		
		if (this:GetID() == 1) then
			if (TrinityDockBarsHide) then
				GameTooltip:AddLine("Configuration mode is |cff00ff00OFF|r");
			else
				GameTooltip:AddLine("Configuration mode is |cfff00000ON|r");
			end
			
			if(TrinityShowButtonTooltips) then
				GameTooltip:AddLine("Action button tooltips are |cff00ff00ENABLED|r");
			else
				GameTooltip:AddLine("Action button tooltips are |cfff00000DISABLED|r");
			end			
		end		

		if (this:GetID() == 2) then
			if (TrinityButtonLock) then
				GameTooltip:AddLine("Action buttons are currently |cff00ff00LOCKED|r");
			else
				GameTooltip:AddLine("Action buttons are currently |cfff00000UNLOCKED|r");
			end
		end
		
		if (this:GetID() == 3) then
			if (TrinityButtonStyle == 1) then
				GameTooltip:AddLine("Current global button style is |cff00ff00SQUARE|r");		
			elseif (TrinityButtonStyle == 2) then
				GameTooltip:AddLine("Current global button style is |cff00ff00ROUND|r");		
			elseif (TrinityButtonStyle == 3) then
				GameTooltip:AddLine("Current global button style is |cff00ff00SQUARE-TRIMMED|r");		
			end
			if (TrinityCoolDown) then
				GameTooltip:AddLine("Cooldown Counter is |cff00ff00ENABLED|r");
			else
				GameTooltip:AddLine("Cooldown Counter is |cfff00000DISABLED|r");
			end
		end
		
		if (this:GetID() == 4) then

		end		
		
		if (this:GetID() == 5) then
		
			local dockID = this.dockID;
			
			if (dockID == TrinityMiscBars["bags"]) then		
				dockID = "Bags"
			elseif (dockID == TrinityMiscBars["menu"]) then
				dockID = "MenuBar"
			elseif (dockID == TrinityMiscBars["pet"]) then
				dockID = "PetBar"
			elseif (dockID == TrinityMiscBars["form"]) then
				dockID = "FormBar"
			elseif (dockID == TrinityMiscBars["cast"]) then
				dockID = "CastBar"
			end							
		
			if (getglobal("TrinityDockFrame"..this.dockID).config["stowed"] == true) then
				GameTooltip:AddLine("Dock frame "..dockID.." is |cff00ff00STOWED|r");
			end
			if (getglobal("TrinityDockFrame"..this.dockID).config["stowed"] == false) then
				GameTooltip:AddLine("Dock frame "..dockID.." is |cfff00000NOT STOWED|r");
			end
			if (getglobal("TrinityDockFrame"..this.dockID).config["stowbuttons"] == true) then
				GameTooltip:AddLine("Buttons for dock frame "..dockID.." are |cff00ff00STOWED|r");
			end
			if (getglobal("TrinityDockFrame"..this.dockID).config["stowbuttons"] == false) then
				GameTooltip:AddLine("Buttons for dock frame "..dockID.." are |cfff00000NOT STOWED|r");
			end			
		end

		if (this:GetID() == 6) then
			if (TrinityKeyBinder:IsVisible()) then
				GameTooltip:AddLine("Key binding mode is |cfff00000ON|r");
			else
				GameTooltip:AddLine("Key binding mode is |cff00ff00OFF|r");
			end
			if (TrinityKeyBindingTextHidden) then
				GameTooltip:AddLine("Key bind text is |cfff00000HIDDEN|r");
			else
				GameTooltip:AddLine("Key bind text is |cff00ff00SHOWN|r");
			end						
		end
		
		if (this:GetID() == 7) then
			GameTooltip:AddLine("Current self-cast option is set to |cff00ff00"..this.option.."|r");
		end		
			
		GameTooltip:Show();
	end
end

function TrinityMinimapOptions1()	

	if (InCombatLockdown()) then
		UIErrorsFrame:AddMessage("In Combat Lockdown", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
		return;
	end							
	
	if (IsShiftKeyDown()) then
		if (TrinityShowButtonTooltips == true) then
			TrinityShowButtonTooltips = false;
			UIErrorsFrame:AddMessage("Action Button tooltips are disabled", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
		else
			TrinityShowButtonTooltips = true;
			UIErrorsFrame:AddMessage("Action Button tooltips are enabled", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
		end
		return;
	end
	
	if (TrinityDockBarsHide) then
		TrinityDockBarsHide = false;								
		TrinityButtonsHide = false;
		getglobal(this:GetName().."Icon"):SetVertexColor(1,1,1);
		if (TrinityTooltipDock) then
			if (not TrinityTooltipDock:IsVisible()) then
				TrinityTooltipDock:Show();
			end
		end								
	else
		TrinityDockBarsHide = true;
		TrinityButtonsHide = true;
		getglobal(this:GetName().."Icon"):SetVertexColor(0.2,0.2,0.2);
		if (TrinityTooltipDock) then
			if (TrinityTooltipDock:IsVisible()) then
				TrinityTooltipDock:Hide();
			end
		end				
	end							
	
	PlaySound("igChatScrollDown");
	TrinityUpdateDocking();
end

function TrinityMinimapOptions2()

	if (TrinityButtonLock) then
		TrinityButtonLock = false;
		UIErrorsFrame:AddMessage("Buttons are unlocked", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);		
		getglobal(this:GetName().."Icon"):SetTexture("Interface\\Addons\\TrinityButtons\\Images\\unlocked.tga");
	else
		TrinityButtonLock = true;
		UIErrorsFrame:AddMessage("Buttons are locked", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);		
		getglobal(this:GetName().."Icon"):SetTexture("Interface\\Addons\\TrinityButtons\\Images\\locked.tga");
	end
end

function TrinityMinimapOptions3()

	if (IsShiftKeyDown()) then
		if (TrinityCoolDown) then
			TrinityCoolDown = false;
		else
			TrinityCoolDown = true;
		end
		return;
	end

	if (TrinityButtonStyle == 1) then	
		TrinityButtonStyle = 2;				
	elseif (TrinityButtonStyle == 2) then	
		TrinityButtonStyle = 3;		
	elseif (TrinityButtonStyle == 3) then	
		TrinityButtonStyle = 1;		
	end	
	
	for i=1,TrinityDockFrames do	
		local dockFrame = getglobal("TrinityDockFrame"..i);		
		dockFrame.config["style"] = TrinityButtonStyle;
		TrinitySwapTextures(dockFrame);
	end
end

function TrinityMinimapOptions4()
	
end

function TrinityMinimapOptions5(button)

	if (not TrinityDockBarsHide) then

		local dockID;
		local dockFrame = getglobal("TrinityDockFrame"..button.dockID);

		if (IsAltKeyDown() and IsControlKeyDown()) then
			if (TrinityDocksStowed) then
				for i=1, TrinityDockFrames do		
					getglobal("TrinityDockFrame"..i).config["stowed"] = false;
					if (not TrinityDockBarsHide) then
						getglobal("TrinityDockFrame"..i):Show();
					end
					TrinityHideDocksButtons(getglobal("TrinityDockFrame"..i):GetID(), getglobal("TrinityDockFrame"..i):GetID())
				end
				TrinityDocksStowed = false;				
				UIErrorsFrame:AddMessage("All docks have been restored", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);		
			else
				for i=1, TrinityDockFrames do
					getglobal("TrinityDockFrame"..i).config["stowed"] = true;
					getglobal("TrinityDockFrame"..i):Hide();
					if (getglobal("TrinityProwlOption"..getglobal("TrinityDockFrame"..i):GetID()) and UnitClass("player") == TRINITY_DRUID) then
						getglobal("TrinityProwlOption"..getglobal("TrinityDockFrame"..i):GetID()):SetAttribute("showstates", "NOSHOW");					
					end
					getglobal("TrinityHybridOption"..getglobal("TrinityDockFrame"..i):GetID()):SetAttribute("showstates", "NOSHOW");			
					TrinityHideDocksButtons(getglobal("TrinityDockFrame"..i):GetID(), getglobal("TrinityDockFrame"..i):GetID())
				end
				UIErrorsFrame:AddMessage("All docks have been stowed", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);		
				TrinityDocksStowed = true;
			end		
			return;
		end			

		if (IsShiftKeyDown()) then

			if (button.click == "LeftButton") then
				if (dockFrame.config["stowed"] == false) then
					dockFrame.config["stowed"] = true;
					dockFrame:Hide();
					if (getglobal("TrinityProwlOption"..dockFrame:GetID()) and UnitClass("player") == TRINITY_DRUID) then
						getglobal("TrinityProwlOption"..dockFrame:GetID()):SetAttribute("showstates", "NOSHOW");					
					end
					getglobal("TrinityHybridOption"..dockFrame:GetID()):SetAttribute("showstates", "NOSHOW");
				else
					dockFrame.config["stowed"] = false;
					if (not TrinityDockBarsHide) then
						dockFrame:Show();
					end
				end
			else				
				for i=0,9 do
					local buttonList = {};	
					string.gsub(dockFrame.buttonList[i], "%d+", function (btn) table.insert(buttonList, btn) end);
					for k,v in pairs (buttonList) do
						if (getglobal("TrinityActionButton"..v):GetAttribute("showstates") == "STOWED") then							
							getglobal("TrinityActionButton"..v):SetAttribute("showstates", getglobal("TrinityActionButton"..v).laststate);							
							getglobal("TrinityActionButton"..v).laststate = "STOWED";							
							dockFrame.config["stowbuttons"] = false;
						else							
							getglobal("TrinityActionButton"..v).laststate = getglobal("TrinityActionButton"..v):GetAttribute("showstates");														
							getglobal("TrinityActionButton"..v):SetAttribute("showstates", "STOWED");							
							dockFrame.config["stowbuttons"] = true;
						end
					end
				end					
			end
			TrinityHideDocksButtons(dockFrame:GetID(), dockFrame:GetID())
			return;
		end

		dockFrame.adjusting = false;
		for i=1,TrinityDockFrames do
			getglobal("TrinityDockFrame"..i):SetBackdropColor(0, 0, 0, 0.25);
			getglobal("TrinityDockFrame"..i):SetFrameStrata("LOW");
			getglobal("TrinityDockFrame"..i).selected = false;
		end
		TrinityHideDocksButtons(dockFrame:GetID(), dockFrame:GetID())

		if (button.click == "LeftButton") then
			button.dockID = button.dockID + 1;
			if (button.dockID > TrinityDockFrames) then
				button.dockID = 1;
			end
		else
			button.dockID = button.dockID - 1;
			if (button.dockID <= 0) then
				button.dockID = TrinityDockFrames;
			end
		end
		
		getglobal("TrinityDockFrame"..button.dockID):SetBackdropColor(0, 0, 0, 0.5);
		getglobal("TrinityDockFrame"..button.dockID):SetFrameStrata("MEDIUM");
		getglobal("TrinityDockFrame"..button.dockID):Show();
		getglobal("TrinityDockFrame"..button.dockID).adjusting = true;		
		getglobal("TrinityDockFrame"..button.dockID).selected = true;
		getglobal("TrinityDockFrame"..button.dockID):EnableKeyboard(false)

		if (button.dockID == TrinityMiscBars["bags"]) then		
			dockID = "B"
		elseif (button.dockID == TrinityMiscBars["menu"]) then
			dockID = "M"
		elseif (button.dockID == TrinityMiscBars["pet"]) then
			dockID = "P"
		elseif (button.dockID == TrinityMiscBars["form"]) then
			dockID = "F"
		elseif (button.dockID == TrinityMiscBars["cast"]) then
			dockID = "C"
		else
			dockID = button.dockID;
		end

		getglobal(button:GetName().."DockID"):SetText(dockID);
		
	else
		UIErrorsFrame:AddMessage("Must be in configuration mode", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);		
	end
end

function TrinityMinimapOptions6()

	if (InCombatLockdown()) then
		UIErrorsFrame:AddMessage("In Combat Lockdown", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
		return;
	end
	if (TrinityKeyBinder:IsVisible()) then
		TrinityKeyBinder:EnableKeyboard(false);						
		TrinityKeyBinder:Hide();		
		getglobal(this:GetName().."Icon"):SetTexture("Interface\\Addons\\TrinityButtons\\Images\\keybindoff.tga");			
	else
		TrinityKeyBinder:EnableKeyboard(false);						
		TrinityKeyBinder:Show();		
		getglobal(this:GetName().."Icon"):SetTexture("Interface\\Addons\\TrinityButtons\\Images\\keybindon.tga");			
	end
end

function TrinityMinimapOptions7()

	if (TrinitySelfCastOption == 1) then	
		TrinitySelfCastOption = 2;		
		TrinitySetSelfCast(TrinitySelfCastOption);
	elseif (TrinitySelfCastOption == 2) then	
		TrinitySelfCastOption = 3;				
		TrinitySetSelfCast(TrinitySelfCastOption);
	elseif (TrinitySelfCastOption == 3) then	
		TrinitySelfCastOption = 4;				
		TrinitySetSelfCast(TrinitySelfCastOption);
	elseif (TrinitySelfCastOption == 4) then	
		TrinitySelfCastOption = 5;				
		TrinitySetSelfCast(TrinitySelfCastOption);
	elseif (TrinitySelfCastOption == 5) then	
		TrinitySelfCastOption = 6;				
		TrinitySetSelfCast(TrinitySelfCastOption);
	elseif (TrinitySelfCastOption == 6) then	
		TrinitySelfCastOption = 7;				
		TrinitySetSelfCast(TrinitySelfCastOption);
	elseif (TrinitySelfCastOption == 7) then	
		TrinitySelfCastOption = 8;				
		TrinitySetSelfCast(TrinitySelfCastOption);
	elseif (TrinitySelfCastOption == 8) then	
		TrinitySelfCastOption = 1;				
		TrinitySetSelfCast(TrinitySelfCastOption);		
	end
	
	UIErrorsFrame:AddMessage("Self-Cast option set to |cff00ff00"..TrinityBarsMinimapButtonOption7.option.."|r", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);												
end

function TrinitySetSelfCast(option)

	TrinityBarsMinimapButtonOption7.option = "None"	

	if (option == 1 or option ~= 2) then
		TrinityStanceButtons:SetAttribute("unit2", nil);
		TrinityPagedButtons:SetAttribute("unit2", nil);
		TrinityHybridStanceButtons:SetAttribute("unit2", nil);
		TrinityHybridPagedButtons:SetAttribute("unit2", nil);		
		TrinityNormalButtons:SetAttribute("unit2", nil);
	end
		
	if (option == 2) then
		TrinityStanceButtons:SetAttribute("unit2", "player");
		TrinityPagedButtons:SetAttribute("unit2", "player");
		TrinityHybridStanceButtons:SetAttribute("unit2", "player");
		TrinityHybridPagedButtons:SetAttribute("unit2", "player");		
		TrinityNormalButtons:SetAttribute("unit2", "player");		
		TrinityBarsMinimapButtonOption7.option = "RightClick"
	end
		
	if (option == 1 or option ~= 3) then		
		TrinityStanceButtons:SetAttribute("alt-unit1", nil);
		TrinityPagedButtons:SetAttribute("alt-unit1", nil);
		TrinityHybridStanceButtons:SetAttribute("alt-unit1", nil);
		TrinityHybridPagedButtons:SetAttribute("alt-unit1", nil);		
		TrinityNormalButtons:SetAttribute("alt-unit1", nil);
	end
		
	if (option ==3) then
		TrinityStanceButtons:SetAttribute("alt-unit1", "player");
		TrinityPagedButtons:SetAttribute("alt-unit1", "player");
		TrinityHybridStanceButtons:SetAttribute("alt-unit1", "player");
		TrinityHybridPagedButtons:SetAttribute("alt-unit1", "player");		
		TrinityNormalButtons:SetAttribute("alt-unit1", "player");		
		TrinityBarsMinimapButtonOption7.option = "Alt-LeftClick"
	end
	
	if (option == 1 or option ~= 4) then		
		TrinityStanceButtons:SetAttribute("alt-unit2", nil);
		TrinityPagedButtons:SetAttribute("alt-unit2", nil);
		TrinityHybridStanceButtons:SetAttribute("alt-unit2", nil);
		TrinityHybridPagedButtons:SetAttribute("alt-unit2", nil);		
		TrinityNormalButtons:SetAttribute("alt-unit2", nil);		
	end
		
	if (option ==4) then
		TrinityStanceButtons:SetAttribute("alt-unit2", "player");
		TrinityPagedButtons:SetAttribute("alt-unit2", "player");
		TrinityHybridStanceButtons:SetAttribute("alt-unit2", "player");
		TrinityHybridPagedButtons:SetAttribute("alt-unit2", "player");		
		TrinityNormalButtons:SetAttribute("alt-unit2", "player");		
		TrinityBarsMinimapButtonOption7.option = "Alt-RightClick"
	end	
		
	if (option == 1 or option ~= 5) then		
		TrinityStanceButtons:SetAttribute("ctrl-unit1", nil);
		TrinityPagedButtons:SetAttribute("ctrl-unit1", nil);
		TrinityHybridStanceButtons:SetAttribute("ctrl-unit1", nil);
		TrinityHybridPagedButtons:SetAttribute("ctrl-unit1", nil);		
		TrinityNormalButtons:SetAttribute("ctrl-unit1", nil);
	end
	
	if (option == 5) then	
		TrinityStanceButtons:SetAttribute("ctrl-unit1", "player");
		TrinityPagedButtons:SetAttribute("ctrl-unit1", "player");
		TrinityHybridStanceButtons:SetAttribute("ctrl-unit1", "player");
		TrinityHybridPagedButtons:SetAttribute("ctrl-unit1", "player");		
		TrinityNormalButtons:SetAttribute("ctrl-unit1", "player");		
		TrinityBarsMinimapButtonOption7.option = "Ctrl-LeftClick"
	end
	
	if (option == 1 or option ~= 6) then		
		TrinityStanceButtons:SetAttribute("ctrl-unit2", nil);
		TrinityPagedButtons:SetAttribute("ctrl-unit2", nil);
		TrinityHybridStanceButtons:SetAttribute("ctrl-unit2", nil);
		TrinityHybridPagedButtons:SetAttribute("ctrl-unit2", nil);		
		TrinityNormalButtons:SetAttribute("ctrl-unit2", nil);
	end
	
	if (option == 6) then	
		TrinityStanceButtons:SetAttribute("ctrl-unit2", "player");
		TrinityPagedButtons:SetAttribute("ctrl-unit2", "player");
		TrinityHybridStanceButtons:SetAttribute("ctrl-unit2", "player");
		TrinityHybridPagedButtons:SetAttribute("ctrl-unit2", "player");		
		TrinityNormalButtons:SetAttribute("ctrl-unit2", "player");		
		TrinityBarsMinimapButtonOption7.option = "Ctrl-RightClick"
	end	

	if (option == 1 or option ~= 7) then		
		TrinityStanceButtons:SetAttribute("shift-unit1", nil);
		TrinityPagedButtons:SetAttribute("shift-unit1", nil);
		TrinityHybridStanceButtons:SetAttribute("shift-unit1", nil);
		TrinityHybridPagedButtons:SetAttribute("shift-unit1", nil);		
		TrinityNormalButtons:SetAttribute("shift-unit1", nil);
	end
		
	if (option == 7) then		
		TrinityStanceButtons:SetAttribute("shift-unit1", "player");
		TrinityPagedButtons:SetAttribute("shift-unit1", "player");
		TrinityHybridStanceButtons:SetAttribute("shift-unit1", "player");
		TrinityHybridPagedButtons:SetAttribute("shift-unit1", "player");		
		TrinityNormalButtons:SetAttribute("shift-unit1", "player");				
		TrinityBarsMinimapButtonOption7.option = "Shift-LeftClick"
	end
	
	if (option == 1 or option ~= 8) then		
		TrinityStanceButtons:SetAttribute("shift-unit2", nil);
		TrinityPagedButtons:SetAttribute("shift-unit2", nil);
		TrinityHybridStanceButtons:SetAttribute("shift-unit2", nil);
		TrinityHybridPagedButtons:SetAttribute("shift-unit2", nil);		
		TrinityNormalButtons:SetAttribute("shift-unit2", nil);
	end
		
	if (option == 8) then		
		TrinityStanceButtons:SetAttribute("shift-unit2", "player");
		TrinityPagedButtons:SetAttribute("shift-unit2", "player");
		TrinityHybridStanceButtons:SetAttribute("shift-unit2", "player");
		TrinityHybridPagedButtons:SetAttribute("shift-unit2", "player");		
		TrinityNormalButtons:SetAttribute("shift-unit2", "player");				
		TrinityBarsMinimapButtonOption7.option = "Shift-RightClick"
	end
	
	return;
end

function TrinityHideKeyBindings()
	if (TrinityKeyBindingTextHidden == true) then
		for i=1,120 do
			getglobal("TrinityActionButton"..i.."HotKey"):Hide();
			getglobal("TrinityActionButton"..i.."HotKeyRound"):Hide();
			
		end
		for i=1,10 do		
			getglobal("ShapeshiftButton"..i.."HotKey"):Hide();			
			getglobal("ShapeshiftButton"..i.."HotKeyRound"):Hide();			
		end
		
	else
		for i=1,120 do
			if (getglobal("TrinityDockFrame"..getglobal("TrinityActionButton"..i).dock).config["style"] == 2) then
				getglobal("TrinityActionButton"..i.."HotKeyRound"):Show();
			else
				getglobal("TrinityActionButton"..i.."HotKey"):Show();
			end		
		end
		for i=1,10 do		
			if (getglobal("TrinityDockFrame"..getglobal("TrinityActionButton"..i+143).dock).config["style"] == 2) then		
				getglobal("ShapeshiftButton"..i.."HotKeyRound"):Show();			
			else
				getglobal("ShapeshiftButton"..i.."HotKey"):Show();			
			end
		end		
	end	
end

function TrinityActionButton_SetTooltip()
	if ( GetCVar("UberTooltips") == "1" ) then
		GameTooltip_SetDefaultAnchor(GameTooltip, this);
	else
		GameTooltip:SetOwner(this, "ANCHOR_RIGHT");		
	end
	
	if ( GameTooltip:SetAction(this:GetID()) ) then
		this.updateTooltip = TOOLTIP_UPDATE_TIME;
	else
		this.updateTooltip = nil;
	end
end

function TrinityGlobalMenuCheck(frame)

	local x1,y1 = TrinityBarsMinimapButton:GetCenter()
	local x2,y2 = frame:GetCenter()
	local width = frame:GetWidth()/2
	
	if (x2 > x1-width and x2 < x1+width and y2 > y1-width and y2 < y1+width) then		
		frame:StopMovingOrSizing();		
		frame:ClearAllPoints();
		frame:SetPoint("CENTER", "TrinityBarsMinimapButton", "CENTER")
		frame:SetUserPlaced(false);
		frame.drag = false;
	end
end

-- Blizzard functions hooked and modified

local SavedUpdateTalentButton = UpdateTalentButton;
function TrinityUpdateTalentButton()

	if ( UnitLevel("player") < 10 ) then
		TalentMicroButton:Hide();
	else	
		TalentMicroButton:Show();		
	end
end
UpdateTalentButton = TrinityUpdateTalentButton;

local SavedShapeshiftBar_UpdateState = ShapeshiftBar_UpdateState;
function TrinityShapeshiftBar_UpdateState()

	local numForms = GetNumShapeshiftForms();
	for i=1, NUM_SHAPESHIFT_SLOTS do
		button = getglobal("ShapeshiftButton"..i);
		icon = getglobal("ShapeshiftButton"..i.."Icon");
		if ( i <= numForms ) then
			texture, name, isActive, isCastable = GetShapeshiftFormInfo(i);
			icon:SetTexture(texture);		
			icon:SetTexCoord(0,1,0,1);
			if (getglobal("TrinityDockFrame"..TrinityMiscBars["form"]).config["style"] == 3) then
				icon:SetTexCoord(0.08,0.92,0.08,0.92);
			end
			
			cooldown = getglobal("ShapeshiftButton"..i.."Cooldown");
			
			if (getglobal("TrinityDockFrame"..TrinityMiscBars["form"]).config["style"] == 1) then
				--Cooldown stuffs				
				if ( texture ) then
					cooldown:Show();
				else
					cooldown:Hide();
				end		
			end

			start, duration, enable = GetShapeshiftFormCooldown(i);
			CooldownFrame_SetTimer(cooldown, start, duration, enable);
			
			if ( isActive ) then
				ShapeshiftBarFrame.lastSelected = button:GetID();
				button:SetChecked(1);
			else
				button:SetChecked(0);
			end

			if ( isCastable ) then
				icon:SetVertexColor(1.0, 1.0, 1.0);
			else
				icon:SetVertexColor(0.4, 0.4, 0.4);
			end
		end
	end
end
ShapeshiftBar_UpdateState = TrinityShapeshiftBar_UpdateState;


SavedCastingBarFrame_OnUpdate = CastingBarFrame_OnUpdate;
function TrinityCastingBarFrame_OnUpdate()

	local barSpark = getglobal(this:GetName().."Spark");
	local barFlash = getglobal(this:GetName().."Flash");
	local barText = getglobal(this:GetName().."Text");			

	local timeLeft = nil;
	if ( this.casting ) then
		timeLeft = this.maxValue - this:GetValue();
	
	elseif ( this.channeling ) then
		timeLeft = this.duration + this:GetValue() - this.endTime;
	
	end
	
	-- Castin bar timer code thanks to Luinil of Suramar server	
	if ( timeLeft ) then	--	
		timeleft = (timeLeft < 0.1) and 0.01 or timeLeft;
		local displayName = TrinityCastingBarTimer.castingInfo[this.unit];
		if not ( displayName ) then
			local _, text;
			if ( this.casting ) then
				_, _, text = UnitCastingInfo(this.unit);
			elseif ( this.channeling ) then
				_, _, text = UnitChannelInfo(this.unit);
			end
			if ( text ) then
				displayName = text.." - %0.1fs";
				TrinityCastingBarTimer.castingInfo[this.unit] = displayName;
			else
				displayName = (barText:GetText() or "").." - %0.1fs";
			end
		end
		barText:SetText( format(displayName, timeLeft) );
		if (this:GetOrientation() == "VERTICAL") then
			barText:SetText(string.gsub(barText:GetText(), ".", "%1\n"))
		end				
	end		

	if ( this.casting ) then
		local status = GetTime();
		if ( status > this.maxValue ) then
			status = this.maxValue;
		end
		if ( status == this.maxValue ) then
			this:SetValue(this.maxValue);
			CastingBarFrame_FinishSpell(barSpark, barFlash);
			return;
		end
		this:SetValue(status);
		if ( barFlash ) then
			barFlash:Hide();
		end
		if (this:GetName() == "TrinityCastingBar") then
			if (getglobal("TrinityDockFrame"..TrinityMiscBars["cast"]).config["shape"] == 1) then			
				local sparkPosition = ((status - this.startTime) / (this.maxValue - this.startTime)) * this:GetParent():GetHeight();
				if ( sparkPosition < 0 ) then
					sparkPosition = 0;
				end		
				if ( barSpark ) then
					barSpark:SetPoint("CENTER", this, "BOTTOM", 0, sparkPosition);
				end			
		
			else
				local sparkPosition = ((status - this.startTime) / (this.maxValue - this.startTime)) * this:GetParent():GetWidth();
				if ( sparkPosition < 0 ) then
					sparkPosition = 0;
				end
				if ( barSpark ) then
					barSpark:SetPoint("CENTER", this, "LEFT", sparkPosition, 2);
				end			
			end
		else
			local sparkPosition = ((status - this.startTime) / (this.maxValue - this.startTime)) * this:GetWidth();
			if ( sparkPosition < 0 ) then
				sparkPosition = 0;
			end
			if ( barSpark ) then
				barSpark:SetPoint("CENTER", this, "LEFT", sparkPosition, 2);
			end
		end

	elseif ( this.channeling ) then
		local time = GetTime();
		if ( time > this.endTime ) then
			time = this.endTime;
		end
		if ( time == this.endTime ) then
			CastingBarFrame_FinishSpell(barSpark, barFlash);
			return;
		end
		local barValue = this.startTime + (this.endTime - time);
		this:SetValue( barValue );
		if ( barFlash ) then
			barFlash:Hide();
		end
	elseif ( GetTime() < this.holdTime ) then
		return;
	elseif ( this.flash ) then
		local alpha = 0;
		if ( barFlash ) then
			alpha = barFlash:GetAlpha() + CASTING_BAR_FLASH_STEP;
		end
		if ( alpha < 1 ) then
			if ( barFlash ) then
				barFlash:SetAlpha(alpha);
			end
		else
			if ( barFlash ) then
				barFlash:SetAlpha(1.0);
			end
			this.flash = nil;
		end
	elseif ( this.fadeOut ) then
		local alpha = this:GetAlpha() - CASTING_BAR_ALPHA_STEP;
		if ( alpha > 0 ) then
			this:SetAlpha(alpha);
		else
			this.fadeOut = nil;
			this:Hide();
		end
	end
end
CastingBarFrame_OnUpdate = TrinityCastingBarFrame_OnUpdate;

SavedMainMenuBar_UpdateKeyRing = MainMenuBar_UpdateKeyRing
function TrinityMainMenuBar_UpdateKeyRing()

	if ( SHOW_KEYRING == 1 ) then
		MainMenuBarTexture3:SetTexture("Interface\\MainMenuBar\\UI-MainMenuBar-KeyRing");
		MainMenuBarTexture3:SetTexCoord(0, 1, 0.1640625, 0.5);
		MainMenuBarTexture2:SetTexture("Interface\\MainMenuBar\\UI-MainMenuBar-KeyRing");
		MainMenuBarTexture2:SetTexCoord(0, 1, 0.6640625, 1);		
		KeyRingButton:Show();
	end
end
MainMenuBar_UpdateKeyRing = TrinityMainMenuBar_UpdateKeyRing;

SavedPetActionBarFrame_OnUpdate = PetActionBarFrame_OnUpdate;
function TrinityPetActionBarFrame_OnUpdate(elapsed)
	--do nothing!
end
PetActionBarFrame_OnUpdate = TrinityPetActionBarFrame_OnUpdate

-- Blizzard functions hooked using secure hook method.

function TrinityPetActionBar_Update()

	if (TrinityPlayerEnteredWorld) then
		for i=1, NUM_PET_ACTION_SLOTS, 1 do
			petActionButton = getglobal("PetActionButton"..i);
			petActionButtonIcon = getglobal("PetActionButton"..i.."Icon");
			petAutoCastableTexture = getglobal("PetActionButton"..i.."AutoCastable");
			petAutoCastModel = getglobal("PetActionButton"..i.."AutoCast");
			local name, subtext, texture, isToken, isActive, autoCastAllowed, autoCastEnabled = GetPetActionInfo(i);
			if (getglobal("TrinityDockFrame"..TrinityMiscBars["pet"]).config["style"] == 1 or
			    getglobal("TrinityDockFrame"..TrinityMiscBars["pet"]).config["style"] == 3) then
				if ( autoCastAllowed ) then
					petAutoCastableTexture:Show();
				else
					petAutoCastableTexture:Hide();
				end
				if ( autoCastEnabled ) then
					petAutoCastModel:Show();
				else
					petAutoCastModel:Hide();				
				end				
			elseif (getglobal("TrinityDockFrame"..TrinityMiscBars["pet"]).config["style"] == 2 and autoCastEnabled) then					
				petAutoCastableTexture:Hide();
				petAutoCastModel:Hide();	
			else
				petAutoCastableTexture:Hide();
				petAutoCastModel:Hide();				
			end

			petActionButtonIcon:SetTexCoord(0,1,0,1);

			if ( texture ) then
				if (getglobal("TrinityDockFrame"..TrinityMiscBars["pet"]).config["style"] == 1) then
					petActionButton:SetNormalTexture("Interface\\Buttons\\UI-Quickslot2");
				elseif (getglobal("TrinityDockFrame"..TrinityMiscBars["pet"]).config["style"] == 2) then
					petActionButton:SetNormalTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButton.tga");
				end
			else
				if (getglobal("TrinityDockFrame"..TrinityMiscBars["pet"]).config["style"] == 1 or getglobal("TrinityDockFrame"..TrinityMiscBars["pet"]).config["style"] == 3) then
					petActionButton:SetNormalTexture("Interface\\Buttons\\UI-Quickslot");
				else
					petActionButton:SetNormalTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButton.tga");				
				end
			end

			if (getglobal("TrinityDockFrame"..TrinityMiscBars["pet"]).config["style"] == 3) then
				petActionButtonIcon:SetTexCoord(0.08,0.92,0.08,0.92);
			end		
		end
	end
end

function TrinityPetButtonOnUpdate(elapsed)

	local autocast = getglobal(this:GetName().."AutoCastSim");
	local _, _, _, _, _, _, autoCastEnabled = GetPetActionInfo(this:GetID());	

	if (getglobal("TrinityDockFrame"..TrinityMiscBars["pet"]).config["style"] == 2 and autoCastEnabled) then
	
		local dockFrame = getglobal("TrinityDockFrame"..TrinityMiscBars["pet"])
	
		if (not dockFrame.dir) then
			dockFrame.dir = 0;
		end

		if (not dockFrame.roundtimer) then
			dockFrame.roundtimer = 0;
		else
			dockFrame.roundtimer = dockFrame.roundtimer + elapsed;
		end	
		
		if (dockFrame.dir == 1) then
			if ((1-(dockFrame.roundtimer/2)) >= 0) then
				autocast:SetAlpha(1-(dockFrame.roundtimer/2));		
			end
			if ((1-(dockFrame.roundtimer/2)) <= 0) then
				dockFrame.dir = 0;
				dockFrame.roundtimer = 0;
			end
		elseif (dockFrame.dir == 0) then
			if ((dockFrame.roundtimer/2) <= 1) then
				autocast:SetAlpha((dockFrame.roundtimer/2));		
			end
			if ((dockFrame.roundtimer/2) >= 1) then
				dockFrame.dir = 1;
				dockFrame.roundtimer = 0;
			end
		end
	else
		autocast:SetAlpha(0);		
	end
end

function TrinityCastingBarFrame_OnEvent(newevent, newarg1)



end

function TrinityShapeshiftBar_UpdatePosition()

	if (getglobal("TrinityDockFrame"..TrinityMiscBars["form"]).config["style"] == 2) then
		for i=1, GetNumShapeshiftForms() do
			getglobal("ShapeshiftButton"..i.."NormalTexture"):SetWidth(32);
			getglobal("ShapeshiftButton"..i.."NormalTexture"):SetHeight(32);
		end

	end
end

function TrinityUIParent_ManageFramePositions()

	if (getglobal("TrinityDockFrame"..TrinityMiscBars["form"]).config["style"] == 2) then
		for i=1, GetNumShapeshiftForms() do
			getglobal("ShapeshiftButton"..i.."NormalTexture"):SetWidth(32);
			getglobal("ShapeshiftButton"..i.."NormalTexture"):SetHeight(32);

		end	
	end
end